unit IAeverMenu2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,IAmouseTimer2,IAMenuContent,
  extctrls,Math;

const
  CM_Opening =cm_Base+102;  
  CM_Closing =cm_Base+103;
  CM_UP = cm_Base+104;
  CM_Down = cm_Base+105;
  //---Begin of menu list constants-------
  mtSgap              = 4;
  mtSUpLeftgap        = 2;
  mtSBottomRightgap   = 2;
  mtSBartoRectgap     = 4;
  mtSRecttoControlgap = 4;
  mtSControlSize      = 16;
  mtSTexttoBMP        = 8;
  mtSTexttoSub        = 8;
  mtSItemGap          = 2;
  mtSBarTexttoBMP     = 8;
  mtSBargap           = 2;
  //--
  mtEgap              = 8;
  mtEUpLeftgap        = 4;
  mtEBottomRightgap   = 4;
  mtEBartoRectgap     = 8;
  mtERecttoControlgap = 8;
  mtEControlSize      = 24;
  mtETexttoBMP        = 16;
  mtETexttoSub        = 16;
  mtEItemGap          = 4;
  mtEBarTexttoBMP     = 16;
  mtEBargap           = 4;
  //--
  mtRgap              = 4;
  mtRUpLeftgap        = 0;
  mtRBottomRightgap   = 0;
  mtRBartoRectgap     = 4;
  mtRRecttoControlgap = 4;
  mtRControlSize      = 16;
  mtRTexttoBMP        = 8;
  mtRTexttoSub        = 8;
  mtRItemGap          = 2;
  mtRBarTexttoBMP     = 8;
  mtRBargap           = 2;


type
  TIAmenuType = (mtPop,mtMain);
  TIAmenuKind = (mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner);
  TIAAlign    = (iaalLeft,iaalRight,iaalTop,iaalBottom,iaalNoneVertical,iaalNoneHorizontal);
  TIAPreferredOrientation = (poLeftRightTopBottom,poRightLeftTopBottom,poLeftRightBottomTop,poRightLeftBottomTop);
  TIARectsInfo = record
    Rects : array of TRect;
    Connected : array of integer;
    ShowHiddenRect : Trect;
    HideHiddenRect : Trect;
    MainRect   : TRect;
    BarRect : TRect;
  end;
  TIAFont3DStyle = (iafsPlain,iafsPressed,iafsRelief);
  TIAWindowState = (iawsBefore,iawsOpening,iawsWorking,iawsClosing);
  TIAMenuSelectProcedure = procedure(Sender : TObject;AName : String;var ANamePath : TStringList;ASubmenuSelected : Boolean) of object;

   //-------------------------
 TIAeverMenuForm = class(TCustomForm)
  private
    FMenuContent : TIAmenuList;
    FRectsInfo : TIARectsInfo;
    FMyOwner : TComponent;
    FOrientation : TIAPreferredOrientation;
    FIWindowState : TIAWindowState;
    FRect : TRect;
    FUpRect : TRect;
    FDownRect : TRect;
    FUpRectSelected : Boolean;
    FDownRectSelected : Boolean;
    FHorizontal : Boolean;

    FGap : integer;
    FCurrentPosition : integer;
    FOpenHiddenSelected : Boolean;
    FCloseHiddenSelected : Boolean;
    FMainBitmap : TBitmap;
    FSemiBitmap : TBitmap;
    FFirst : Boolean;
    FTimed : Boolean;
    FTimer : TTimer;
    FSelectedRectNumber : integer;
    FCurrentBackBitmap : TBitmap;
    FCurrentListBackBitmap : TBitmap;
    procedure GetRectsInfo(ABefore : Boolean =false);
    function GetCurrentRegion: HRGN;
    procedure WMMOUSEACTIVATE(var Message : TMessage); message WM_MOUSEACTIVATE;
    procedure WMACTIVATE(var Message : TMessage); message WM_ACTIVATE;
    procedure CMOpening(var Message : TMessage); message CM_Opening;
    procedure CMClosing(var Message : TMessage); message CM_Closing;
    procedure WMSize(var Message : TMessage); message WM_SIZE;
    procedure DefineBarPosition;
    procedure CorrectBarPosition;

    procedure onFTimer(Sender: TObject);
    procedure TryUnselect;
    procedure Unselect;
    procedure WMMOUSEMOVE(var Message : TMessage); message WM_MOUSEMOVE;
    procedure WMLBUTTONDOWN(var Message : TMessage);message WM_LBUTTONDOWN;
    procedure WMLBUTTONDBLCLK(var Message : TMessage);message WM_LBUTTONDBLCLK;
    procedure CMDOWN(var Message : TMessage);message CM_DOWN;
    procedure CMUP(var Message : TMessage);message CM_UP;
    procedure GetSemi(Nw : integer =0;Nh : integer =0);
    procedure DefineRealOrientation;
    procedure IChanged;
    function  IsChanged: Boolean;
    procedure SetRegion;
    procedure PaintAnimate;
    procedure GetSemiBitmaps;
    procedure DrawMainBitmap;
    procedure DrawMainBitmapmkSimple;
    procedure SetCurrentBackBitmap(ANumberItem : integer;AConTinued : Boolean;AList : TIAmenuList);
    procedure SetCurrentListBackBitmap(AConTinued : Boolean);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateHandle; override;
    procedure SetIWindowState(Value : TIAWindowState);virtual;
    procedure Paint;override;
    procedure SetOpenHiddenSelected(Value : Boolean); virtual;
    procedure SetCloseHiddenSelected(Value : Boolean); virtual;
    procedure SetUpRectSelected(Value : Boolean); virtual;
    procedure SetDownRectSelected(Value : Boolean); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    constructor CreateNewOne(AOwner: TComponent;AMenuContent : TIAmenuList;
    ARect : TRect;AHorizontal : Boolean;var AOrientation : TIAPreferredOrientation;AmyOwner :TComponent);
    destructor Destroy; override;
    property IWindowState : TIAWindowState read FIWindowState write SetIWindowState;
    property OpenHiddenSelected : Boolean read FOpenHiddenSelected write SetOpenHiddenSelected default false;
    property CloseHiddenSelected : Boolean read FCloseHiddenSelected write SetCloseHiddenSelected default false;
    property UpRectSelected : Boolean read FUpRectSelected write SetUpRectSelected default false;
    property DownRectSelected : Boolean read FDownRectSelected write SetDownRectSelected default false;
  end;
   //-------------------------
   
  TIAeverMenuWindow2 = class(TComponent)
  private
    { Private declarations }
    FNextWindow     : TIAeverMenuWindow2;
    FPreviousWindow : TIAeverMenuWindow2;
    FMenuContent : TIAmenuList;
    FConnectedWindow : TIAeverMenuForm;
    FRealOrientation : TIAPreferredOrientation;
    FIWindowState : TIAWindowState;
    FRect : TRect;
    FTimed : Boolean;
    FNCadr : integer;
    procedure CloseWindow;
    procedure OpeningWindow;
    procedure ClosingWindow;
  protected
    { Protected declarations }
    procedure SetIWindowState(Value : TIAWindowState);virtual;

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    constructor CreateNew(AOwner: TComponent;AMenuContent : TIAmenuList;ARect : TRect;AHorizontal : Boolean);
    destructor Destroy; override;
    property IWindowState : TIAWindowState read FIWindowState write SetIWindowState;
  published
    { Published declarations }
  end;
  //-------------------------
  TIAeverMenuMainWindow2 = class(TCustomControl)
  private
    { Private declarations }
    FRectsInfo : TIARectsInfo;
    FMenuContent : TIAmenuList;
    FOpenHiddenSelected : Boolean;
    FCloseHiddenSelected : Boolean;
    FTimed : Boolean;
    FTimer : TTimer;
    FRealLeft,FRealTOP : integer;
    FSelectedRectNumber : integer;
    FPaintBitmap : TBitmap;
    FSemiBitmap : TBitmap;
    FFirst: Boolean;
    FCurrentBackBitmap : TBitmap;
    procedure GetRectsInfo;
    function GetCurrentRegion: HRGN;
    procedure PaintmtSimple;
    procedure DrawBackmtSimple;
    procedure DrawItemsmtSimple;
    procedure DrawHiddenRectsmtSimple;
    procedure IChanged;
    function  IsChanged: Boolean;

    procedure onFTimer(Sender: TObject);
    procedure GetRealLeftTOP;
    procedure TryUnselect;
    procedure Unselect;
    procedure WMMOUSEMOVE(var Message : TMessage); message WM_MOUSEMOVE;
    procedure WMLBUTTONDOWN(var Message : TMessage);message WM_LBUTTONDOWN;
    procedure WMLBUTTONDBLCLK(var Message : TMessage);message WM_LBUTTONDBLCLK;
    procedure DrawBitmap;
    procedure GetSemiBitmaps;
    procedure SetCurrentBackBitmap(ANumberItem : integer;AConTinued : Boolean);
  protected
    { Protected declarations }
    procedure CreateHandle; override;
    procedure Paint; override;
    procedure SetOpenHiddenSelected(Value : Boolean); virtual;
    procedure SetCloseHiddenSelected(Value : Boolean); virtual;
  public
    { Public declarations }
    procedure SetRegion;

    constructor Create(AOwner: TComponent); override;
    constructor CreateNew(AOwner: TComponent;var AMenuContent : TIAmenuList);
    destructor Destroy; override;
    property OpenHiddenSelected : Boolean read FOpenHiddenSelected write SetOpenHiddenSelected default false;
    property CloseHiddenSelected : Boolean read FCloseHiddenSelected write SetCloseHiddenSelected default false;
  published
    { Published declarations }
  end;
  //-------------------------
  TIAeverMenu2 = class(TComponent)
  private
    OldParentWndProc : TFarProc;//Hook variables...
    NewparentWndProc : Pointer;

    FMainWindow : TIAeverMenuMainWindow2;
    FCurrentWindow : TIAeverMenuWindow2;
    FFirstWindow : TIAeverMenuWindow2;
    FMouseTimer : TIAmousetimer2;

    FMenuType : TIAmenuType;
    FMenuKind : TIAmenuKind;
    FMenuAlign : TIAAlign;
    FPreferredOrientation : TIAPreferredOrientation;
    FDelayTime : integer;
    FMenuFont : TFont;
    FMainMenuLeft : integer;
    FMainMenuTop : integer;

    FMainMenuList : TIAmenuList;
    //Colors....
    FBackColor : TColor;
    FSelectColor : TColor;
    FGrayColor : TColor;
    FSelectFontColor : TColor;
    FFont3DStyle : TIAFont3DStyle;
    FSemiPercent : Integer;
    FMainSemiPercent : Integer;
    FFramesDelay : Integer;
    FScrollVelocity : integer;

    //Colors end...

    First : boolean;
    FOnSelectItem : TIAMenuSelectProcedure;

    { Private declarations }
    procedure HookWndProc(var Message : Tmessage);
    procedure Calldefault(var Message : Tmessage);
    procedure HookParent;
    procedure UnhookParent;
    procedure RecreateMenu;
    procedure MenuFontChanged(Sender: TObject);
    procedure ONMainSelectItem(AItem : TIAmenuItem;Clicked : Boolean;ARect : TRect;AHorizontal : Boolean;ADouble : Boolean);
    procedure ONSelectCurrentItem(AItem : TIAmenuItem;Clicked : Boolean;ARect : TRect;ADouble : Boolean);
    function GetPathofItem(AItem : TIAmenuItem): TStringList;
  protected
    { Protected declarations }
    procedure SetCurrentWindow(Value : TIAeverMenuWindow2); virtual;
    procedure SetMenuType(Value : TIAmenuType);virtual;
    procedure SetMenuKind(Value : TIAmenuKind);virtual;
    procedure SetMenuAlign(Value : TIAAlign);  virtual;
    procedure SetPreferredOrientation(Value : TIAPreferredOrientation); virtual;
    procedure SetDelayTime(Value : integer); virtual;
    procedure SetMenuFont(Value : TFont);virtual;
    procedure SetFont3DStyle(Value : TIAFont3DStyle);virtual;
    procedure SetBackColor(Value : TColor);virtual;
    procedure SetSelectColor(Value : TColor);virtual;
    procedure SetGrayColor(Value : TColor);virtual;
    procedure SetSelectFontColor(Value : TColor);virtual;
    procedure SetSemiPercent(Value : Integer);virtual;
    procedure SetMainSemiPercent(Value : Integer);virtual;
    procedure SetFramesDelay(Value : Integer);virtual;
    procedure SetScrollVelocity(Value : integer);virtual;


    procedure SetMainMenuLeft(Value : integer);virtual;
    procedure SetMainMenuTop(Value : integer);virtual;
    procedure SetMainMenuList(Value : TIAMenuList);virtual;


    property CurrentWindow : TIAeverMenuWindow2 read FCurrentWindow write SetCurrentWindow;

    property MenuType : TIAmenuType read FMenuType write SetMenuType default mtPop;
    property MenuAlign : TIAAlign read FMenuAlign write SetMenuAlign;// default iaalTop;
    property MainSemiPercent : integer read FMainSemiPercent write SetMainSemiPercent default 0;
    property MainMenuLeft : integer read FMainMenuLeft write SetMainMenuLeft default 0;
    property MainMenuTop  : integer read FMainMenuTop  write SetMainMenuTop  default 0;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure CloseMenu;
    procedure OpenMenu(Moused : Boolean = TRUE;AWinControl : TWinControl = nil;
           Aleft : integer =0; Atop : integer = 0; Aright : integer = 0 ; Abottom : integer = 0;AHorizontal : Boolean=false);
  published
    { Published declarations }
    property MainMenuList : TIAMenuList read FMainMenuList write SetMainMenuList;
    property MenuKind : TIAmenuKind read FMenuKind write SetMenuKind default mkSimple;

    property PreferredOrientation : TIAPreferredOrientation read FPreferredOrientation
                                     write SetPreferredOrientation default poLeftRightTopBottom;
    property DelayTime : integer read FDelayTime write setDelayTime default 60;
    property MenuFont : TFont read FMenuFont write SetMenuFont;
    property Font3DStyle : TIAFont3DStyle read FFont3DStyle write SetFont3DStyle default iafsPlain;
    property BackColor : TColor read FBackColor write SetBackColor default clMenu;
    property SelectColor : TColor read FSelectColor write SetSelectColor default clActiveCaption;
    property GrayColor : TColor read FGrayColor write SetGrayColor default clInactiveCaption;
    property SelectFontColor : TColor read FSelectFontColor write SetSelectFontColor default clMenuText;
    property SemiPercent : integer read FSemiPercent write SetSemiPercent default 0;

    property FramesDelay : integer read FFramesDelay write SetFramesDelay default 10;
    property ScrollVelocity : integer read FScrollVelocity write SetScrollVelocity default 5;
    property OnSelectItem : TIAMenuSelectProcedure read FOnSelectItem write FOnSelectItem;


  end;
  //-------------------------
  //++++++++++++++++++++++Main Declarations...
  TIAeverMainMenuSe = class(TIAeverMenu2)
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    property MainMenuList;
    property MenuAlign;
    property MainSemiPercent;
    property MainMenuLeft;
    property MainMenuTop;
  end;
  TIAeverPopMenuSe = class(TIAeverMenu2)
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
  published
    property MainMenuList;
  end;

  //+++++++++++++++++++++++
procedure Register;

implementation

//
function GetLColor(AColor : TColor): TColor;
var
  pR,pG,pB : pByte;
begin
  Result:=ColorToRGB(AColor);
  pR:=pByte(@Result);
  pG:=pByte(integer(pR)+1);
  pB:=pByte(integer(pG)+1);
  if (255-pR^)<64 then pR^:=255 else inc(pR^,64);
  if (255-pG^)<64 then pG^:=255 else inc(pG^,64);
  if (255-pB^)<64 then pB^:=255 else inc(pB^,64);
  if (pR^)<96 then pR^:=96;
  if (pG^)<96 then pG^:=96;
  if (pB^)<96 then pB^:=96;
end;
function GetDColor(AColor : TColor): TColor;
var
  pR,pG,pB : pByte;
begin
  Result:=ColorToRGB(AColor);
  pR:=pByte(@Result);
  pG:=pByte(integer(pR)+1);
  pB:=pByte(integer(pG)+1);
  if (pR^)<128 then pR^:=64 else dec(pR^,64);
  if (pG^)<128 then pG^:=64 else dec(pG^,64);
  if (pB^)<128 then pB^:=64 else dec(pB^,64);
end;
procedure TIAeverMenu2.MenuFontChanged(Sender: TObject);
begin
  RecreateMenu;
end;
constructor TIAeverMenu2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  First:=True;
  FOnSelectItem:=nil;
  FMainWindow:=nil;
  FCurrentWindow:=nil;
  FFirstWindow:=nil;
  if AOWNER is TWinControl then hookparent
    else
      begin
        ShowMessage('Only TwinControl Allowed as AOwner...');
        halt;
      end;
  FMouseTimer:=TIAmousetimer2.Create(TRUE);
  FmouseTimer.FHandle:=TWinControl(AOwner).handle;
  FMenuType:=mtPop;
  FMenuKind:=mkSimple;
  FMainMenuList:=TIAmenuList.Create(nil);
  FMenuAlign:=iaalTop;
  FFont3DStyle:=iafsPlain;
  FBackColor:=clMenu;
  FSelectColor:=clActiveCaption;
  FGrayColor:=clInactiveCaption;
  FSelectFontColor:=clMenuText;
  FPreferredOrientation:=poLeftRightTopBottom;
  FDelayTime:=60;
  FFramesDelay:=10;
  FScrollVelocity:=5;
  FMenuFont:=TFont.Create;
  FMenuFont.Name:='Times New Roman';
  FMenuFont.OnChange:=MenuFontChanged;
  FMainMenuLeft:=0;
  FMainMenuTop:=0;
end;
destructor TIAeverMenu2.Destroy;
begin
  CloseMenu;
  if FMainWindow<>Nil then
    begin
      FMainWindow.free;
      FmainWindow:=nil;
    end;
  if FMousetimer.Suspended then
    begin
      FMousetimer.Terminate;
      FMouseTimer.Resume;
      FMousetimer.WaitFor;
    end else
    begin
      FMousetimer.Terminate;
      FMousetimer.WaitFor;
    end;
  FMenuFont.Free;  
  unhookparent;
  inherited Destroy;
end;
procedure TIAeverMenu2.HookParent;
begin
  if Not Assigned(Owner) then exit;
  OldParentWndProc:=TFarProc(GetWindowLong((owner as TwinControl).handle,GWL_WNdProc));
  NewParentWndProc:=MakeObjectInstance(HookWndProc);
  SetWindowLong((owner as TwinControl).handle,GWL_WNdProc,LongInt(NewParentWndProc));
end;
procedure TIAeverMenu2.UnhookParent;
begin
  if assigned(owner) and assigned(OldParentWndProc) then
    SetWindowLong((owner as TwinControl).handle,GWL_WNdProc,LongInt(OldParentWndProc));
  if assigned(NewParentWndProc) then FreeObjectInstance(NewParentWndProc);
  NewParentWndProc:=nil;
  OldParentWndProc:=nil;
end;
procedure TIAeverMenu2.HookWndProc(var Message : Tmessage);
var
 fActive : integer;
 P1 : TPoint;
 R1,R2 : TRect;
begin
  if Message.Msg=WM_SIZE then
    begin
      if FMainWindow<>Nil then FMainWindow.SetRegion;
    end;
   if Message.Msg=CM_CHECKFORMOUSE then
    begin
      if FCurrentWindow=nil then
        begin
          if not FMousetimer.Suspended then FMousetimer.Suspend;
        end else
        begin
          P1:=Mouse.CursorPos;
          R1:=FCurrentWindow.FConnectedWindow.ClientRect;
          offsetrect(R1,FCurrentWindow.FConnectedWindow.left,FCurrentWindow.FConnectedWindow.top);
          R2:=FCurrentWindow.FRect;
          inflaterect(R1,0,0);
          inflaterect(R2,0,0);
          if not ((ptinrect(R1,P1)) or (ptinrect(R2,P1))) then
            begin
              case FCurrentwindow.FIWindowState of
               iawsWorking,iawsClosing :
                 begin

                   if (FCurrentWindow.FPreviousWindow<>nil) and
                   ptinrect(FCurrentWindow.FPreviousWindow.FConnectedWindow.ClientRect,P1) then
                     begin
                       FCurrentWindow.IWindowState:=iawsClosing;
                     end else
                     begin
                       if (FMainWindow<>nil) then
                         begin
                           FMainWindow.GetRealLeftTOP;
                           p1.x:=p1.x-FMainWindow.FRealLeft;
                           p1.y:=p1.y-FMainWindow.FRealtop;
                         end;
                       if (FMainWindow<>nil) and ptinrect(FMainWindow.ClientRect,P1) then FCurrentWindow.CloseWindow else
                       FCurrentWindow.IWindowState:=iawsClosing;
                     end;

                 end;
               else  FCurrentWindow.CloseWindow;
              end;
            end;
        end;
    end;
  if Message.Msg=WM_Activate then
    begin
      
      fActive := LOWORD(Message.WParam);
      if FActive=WA_INACTIVE  then//I prevent the activating of window besause of delphi error...
        begin
          CloseMenu;
        end;
   end;
   CallDefault(Message);
end;
procedure TIAeverMenu2.CallDefault(var Message : Tmessage);
begin
  if assigned(owner) then
  Message.Result:=
  CallWindowProc(OldParentWndProc,(owner as TwinControl).Handle,Message.Msg,Message.wParam,Message.lParam);
end;
procedure TIAeverMenu2.SetCurrentWindow(Value : TIAeverMenuWindow2);
begin
  FCurrentWindow:=Value;
  if Value=Nil then
    begin
      FFirstWindow:=Nil;
      if not FMousetimer.Suspended then FMousetimer.Suspend;
    end else
    begin
      if FMousetimer.Suspended then FMousetimer.Resume;
      if FFirstWindow=nil then FFirstWindow:=Value;
    end;
end;
procedure TIAeverMenu2.RecreateMenu;
begin
  CloseMenu;
  if FMainWindow<>Nil then
    begin
      FMainWindow.free;
      FmainWindow:=nil;
    end;
  //Here need the new FMainWindowCreate;
  if FMenuType=mtMain then
    begin
      FMainWindow:=TIAeverMenuMainWindow2.CreateNew(self,FMainMenuList);
    end;
end;
procedure TIAeverMenu2.CloseMenu;
begin
  if FFirstWindow<>Nil then
    begin
      FFirstWindow.CloseWindow;
      FFirstWindow:=nil;
    end;
end;
procedure TIAeverMenu2.OpenMenu(Moused : Boolean = TRUE;AWinControl : TWinControl = nil;
Aleft : integer =0; Atop : integer = 0; Aright : integer = 0 ; Abottom : integer = 0;AHorizontal : Boolean=false);
var ARect : TRect;
begin
  if (FMenuType=mtPop) and  (FFirstWindow=Nil) then
    begin
      if Moused then
        begin
          ARect:=rect(Mouse.CursorPos.x-1,Mouse.CursorPos.y-1,Mouse.CursorPos.x+1,Mouse.CursorPos.y+1);
        end else
        begin
          if AWinControl<>nil then
             begin
               ARect:=AWinControl.ClientRect;
               if AWinControl.parent<> nil then
                 begin
                   offsetRect(ARect,AWinControl.parent.ClientOrigin.x+AWinControl.left,AWinControl.parent.ClientOrigin.y+AWinControl.top);
                 end;

             end else
             begin
               ARect:=Rect(ALeft,ATop,ARight,ABottom);
             end;
        end;
      TIAeverMenuWindow2.CreateNew(self,FMainMenuList,ARect,AHorizontal);  
    end; 
end;
procedure TIAeverMenu2.ONSelectCurrentItem(AItem : TIAmenuItem;Clicked : Boolean;ARect : TRect;ADouble : Boolean);
var AList : TStringList;
begin
  if FCurrentWindow.FNextWindow<>nil  then
    begin
      FCurrentWindow.FNextWindow.CloseWindow;
      FCurrentWindow.FNextWindow:=nil;
    end;
  if (AItem<>nil) and (AItem.SubMenuList<>nil) and (not ADouble) then
    begin
      //We need to open new window SubMenuList..
      TIAeverMenuWindow2.CreateNew(self,AItem.SubMenuList,ARect,false);
      if Assigned(FOnSelectItem) then
        begin
          if AItem<>nil then
            begin
              AList:=GetPathofItem(AItem);
              FOnSelectItem(self,AItem.ItemName,AList,TRUE);
              AList.Free;
            end;
        end;


    end else
    begin
      //here if Clicked is on then we must to call onSelect Function..
      if (AItem<>nil) then
        begin
          if Clicked and (AItem.SubMenuList=nil) then
            begin
              CloseMenu;
              if Assigned(FOnSelectItem) then
                begin
                   AList:=GetPathofItem(AItem);
                   FOnSelectItem(self,AItem.ItemName,AList,false);
                   AList.Free;
                end;
            end;
        end;
    end;
end;
procedure TIAeverMenu2.ONMainSelectItem(AItem : TIAmenuItem;Clicked : Boolean;ARect : TRect;AHorizontal : Boolean;ADouble : Boolean);
var AList : TStringList;

begin
  CloseMenu;
  if (AItem<>nil) and (AItem.SubMenuList<>nil) and (not ADouble) then
    begin
      //We need to open new window SubMenuList..
       TIAeverMenuWindow2.CreateNew(self,AItem.SubMenuList,ARect,AHorizontal);
      if Assigned(FOnSelectItem) then
        begin
          if AItem<>nil then
            begin
              AList:=GetPathofItem(AItem);
              FOnSelectItem(self,AItem.ItemName,AList,TRUE);
              AList.Free;
            end;
        end;


    end else
    begin
      //here if Clicked is on then we must to call onSelect Function..
      if (AItem<>nil) then
        begin
          if Clicked and (AItem.SubMenuList=nil) then
            begin
   
              if Assigned(FOnSelectItem) then
                begin
                  AList:=GetPathofItem(AItem);
                  FOnSelectItem(self,AItem.ItemName,AList,false);
                  AList.Free;
                end;
            end;
        end;
    end;
end;
function TIAeverMenu2.GetPathofItem(AItem : TIAmenuItem): TStringList;
begin
  Result:= TStringList.Create;
  While (AItem<>nil) and (AItem.Owner is TIAmenuList) and ((AItem.Owner as TIAmenuList).owner<>nil) and ((AItem.Owner as TIAmenuList).owner is TIAmenuItem) do
    begin
      Result.Insert(0,((AItem.Owner as TIAmenuList).owner as TIAmenuItem).ItemName);
      Aitem:=((AItem.Owner as TIAmenuList).owner as TIAmenuItem);
    end;
end;
procedure TIAeverMenu2.SetMenuType(Value : TIAmenuType);
begin
  if Value<>FMenuType then
    begin
      FMenuType:=Value;
      RecreateMenu;
    end;
end;
procedure TIAeverMenu2.SetMenuKind(Value : TIAmenuKind);
begin
  if Value<>FMenuKind then
    begin
      FMenuKind:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetMenuAlign(Value : TIAAlign);
begin
  if Value<>FMenuAlign then
    begin
      FMenualign:=Value;
   end;
 if FMenuType=mtMain then
   begin
     Recreatemenu;
   end;
end;
procedure TIAeverMenu2.SetPreferredOrientation(Value : TIAPreferredOrientation);
begin
  if Value<>FPreferredOrientation then
    begin
      FPreferredOrientation:=Value;
    end;
end;
procedure TIAeverMenu2.SetDelayTime(Value : integer);
begin
  if Value<>FDelayTime then
    begin
      FDelayTime:=Value;
    end;
end;
procedure TIAeverMenu2.SetMenuFont(Value : TFont);
begin
  if FMenuFont<>Value then
    begin
      FMenuFont.Assign(Value);
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetFont3DStyle(Value : TIAFont3DStyle);
begin
  if Value<>FFont3DStyle then
    begin
      FFont3DStyle:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetBackColor(Value : TColor);
begin
  if Value<>fBackColor then
    begin
      FBackColor:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetSelectColor(Value : TColor);
begin
  if Value<>fSelectColor then
    begin
      FSelectColor:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetGrayColor(Value : TColor);
begin
  if Value<>fGrayColor then
    begin
      FGrayColor:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetSelectFontColor(Value : TColor);
begin
  if Value<>fSelectFontColor then
    begin
      FSelectFontColor:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetSemiPercent(Value : Integer);
begin
  if (Value>=0) and (Value<=100) and (Value<>FSemiPercent) then
    begin
      FSemiPercent:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetMainSemiPercent(Value : Integer);
begin
  if (Value>=0) and (Value<=100) and (Value<>FMainSemiPercent) then
    begin
      FMainSemiPercent:=Value;
      Recreatemenu;
    end;
end;
procedure TIAeverMenu2.SetFramesDelay(Value : Integer);
begin
  if (Value>=0) and (Value<=50) and (value<>FFramesDelay) then
    begin
      FFramesDelay:=Value;
    end;
end;
procedure TIAeverMenu2.SetScrollVelocity(Value : integer);
begin
  if (Value>0) and (Value<51) and (Value<>FScrollVelocity) then
    begin
      FScrollVelocity:=Value;
    end;
end;
procedure TIAeverMenu2.SetMainMenuLeft(Value : integer);
begin
  if FMainmenuLeft<>Value then
    begin
      FMainmenuLeft:=Value;
      if FMenuType=mtMain then
        begin
          Recreatemenu;
        end;
    end;
end;
procedure TIAeverMenu2.SetMainMenuTop(Value : integer);
begin
  if FMainmenuTop<>Value then
    begin
      FMainmenuTop:=Value;
      if FMenuType=mtMain then
        begin
          Recreatemenu;
        end;
    end;
end;
procedure TIAeverMenu2.SetMainMenuList(Value : TIAMenuList);
begin
  if Value<>FMainMenuList then
    begin
      if Value=nil then
        begin
          CloseMenu;
          if FMainWindow<>nil then
            begin
              FMainWindow.Free;
              FMainWindow:=nil;
            end;
          FMainMenuList.Free;
          FMainMenuList:=nil;
        end else
        begin
          if FMainMenuList=nil then
            begin
              FMainMenuList:=TIAMenuList.Create(self);
              FMainMenuList.Assign(Value);
              Recreatemenu;
            end else
            begin
              CloseMenu;
              FMainMenuList.Assign(Value);
              Recreatemenu;
            end;
        end;
    end;
end;
//-------------------------
constructor TIAeverMenuWindow2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPreviousWindow:=nil;
  FNextWindow:=nil;
  FIWindowState:=iawsbefore;
  FTimed:=False;
end;
constructor TIAeverMenuWindow2.CreateNew(AOwner: TComponent;AMenuContent : TIAmenuList;ARect : TRect;AHorizontal : Boolean);
begin
  Create(AOwner);
  FMenuContent:=AMenuContent;
  FRect:=ARect;
  FPreviousWindow:=(AOwner as TIAeverMenu2).CurrentWindow;
  if FPreviousWindow<>nil then FPreviousWindow.FNextWindow:=self;
  (AOwner as TIAeverMenu2).CurrentWindow:=self;
  FRealOrientation:=(AOwner as TIAeverMenu2).FPreferredOrientation;
  FConnectedWindow := TIAeverMenuForm.CreateNewOne(Application,AMenuContent,ARect,AHorizontal,FRealOrientation,AOwner);
  ShowWindow(FConnectedWindow.handle,SW_SHOWNOACTIVATE);	

  Iwindowstate:=iawsOpening;
end;
destructor TIAeverMenuWindow2.Destroy;
begin
  FConnectedWindow.release;
  FConnectedWindow.free;
  FConnectedWindow:=nil;
  if (FMenuContent.Owner<>nil) and (FMenuContent.Owner is TIAmenuItem) then (FMenuContent.Owner as TIAmenuItem).selected:=false;
  (Owner as TIAeverMenu2).CurrentWindow:=FPreviousWindow;
  inherited Destroy;
end;
procedure TIAeverMenuWindow2.CloseWindow;
begin
  if FNextWindow<>nil then
   begin
     FNextWindow.CloseWindow;
     FNextWindow:=nil;
   end;
  if FPreviousWindow<>nil then FPreviouswindow.FNextWindow:=nil;
  self.Free;
end;
procedure TIAeverMenuWindow2.SetIWindowState(Value : TIAWindowState);
begin
  if Value<>FIWindowState then
    begin
      FIWindowstate:=value;
      FConnectedWindow.IWindowState:=Value;
      case value of
        iawsOpening :
          begin
            OpeningWindow;
          end;
        iawsClosing :
          begin
            ClosingWindow;
          end;  
        else
          begin

          end;
      end;
    end;
end;
procedure TIAeverMenuWindow2.ClosingWindow;
var RGN,R1 : HRGN;
    i : integer;
begin
  if (Owner as TIAeverMenu2).framesdelay=0 then
    begin
      self.CloseWindow;
      exit;
    end;
  RGN:=NULLREGION;
  case (Owner as TIAeverMenu2).menukind of
    mkRects :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
              poLeftRightTopBottom,poRightLeftTopBottom :
                begin
                  RGN:=CreateRectRGn(0,0,0,0);
                  for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                    begin
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                        FConnectedWindow.FRectsinfo.Rects[i].right,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                    FConnectedWindow.FRectsinfo.BarRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.ShowHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.HideHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,(20-FNCadr)*FConnectedWindow.FUpRect.top div 20,
                                    FConnectedWindow.FUpRect.right,(20-FNCadr)*FConnectedWindow.FUpRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,(20-FNCadr)*FConnectedWindow.FDownRect.top div 20,
                                    FConnectedWindow.FDownRect.right,(20-FNCadr)*FConnectedWindow.FDownRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                end;
              poLeftRightBottomTop,poRightLeftBottomTop :
                begin
                  RGN:=CreateRectRGn(0,0,0,0);
                  for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                    begin
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                        FConnectedWindow.FRectsinfo.Rects[i].right,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                    FConnectedWindow.FRectsinfo.BarRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.ShowHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.HideHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,(20-FNCadr)*FConnectedWindow.FUpRect.top div 20,
                                    FConnectedWindow.FUpRect.right,(20-FNCadr)*FConnectedWindow.FUpRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,(20-FNCadr)*FConnectedWindow.FDownRect.top div 20,
                                    FConnectedWindow.FDownRect.right,(20-FNCadr)*FConnectedWindow.FDownRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  offsetRGn(RGN,0,(FNCadr)*(FConnectedWindow.FRectsInfo.MainRect.bottom-FConnectedWindow.FRectsInfo.MainRect.top) div 20);
                end;  
            end;
            setwindowrgn(FConnectedWindow.handle,RGN,True);

         //   postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
            FConnectedWindow.paint;
         //   Application.ProcessMessages;
            postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poLeftRightTopBottom,poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGn(0,0,0,0);
                      for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                        begin
                          R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                            FConnectedWindow.FRectsinfo.Rects[i].right,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                          CombineRGN(RGN,RGN,R1,RGN_OR);
                          DeleteObject(R1);
                        end;
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                        FConnectedWindow.FRectsinfo.BarRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.ShowHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.HideHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,(20-FNCadr)*FConnectedWindow.FUpRect.top div 20,
                                        FConnectedWindow.FUpRect.right,(20-FNCadr)*FConnectedWindow.FUpRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,(20-FNCadr)*FConnectedWindow.FDownRect.top div 20,
                                        FConnectedWindow.FDownRect.right,(20-FNCadr)*FConnectedWindow.FDownRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  poLeftRightBottomTop,poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGn(0,0,0,0);
                      for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                        begin
                          R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                            FConnectedWindow.FRectsinfo.Rects[i].right,(20-FNCadr)*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                          CombineRGN(RGN,RGN,R1,RGN_OR);
                          DeleteObject(R1);
                        end;
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                        FConnectedWindow.FRectsinfo.BarRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.ShowHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.HideHiddenRect.right,(20-FNCadr)*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,(20-FNCadr)*FConnectedWindow.FUpRect.top div 20,
                                        FConnectedWindow.FUpRect.right,(20-FNCadr)*FConnectedWindow.FUpRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,(20-FNCadr)*FConnectedWindow.FDownRect.top div 20,
                                        FConnectedWindow.FDownRect.right,(20-FNCadr)*FConnectedWindow.FDownRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      offsetRGn(RGN,0,(FNCadr)*(FConnectedWindow.FRectsInfo.MainRect.bottom-FConnectedWindow.FRectsInfo.MainRect.top) div 20);
                    end;
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,True);

            //    postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
                FConnectedWindow.paint;
           //     Application.ProcessMessages;
                postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
              end else
              begin
                FTimed:=false;
                self.CloseWindow;
 
              end;
          end;
      end;
    mkSimpleCorner,mkWideCorner :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
              poRightLeftBottomTop :
                begin
                  RGN:=CreateRectRGN(0,0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                          (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                end;
              poLeftRightBottomTop :
                begin
                  RGN:=CreateRectRGN((FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,0,FConnectedWindow.FRectsInfo.MainRect.right,
                          (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                end;
              poRightLeftTopBottom :
                begin
                  RGN:=CreateRectRGN(0,(FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                          FConnectedWindow.FRectsInfo.MainRect.bottom);
                end;
              poLeftRightTopBottom :
                begin
                  RGN:=CreateRectRGN((FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,(FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                        FConnectedWindow.FRectsInfo.MainRect.right,
                        FConnectedWindow.FRectsInfo.MainRect.bottom);
                end;  
            end; 
            setwindowrgn(FConnectedWindow.handle,RGN,True);

         //   postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
            FConnectedWindow.paint;
         //   Application.ProcessMessages;
            postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGN(0,0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                              (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poLeftRightBottomTop :
                    begin
                      RGN:=CreateRectRGN((FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,0,FConnectedWindow.FRectsInfo.MainRect.right,
                              (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGN(0,(FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                              FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                  poLeftRightTopBottom :
                    begin
                      RGN:=CreateRectRGN((FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,(FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                            FConnectedWindow.FRectsInfo.MainRect.right,
                            FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;  
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,True);

            //    postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
                FConnectedWindow.paint;
           //     Application.ProcessMessages;
                postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
              end else
              begin
                FTimed:=false;
                self.CloseWindow;
 
              end;
          end;
      end;
    mkSimple,mkWide :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
                  poLeftRightTopBottom,poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGN(0,0,FConnectedWindow.FRectsInfo.MainRect.right,
                              (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poLeftRightBottomTop,poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGN(0,FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                            FConnectedWindow.FRectsInfo.MainRect.right,
                            FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                end;
            setwindowrgn(FConnectedWindow.handle,RGN,True);

         //   postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
            FConnectedWindow.paint;
         //   Application.ProcessMessages;
            postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poLeftRightTopBottom,poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGN(0,0,FConnectedWindow.FRectsInfo.MainRect.right,
                              (20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poLeftRightBottomTop,poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGN(0,FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                            FConnectedWindow.FRectsInfo.MainRect.right,
                            FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,True);

            //    postmessage(((Owner as TIAeverMenu2).owner as TWinControl).handle,WM_PAINT,0,0);
                FConnectedWindow.paint;
           //     Application.ProcessMessages;
                postmessage(FConnectedWindow.handle,CM_Closing,integer(self),0);
              end else
              begin
                FTimed:=false;
                self.CloseWindow;
 
              end;
          end;
      end;  
  end;
end;
procedure TIAeverMenuWindow2.OpeningWindow;
var RGN,R1 : HRGN;
    i : integer;
begin
  if (Owner as TIAeverMenu2).framesdelay=0 then
    begin
      FIWindowState:=iawsWorking;
      FConnectedWindow.IWindowState:=iawsWorking;
      exit;
    end;
  RGN:=NULLREGION;
  case (Owner as TIAeverMenu2).menukind of
    mkRects :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
              poLeftRightTopBottom,poRightLeftTopBottom :
                begin
                  RGN:=CreateRectRGn(0,0,0,0);
                  for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                    begin
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                        FConnectedWindow.FRectsinfo.Rects[i].right,FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                    FConnectedWindow.FRectsinfo.BarRect.right,FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.ShowHiddenRect.right,FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.HideHiddenRect.right,FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,FConnectedWindow.FUpRect.top div 20,
                                    FConnectedWindow.FUpRect.right,FConnectedWindow.FUpRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,FConnectedWindow.FDownRect.top div 20,
                                    FConnectedWindow.FDownRect.right,FConnectedWindow.FDownRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                end;
              poLeftRightBottomTop,poRightLeftBottomTop :
                begin
                  RGN:=CreateRectRGn(0,0,0,0);
                  for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                    begin
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                        FConnectedWindow.FRectsinfo.Rects[i].right,FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                    FConnectedWindow.FRectsinfo.BarRect.right,FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.ShowHiddenRect.right,FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                    FConnectedWindow.FRectsinfo.HideHiddenRect.right,FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,FConnectedWindow.FUpRect.top div 20,
                                    FConnectedWindow.FUpRect.right,FConnectedWindow.FUpRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,FConnectedWindow.FDownRect.top div 20,
                                    FConnectedWindow.FDownRect.right,FConnectedWindow.FDownRect.bottom div 20);
                  CombineRGN(RGN,RGN,R1,RGN_OR);
                  DeleteObject(R1);
                  offsetRGn(RGN,0,(20-FNCadr)*(FConnectedWindow.FRectsInfo.MainRect.bottom-FConnectedWindow.FRectsInfo.MainRect.top) div 20);
                end;
            end;
            setwindowrgn(FConnectedWindow.handle,RGN,true);
            FConnectedWindow.Repaint;
            postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poLeftRightTopBottom,poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGn(0,0,0,0);
                      for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                        begin
                          R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,FNCadr*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                            FConnectedWindow.FRectsinfo.Rects[i].right,FNCadr*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                          CombineRGN(RGN,RGN,R1,RGN_OR);
                          DeleteObject(R1);
                        end;
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,FNCadr*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                        FConnectedWindow.FRectsinfo.BarRect.right,FNCadr*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,FNCadr*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.ShowHiddenRect.right,FNCadr*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,FNCadr*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.HideHiddenRect.right,FNCadr*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,FNCadr*FConnectedWindow.FUpRect.top div 20,
                                        FConnectedWindow.FUpRect.right,FNCadr*FConnectedWindow.FUpRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,FNCadr*FConnectedWindow.FDownRect.top div 20,
                                        FConnectedWindow.FDownRect.right,FNCadr*FConnectedWindow.FDownRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                    end;
                  poLeftRightBottomTop,poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGn(0,0,0,0);
                      for i:=0 to length(FConnectedWindow.FRectsinfo.Rects)-1 do
                        begin
                          R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.Rects[i].left,FNCadr*FConnectedWindow.FRectsinfo.Rects[i].top div 20,
                                            FConnectedWindow.FRectsinfo.Rects[i].right,FNCadr*FConnectedWindow.FRectsinfo.Rects[i].bottom div 20);
                          CombineRGN(RGN,RGN,R1,RGN_OR);
                          DeleteObject(R1);
                        end;
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.BarRect.left,FNCadr*FConnectedWindow.FRectsinfo.BarRect.top div 20,
                                        FConnectedWindow.FRectsinfo.BarRect.right,FNCadr*FConnectedWindow.FRectsinfo.BarRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.ShowHiddenRect.left,FNCadr*FConnectedWindow.FRectsinfo.ShowHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.ShowHiddenRect.right,FNCadr*FConnectedWindow.FRectsinfo.ShowHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FRectsinfo.HideHiddenRect.left,FNCadr*FConnectedWindow.FRectsinfo.HideHiddenRect.top div 20,
                                        FConnectedWindow.FRectsinfo.HideHiddenRect.right,FNCadr*FConnectedWindow.FRectsinfo.HideHiddenRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FUpRect.left,FNCadr*FConnectedWindow.FUpRect.top div 20,
                                        FConnectedWindow.FUpRect.right,FNCadr*FConnectedWindow.FUpRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      R1:=CreateRectRGN(FConnectedWindow.FDownRect.left,FNCadr*FConnectedWindow.FDownRect.top div 20,
                                        FConnectedWindow.FDownRect.right,FNCadr*FConnectedWindow.FDownRect.bottom div 20);
                      CombineRGN(RGN,RGN,R1,RGN_OR);
                      DeleteObject(R1);
                      offsetRGn(RGN,0,(20-FNCadr)*(FConnectedWindow.FRectsInfo.MainRect.bottom-FConnectedWindow.FRectsInfo.MainRect.top) div 20);
                    end;
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,true);
                FConnectedWindow.Repaint;
                postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
              end else
              begin
                FTimed:=false;
                FIWindowState:=iawsWorking;
                FConnectedWindow.IWindowState:=iawsWorking;
              end;
          end;
      end;
    mkSimpleCorner,mkWideCorner :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
              poLeftRightTopBottom :
                begin
                  RGN:=CreateRectRGN(0,0,FNCadr*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                          FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                end;
              poRightLeftTopBottom :
                begin
                  RGN:=CreateRectRGN((20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,0,FConnectedWindow.FRectsInfo.MainRect.right,
                          FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                end;
              poLeftRightBottomTop :
                begin
                  RGN:=CreateRectRGN(0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,FNCadr*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                          FConnectedWindow.FRectsInfo.MainRect.bottom);
                end;
              poRightLeftBottomTop :
                begin
                  RGN:=CreateRectRGN((20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                        FConnectedWindow.FRectsInfo.MainRect.right,
                        FConnectedWindow.FRectsInfo.MainRect.bottom);
                end;  
            end;    

            setwindowrgn(FConnectedWindow.handle,RGN,false);
            FConnectedWindow.Repaint;
            postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poLeftRightTopBottom :
                    begin
                      RGN:=CreateRectRGN(0,0,FNCadr*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                              FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGN((20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,0,FConnectedWindow.FRectsInfo.MainRect.right,
                              FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poLeftRightBottomTop :
                    begin
                      RGN:=CreateRectRGN(0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,FNCadr*FConnectedWindow.FRectsInfo.MainRect.right div 20,
                          FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                  poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGN((20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.right div 20,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                            FConnectedWindow.FRectsInfo.MainRect.right,
                            FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,false);
                FConnectedWindow.Repaint;
                postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
              end else
              begin
                FTimed:=false;
                FIWindowState:=iawsWorking;
                FConnectedWindow.IWindowState:=iawsWorking;
              end;
          end;
      end;
    mkSimple,mkWide :
      begin
        if not FTimed then
          begin
            FNCadr:=1;
            FTimed:=true;
            case FRealOrientation of
              poLeftRightTopBottom,poRightLeftTopBottom :
                begin
                  RGN:=CreateRectRGN(0,0,FConnectedWindow.FRectsInfo.MainRect.right,
                          FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                end;
              poLeftRightBottomTop,poRightLeftBottomTop :
                begin
                  RGN:=CreateRectRGN(0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                        FConnectedWindow.FRectsInfo.MainRect.right,
                        FConnectedWindow.FRectsInfo.MainRect.bottom);
                end;  
            end;    

            setwindowrgn(FConnectedWindow.handle,RGN,false);
            FConnectedWindow.Repaint;
            postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
          end else
          begin
            inc(FNCadr);
            if FNCadr<=20 then
              begin
                case FRealOrientation of
                  poLeftRightTopBottom,poRightLeftTopBottom :
                    begin
                      RGN:=CreateRectRGN(0,0,FConnectedWindow.FRectsInfo.MainRect.right,
                              FNCadr*FConnectedWindow.FRectsInfo.MainRect.bottom div 20);
                    end;
                  poLeftRightBottomTop,poRightLeftBottomTop :
                    begin
                      RGN:=CreateRectRGN(0,(20-FNCadr)*FConnectedWindow.FRectsInfo.MainRect.bottom div 20,
                            FConnectedWindow.FRectsInfo.MainRect.right,
                            FConnectedWindow.FRectsInfo.MainRect.bottom);
                    end;
                end;
                setwindowrgn(FConnectedWindow.handle,RGN,false);
                FConnectedWindow.Repaint;
                postmessage(FConnectedWindow.handle,CM_Opening,integer(self),0);
              end else
              begin
                FTimed:=false;
                FIWindowState:=iawsWorking;
                FConnectedWindow.IWindowState:=iawsWorking;
              end;
          end;
      end;  
  end;
end;
//-------------------------
constructor TIAeverMenuMainWindow2.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FOpenHiddenSelected:=False;
  FCloseHiddenSelected:=False;
  FSelectedRectNumber:=-10;
  FTimed:=false;
  FPaintBitmap:=TBitmap.Create;
  FPaintBitmap.PixelFormat:=pf24bit;
  FPaintBitmap.Width:=0;
  FPaintBitmap.Height:=0;
  FPaintBitmap.Canvas.Font:=(Owner as TIAeverMenu2).MenuFont;
  FSemiBitmap:=nil;
  FCurrentBackBitmap:=nil;
  if (Owner as TIAeverMenu2).mainsemipercent>0 then
    begin
      FSemiBitmap:=TBitmap.Create;
      FSemiBitmap.PixelFormat:=pf24Bit;
      FSemiBitmap.Width:=0;
      FSemiBitmap.Height:=0;
    end;
  FFirst:=True;
  self.ControlStyle:=self.ControlStyle+[csOpaque];
end;
procedure TIAeverMenuMainWindow2.CreateHandle;
begin
  inherited CreateHandle;
  GetRectsInfo;//GetTextExtentPoint32
  left:=FRectsInfo.MainRect.left;
  top:=FRectsInfo.MainRect.top;
  width:=FRectsInfo.MainRect.right-FRectsInfo.MainRect.left;
  height:=FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top;
 // self.BoundsRect:=FRectsInfo.MainRect;
  SetRegion;
  if FMenuContent<>nil then FMenuContent.OnChange:=IChanged;
end;
constructor TIAeverMenuMainWindow2.CreateNew(AOwner: TComponent;var AMenuContent : TIAmenuList);
begin
  Create(AOwner);
  FMenuContent:=AMenuContent;

  Self.Canvas.Font:=(AOwner as TIAeverMenu2).MenuFont;

  self.parent:=((AOwner as TIAeverMenu2).owner as TWinControl);
  case (AOwner as TIAeverMenu2).MenuAlign of
    iaalTop : self.align:=alTop;
    iaalBottom : self.align:=alBottom;
    iaalRight : self.align:=alRight;
    iaalLeft : self.align:=alLeft;
    iaalNoneVertical,iaalNoneHorizontal : self.align:=alNone;
  end;
end;
destructor TIAeverMenuMainWindow2.Destroy;
begin
  if FTimed then
    begin
      if FTimer<>nil then
        begin
          FTimer.free;
          FTimer:=nil;
        end;
      FTimed:=false;
    end;
  if FMenuContent<>nil then FMenuContent.OnChange:=Nil;
  FMenuContent:=nil;
  (Owner as TIAeverMenu2).FMainWindow:=nil;
  FPaintBitmap.free;
  FSemiBitmap.free;
  FCurrentBackBitmap.free;
  inherited Destroy;
end;
function  TIAeverMenuMainWindow2.IsChanged: Boolean;
var i : integer;
    TempInfo : TIARectsInfo;
begin
  Tempinfo.MainRect:=FRectsInfo.MainRect;
  Tempinfo.ShowHiddenRect:=FRectsInfo.ShowHiddenRect;
  Tempinfo.HideHiddenRect:=FRectsInfo.HideHiddenRect;
  setlength(Tempinfo.Rects,length(FRectsInfo.rects));
  for i:=0 to length(FRectsInfo.rects)-1 do
    Tempinfo.Rects[i]:=FRectsInfo.rects[i];
  setlength(Tempinfo.Connected,length(FRectsInfo.Connected));
  for i:=0 to length(FRectsInfo.Connected)-1 do
    Tempinfo.Connected[i]:=FRectsInfo.Connected[i];
  GetRectsInfo;
  Result:=True;
  if Tempinfo.MainRect.Left<>FRectsInfo.MainRect.Left then Result:=false;
  if Tempinfo.MainRect.Top<>FRectsInfo.MainRect.Top then Result:=false;
  if Tempinfo.MainRect.Right<>FRectsInfo.MainRect.Right then Result:=false;
  if Tempinfo.MainRect.Bottom<>FRectsInfo.MainRect.Bottom then Result:=false;

  if Tempinfo.ShowHiddenRect.Left<>FRectsInfo.ShowHiddenRect.Left then Result:=false;
  if Tempinfo.ShowHiddenRect.Top<>FRectsInfo.ShowHiddenRect.Top then Result:=false;
  if Tempinfo.ShowHiddenRect.Right<>FRectsInfo.ShowHiddenRect.Right then Result:=false;
  if Tempinfo.ShowHiddenRect.Bottom<>FRectsInfo.ShowHiddenRect.Bottom then Result:=false;

  if Tempinfo.HideHiddenRect.Left<>FRectsInfo.HideHiddenRect.Left then Result:=false;
  if Tempinfo.HideHiddenRect.Top<>FRectsInfo.HideHiddenRect.Top then Result:=false;
  if Tempinfo.HideHiddenRect.Right<>FRectsInfo.HideHiddenRect.Right then Result:=false;
  if Tempinfo.HideHiddenRect.Bottom<>FRectsInfo.HideHiddenRect.Bottom then Result:=false;

  if length(FRectsInfo.rects)<>length(Tempinfo.rects) then Result:=false;
  for i:=0 to min(length(FRectsInfo.rects),length(Tempinfo.rects))-1 do
    begin
      if Tempinfo.Rects[i].Left<>FRectsInfo.rects[i].Left then Result:=false;
      if Tempinfo.Rects[i].Top<>FRectsInfo.rects[i].Top then Result:=false;
      if Tempinfo.Rects[i].Right<>FRectsInfo.rects[i].Right then Result:=false;
      if Tempinfo.Rects[i].Bottom<>FRectsInfo.rects[i].Bottom then Result:=false;
    end;
  if length(FRectsInfo.Connected)<>length(Tempinfo.Connected) then Result:=false;
  for i:=0 to min(length(FRectsInfo.Connected),length(Tempinfo.Connected))-1 do
    begin
      if Tempinfo.Connected[i]<>FRectsInfo.Connected[i] then Result:=false;
    end;

end;
procedure TIAeverMenuMainWindow2.SetCurrentBackBitmap(ANumberItem : integer;AConTinued: Boolean);
  var i : integer;
begin
  FCurrentBackBitmap.free;
  FCurrentBackBitmap:=nil;
  if AContinued then
    begin
      i:=ANumberItem;
      while (i>=0) and
            (FMenuContent.Items[i].Continued) and
            (FMenuContent.Items[i].BackBitmap=nil) do dec(i);
      if i>=0 then
        begin
          FCurrentBackBitmap:=TBitmap.Create;
          FCurrentBackBitmap.PixelFormat:=pf24bit;
          FCurrentBackBitmap.Width:=FMenuContent.Items[i].BackBitmap.Width;
          FCurrentBackBitmap.height:=FMenuContent.Items[i].BackBitmap.height;
          FCurrentBackBitmap.Canvas.Draw(0,0,FMenuContent.Items[i].BackBitmap);
        end;
    end else
    begin
      if FMenuContent.Items[ANumberItem].BackBitmap<>nil then
        begin
          FCurrentBackBitmap:=TBitmap.Create;
          FCurrentBackBitmap.PixelFormat:=pf24bit;
          FCurrentBackBitmap.Width:=FMenuContent.Items[ANumberItem].BackBitmap.Width;
          FCurrentBackBitmap.height:=FMenuContent.Items[ANumberItem].BackBitmap.height;
          FCurrentBackBitmap.Canvas.Draw(0,0,FMenuContent.Items[ANumberItem].BackBitmap);
        end;
    end;
end;
procedure TIAeverMenuMainWindow2.IChanged;
begin
  if not IsChanged then
    begin
      left:=FRectsInfo.MainRect.left;
      top:=FRectsInfo.MainRect.top;
      width:=FRectsInfo.MainRect.right-FRectsInfo.MainRect.left;
      height:=FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top;
    //  self.BoundsRect:=FRectsInfo.MainRect;
      SetRegion;
    end;
  Invalidate;
end;
procedure TIAeverMenuMainWindow2.WMLBUTTONDOWN(var Message : TMessage);
var TrySelectNumber : integer;
    Point1 : TPoint;
    i : integer;
    ARect : TRect;
    AHorizontal : Boolean;
begin
  inherited;
  Point1:=Point(Message.LParamLo,Message.LParamHi);
  TrySelectNumber:=-10;
  if ptinrect(FRectsInfo.ShowHiddenRect,Point1) then  TrySelectNumber:=-2;
  if ptinrect(FRectsInfo.HideHiddenRect,Point1) then  TrySelectNumber:=-1;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         ptinrect(FRectsInfo.Rects[i],Point1) then TrySelectNumber:=i;
    end;

      FSelectedRectNumber:=TrySelectNumber;
      case TrySelectNumber of
        -10 : begin Unselect; end;
        -2 : begin
               TryUnselect;
               OpenHiddenSelected:=true;
               FMenuContent.ShowHidden:=true;
               (Owner as TIAeverMenu2).ONMainSelectItem(nil,TRUE,Rect(0,0,0,0),TRUE,false);
             end;
        -1 : begin
               TryUnselect;
               CloseHiddenSelected:=true;
               FMenuContent.ShowHidden:=false;
               (Owner as TIAeverMenu2).ONMainSelectItem(nil,TRUE,Rect(0,0,0,0),TRUE,false);
             end;
        else begin
               if not FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected then
               begin
                 TryUnselect;
                 if FSelectedRectNumber<=(length(FRectsInfo.Rects)-1) then
                   Begin
                     FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected:=True;
                     GetRealLeftTOP;
                     ARect:=FrectsInfo.Rects[FSelectedRectNumber];
                     offsetRect(ARect,FrealLeft,FrealTop);
                     case (Owner as TIAeverMenu2).MenuAlign of
                       iaalTop,iaalBottom,iaalNoneHorizontal :  AHorizontal:=True;
                       else AHorizontal:=false;
                     end;
                     (Owner as TIAeverMenu2).ONMainSelectItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                              TRUE,ARect,AHorizontal,false);
                   end;
               end else
               begin
                  case (Owner as TIAeverMenu2).MenuAlign of
                       iaalTop,iaalBottom,iaalNoneHorizontal :  AHorizontal:=True;
                       else AHorizontal:=false;
                  end;     
                 (Owner as TIAeverMenu2).ONMainSelectItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                              TRUE,ARect,AHorizontal,True);
               end;
             end;
      end;
end;
procedure TIAeverMenuMainWindow2.WMLBUTTONDBLCLK(var Message : TMessage);
begin
  inherited;
  sendmessage(self.handle,WM_LBUTTONDOWN,Message.WParam,Message.LParam);
end;
procedure TIAeverMenuMainWindow2.WMMOUSEMOVE(var Message : TMessage);
begin
  inherited;
  if (not FTimed)  then
    begin
      FTimed:=TRUE;
      FTimer:=TTimer.Create(self);
      FTimer.OnTimer:=onFTimer;
      FTimer.Interval:=(Owner as TIAeverMenu2).FDelayTime;
      FTimer.Enabled:=True;
    end;
end;
procedure TIAeverMenuMainWindow2.onFTimer(Sender: TObject);
var TrySelectNumber,i : integer;
    Point1 : TPoint;
    ARect : TRect;
    AHorizontal : Boolean;
begin
  FTimer.free;
  FTimer:=nil;
  FTimed:=false;
  GetRealLeftTOP;
  Point1:=Point(Mouse.CursorPos.x-FrealLeft,Mouse.CursorPos.y-FrealTOP);
  TrySelectNumber:=-10;
  if ptinrect(FRectsInfo.ShowHiddenRect,Point1) then  TrySelectNumber:=-2;
  if ptinrect(FRectsInfo.HideHiddenRect,Point1) then  TrySelectNumber:=-1;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         ptinrect(FRectsInfo.Rects[i],Point1) then TrySelectNumber:=i;
    end;
      FSelectedRectNumber:=TrySelectNumber;
      case TrySelectNumber of
        -10 : begin Unselect; end;
        -2 : begin
               TryUnselect;
               OpenHiddenSelected:=true;
               (Owner as TIAeverMenu2).ONMainSelectItem(nil,false,Rect(0,0,0,0),TRUE,false);
             end;
        -1 : begin
               TryUnselect;
               CloseHiddenSelected:=true;
               (Owner as TIAeverMenu2).ONMainSelectItem(nil,false,Rect(0,0,0,0),TRUE,false);
             end;
        else begin
               if not FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected then
               begin
                 TryUnselect;
                 if FSelectedRectNumber<=(length(FRectsInfo.Rects)-1) then
                   Begin
                     FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected:=True;
                     GetRealLeftTOP;
                     ARect:=FrectsInfo.Rects[FSelectedRectNumber];
                     offsetRect(ARect,FrealLeft,FrealTop);
                     case (Owner as TIAeverMenu2).MenuAlign of
                       iaalTop,iaalBottom,iaalNoneHorizontal :  AHorizontal:=True;
                       else AHorizontal:=false;
                     end;
                     (Owner as TIAeverMenu2).ONMainSelectItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                              false,ARect,AHorizontal,false);
                   end;
               end;
             end;
      end;
end;
procedure TIAeverMenuMainWindow2.TryUnselect;
var i : integer;
begin
  if FSelectedRectNumber<>-2 then OpenHiddenSelected:=false;
  if FSelectedRectNumber<>-1 then CloseHiddenSelected:=false;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         (FSelectedRectNumber<>i) and (FMenuContent.Items[FrectsInfo.Connected[i]].SubMenuList=nil) then
         FMenuContent.Items[FrectsInfo.Connected[i]].selected:=false;
    end;
end;
procedure TIAeverMenuMainWindow2.Unselect;
var i : integer;
begin
  OpenHiddenSelected:=false;
  CloseHiddenSelected:=false;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
          (FMenuContent.Items[FrectsInfo.Connected[i]].SubMenuList=nil) then
         FMenuContent.Items[FrectsInfo.Connected[i]].selected:=false;
    end;
end;
procedure TIAeverMenuMainWindow2.GetRealLeftTOP;
begin
  FRealLeft:=Left+Self.Parent.ClientOrigin.x;FRealTOP:=TOP+Self.Parent.ClientOrigin.y;
end;
procedure TIAeverMenuMainWindow2.SetOpenHiddenSelected(Value : Boolean);
begin
  if Value<>FOpenHiddenSelected then
    begin
      FOpenHiddenSelected:=Value;
      IChanged;
      invalidate;
    end;
end;
procedure TIAeverMenuMainWindow2.SetCloseHiddenSelected(Value : Boolean);
begin
  if Value<>FCloseHiddenSelected then
    begin
      FCloseHiddenSelected:=Value;
      IChanged;
      invalidate;
    end;
end;
procedure TIAeverMenuMainWindow2.DrawBitmap;
begin
  FPaintBitmap.Width:=Width;
  FPaintBitmap.Height:=height;
  case (Owner as TIAeverMenu2).MenuKind of
    mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
      begin
        PaintmtSimple;
      end;
  end;
end;
procedure TIAeverMenuMainWindow2.GetSemiBitmaps;
var i,j : integer;
    P1,P2 : PByteArray;
    TempBitmap : TBitmap;
begin
  if (Owner as TIAeverMenu2).mainsemipercent>0 then
    begin
      FSemiBitmap.Width:=self.Width;
      FSemiBitmap.Height:=self.Height;
      TempBitmap:=TBitmap.Create;
      TempBitmap.PixelFormat:=pf24bit;
      TempBitmap.Width:=width+left;
      TempBitmap.Height:=height+top;
      TempBitmap.Canvas.brush.color:=TPanel(Parent).color;
      TempBitmap.Canvas.FillRect(rect(0,0,TempBitmap.width,TempBitmap.height));
      sendmessage(parent.handle,WM_PAINT,TempBitmap.canvas.handle,0);
      FSemiBitmap.Canvas.Draw(-left,-top,TempBitmap);

      TempBitmap.free;
      for i:=0 to height-1 do
        begin
          P1:=FPaintBitmap.ScanLine[i];P2:=FSemiBitmap.ScanLine[i];
          for j:=0 to width*3-1 do
            begin
              P1[j]:=P1[j]+(P2[j]-P1[j])*(Owner as TIAeverMenu2).mainsemipercent div 100;
            end;
        end;
    end;
end;
procedure TIAeverMenuMainWindow2.Paint;
begin
 // inherited Paint;
  if Not FFirst then
  begin
    if Assigned(FPaintBitmap) then
    begin
    Canvas.Draw(0,0,FPaintBitmap);
    DrawBitmap;
    Canvas.Draw(0,0,FPaintBitmap);
    end;
  end else
  begin
    FFirst:=False;
    if Assigned(FPaintBitmap) then
    begin
    DrawBitmap;
    Canvas.Draw(0,0,FPaintBitmap);
    end;
  end;
end;
procedure TIAeverMenuMainWindow2.PaintmtSimple;
begin
  DrawBackmtSimple;
  DrawItemsmtSimple;
  DrawHiddenRectsmtSimple;
//  GetSemiBitmaps;

end;
procedure TIAeverMenuMainWindow2.DrawHiddenRectsmtSimple;
var
  dh,dx,dy : integer;
begin
  //Draw Close REct
  if (FRectsInfo.HideHiddenRect.Right-FRectsInfo.HideHiddenRect.Left)*(FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top)<>0 then
    begin
      dh:=Min(FRectsInfo.HideHiddenRect.Right-FRectsInfo.HideHiddenRect.Left,
              FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top) div 2-2;
      dx:=(FRectsInfo.HideHiddenRect.Right-FRectsInfo.HideHiddenRect.Left-dh) div 2;
      dy:=(FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top-dh) div 2;
      case (Owner as TIAeverMenu2).MenuAlign of
        iaalTop,iaalBottom,iaalNoneHorizontal :
          begin
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
              FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx-1,FRectsInfo.HideHiddenRect.top+dy-1);
              FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                            (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-dx-1,FRectsInfo.HideHiddenRect.Bottom-dy-1);
              FPaintBitmap.Canvas.MoveTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                             FRectsInfo.HideHiddenRect.top+dy-1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left+dx-1,
                            (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
              FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                             FRectsInfo.HideHiddenRect.Bottom-dy-1);
            end;
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
              FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx+1,FRectsInfo.HideHiddenRect.top+dy+1);
              FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                            (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-dx+1,FRectsInfo.HideHiddenRect.Bottom-dy+1);
              FPaintBitmap.Canvas.MoveTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                             FRectsInfo.HideHiddenRect.top+dy+1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left+dx+1,
                            (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
              FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                             FRectsInfo.HideHiddenRect.Bottom-dy+1);
            end;
            if FCloseHiddenSelected then
            FPaintBitmap.Canvas.pen.color:=(Owner as TIAeverMenu2).selectfontcolor else
            FPaintBitmap.Canvas.pen.color:=GetLColor(FPaintBitmap.Canvas.font.color);
            FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx,FRectsInfo.HideHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-dx,FRectsInfo.HideHiddenRect.Bottom-dy);
            FPaintBitmap.Canvas.MoveTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                           FRectsInfo.HideHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left+dx,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                           FRectsInfo.HideHiddenRect.Bottom-dy);
          end;
        iaalLeft,iaalRight,iaalNoneVertical :
          begin
             if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                          FRectsInfo.HideHiddenRect.top+dy-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx-1,
                          FRectsInfo.HideHiddenRect.Bottom-dy-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx-1,
                          FRectsInfo.HideHiddenRect.Bottom-dy-1);
            end;
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx+1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                          FRectsInfo.HideHiddenRect.top+dy+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx+1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx+1,
                          FRectsInfo.HideHiddenRect.Bottom-dy+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx+1,
                          FRectsInfo.HideHiddenRect.Bottom-dy+1);
            end;
            if FCloseHiddenSelected then
            FPaintBitmap.Canvas.pen.color:=(Owner as TIAeverMenu2).selectfontcolor else
            FPaintBitmap.Canvas.pen.color:=GetLColor(FPaintBitmap.Canvas.font.color);
            FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                          FRectsInfo.HideHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx,
                          FRectsInfo.HideHiddenRect.Bottom-dy);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx,
                          FRectsInfo.HideHiddenRect.Bottom-dy);
          end;
      end;
      FPaintBitmap.Canvas.pen.Width:=1;
      if FCloseHiddenSelected then
        begin
          FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).SelectColor);
          FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.top);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-1,FRectsInfo.HideHiddenRect.top);
          FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).SelectColor);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.right-1,FRectsInfo.HideHiddenRect.Bottom-1);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
        end;
    end;
   //Draw Open REct
  if (FRectsInfo.ShowHiddenRect.Right-FRectsInfo.ShowHiddenRect.Left)*(FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top)<>0 then
    begin
      dh:=Min(FRectsInfo.ShowHiddenRect.Right-FRectsInfo.ShowHiddenRect.Left,
              FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top) div 2-2;
      dx:=(FRectsInfo.ShowHiddenRect.Right-FRectsInfo.ShowHiddenRect.Left-dh) div 2;
      dy:=(FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top-dh) div 2;
      case (Owner as TIAeverMenu2).MenuAlign of
        iaalTop,iaalBottom,iaalNoneHorizontal :
          begin
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
              FPaintBitmap.Canvas.MoveTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          FRectsInfo.ShowHiddenRect.top+dy-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          FRectsInfo.ShowHiddenRect.Bottom-dy-1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left+dx-1,
                           FRectsInfo.ShowHiddenRect.top+dy-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left+dx-1,
                           FRectsInfo.ShowHiddenRect.Bottom-dy-1);
            end;
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
              FPaintBitmap.Canvas.MoveTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          FRectsInfo.ShowHiddenRect.top+dy+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          FRectsInfo.ShowHiddenRect.Bottom-dy+1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left+dx+1,
                           FRectsInfo.ShowHiddenRect.top+dy+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left+dx+1,
                           FRectsInfo.ShowHiddenRect.Bottom-dy+1);
            end;
            if FOpenHiddenSelected then
            FPaintBitmap.Canvas.pen.color:=(Owner as TIAeverMenu2).selectfontcolor else
            FPaintBitmap.Canvas.pen.color:=GetLColor(FPaintBitmap.Canvas.font.color);
            FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          FRectsInfo.ShowHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          FRectsInfo.ShowHiddenRect.Bottom-dy);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left+dx,
                           FRectsInfo.ShowHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left+dx,
                           FRectsInfo.ShowHiddenRect.Bottom-dy);
          end;
        iaalLeft,iaalRight,iaalNoneVertical :
          begin
             if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          FRectsInfo.ShowHiddenRect.bottom-dy-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx-1,
                          FRectsInfo.ShowHiddenRect.top+dy-1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx-1,
                          FRectsInfo.ShowHiddenRect.top+dy-1);
            end;
            if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          FRectsInfo.ShowHiddenRect.bottom-dy+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx+1,
                          FRectsInfo.ShowHiddenRect.top+dy+1);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx+1,
                          FRectsInfo.ShowHiddenRect.top+dy+1);
            end;
            if FOpenHiddenSelected then
            FPaintBitmap.Canvas.pen.color:=(Owner as TIAeverMenu2).selectfontcolor else
            FPaintBitmap.Canvas.pen.color:=GetLColor(FPaintBitmap.Canvas.font.color);
            FPaintBitmap.Canvas.pen.Width:=2;
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          FRectsInfo.ShowHiddenRect.bottom-dy);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx,
                          FRectsInfo.ShowHiddenRect.top+dy);
            FPaintBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
            FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx,
                          FRectsInfo.ShowHiddenRect.top+dy);
          end;
      end;
      FPaintBitmap.Canvas.pen.Width:=1;
      if FOpenHiddenSelected then
        begin
          FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).SelectColor);
          FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.top);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-1,FRectsInfo.ShowHiddenRect.top);
          FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).SelectColor);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.right-1,FRectsInfo.ShowHiddenRect.Bottom-1);
          FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
        end; 
    end;
end;
procedure TIAeverMenuMainWindow2.DrawItemsmtSimple;
var
  i,Maxw,j,k,dx,dy,BarIndex : integer;
  TR,TG,TB : BYTE;
  TeBit,TeBit1 : TBitmap;
  P1,P2 : PByteArray;
  RGN : HRGN;
  FCol : TColor;
  TempFont : tfont;
  MyFont,oldfont : HFONT;
  MyLFont : LOGFONT;
  DC : HDC;
  SZ : TSize;
  TtBMP,IGap,GapBar,BTtBMP : integer;
begin
  case (Owner as TIAeverMenu2).menuKind of
    mkRects :
      begin
        GapBar := mtRBargap;
        TtBMP := mtRTexttoBMP;
        IGap  := mtRItemGap;
        BTtBMP :=mtRBarTexttoBMP;
      end;
    mkWide,mkWideCorner :
      begin
        GapBar := mtEBargap;
        TtBMP := mtETexttoBMP;
        IGap  := mtEItemGap;
        BTtBMP :=mtEBarTexttoBMP;
      end;
    mkSimple,mkSimpleCorner :
      begin
        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
    else
      begin
        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
  end;
  //==
  maxW:=-TtBMP; //TtBMP,IGap,GapBar,BTtBMP
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil) and
          (not FMenuContent[FRectsInfo.Connected[i]].Splitter)then
      Maxw:=Max(MaxW,FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width);
    end;
  //draw BackBitmaps...
  FPaintBitmap.Canvas.Draw(0,0,FPaintBitmap);
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      SetCurrentBackBitmap(FRectsInfo.Connected[i],FMenuContent[FRectsInfo.Connected[i]].Continued);
      if FCurrentBackBitmap<>nil then
        begin
          if FMenuContent[FRectsInfo.Connected[i]].Stretch then
            begin


              RGN:=CreateRectRGN(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top,FRectsInfo.Rects[i].Right,FRectsInfo.Rects[i].Bottom);
              selectClipRGN(FPaintBitmap.Canvas.handle,RGN);

              StretchBlt(FPaintBitmap.canvas.handle,FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top,
                         FRectsInfo.Rects[i].Right-FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].top,
                         FCurrentBackBitmap.Canvas.handle,0,0,FCurrentBackBitmap.Width-1,FCurrentBackBitmap.Height-1,SRCCOPY);
            //  FPaintBitmap.Canvas.CopyRect(FRectsInfo.Rects[i],FCurrentBackBitmap.Canvas,
            //  Rect(0,0,FCurrentBackBitmap.Width,FCurrentBackBitmap.Height));


              selectClipRGN(FPaintBitmap.Canvas.handle,0);
              deleteobject(RGN);
            end else
            begin
              RGN:=CreateRectRGN(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top,FRectsInfo.Rects[i].Right,FRectsInfo.Rects[i].Bottom);
              selectClipRGN(FPaintBitmap.Canvas.handle,RGN);
              for j:=0 to (FRectsInfo.Rects[i].right-FRectsInfo.Rects[i].left) div
                          FCurrentBackBitmap.Width   do
                for k:=0 to (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].top) div
                            FCurrentBackBitmap.height   do
                  FPaintBitmap.Canvas.Draw(FRectsInfo.Rects[i].left+FCurrentBackBitmap.Width*j,
                                           FRectsInfo.Rects[i].top+FCurrentBackBitmap.height*k,
                                           FCurrentBackBitmap);
              selectClipRGN(FPaintBitmap.Canvas.handle,0);
              deleteobject(RGN);
            end;
        end;
    end;
  if (Owner as TIAeverMenu2).menuKind =  mkRects then
    for i:=0 to length(FRectsInfo.Rects)-1 do
      begin
        FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
        FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
        FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top);
        FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].Right-1,FRectsInfo.Rects[i].top);
        FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
        FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].Bottom-1);
        FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
      end;
  if (Owner as TIAeverMenu2).menuKind =  mkRects then
    begin
      FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
      FPaintBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.top);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-1,FRectsInfo.ShowHiddenRect.top);
      FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.right-1,FRectsInfo.ShowHiddenRect.Bottom-1);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
    end;
  if (Owner as TIAeverMenu2).menuKind =  mkRects then
    begin
      FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
      FPaintBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.top);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-1,FRectsInfo.HideHiddenRect.top);
      FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.right-1,FRectsInfo.HideHiddenRect.Bottom-1);
      FPaintBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
    end;
  //______________!!!!!!SemiTransparence

  GetSemiBitmaps;

  //______________!!!!!!

  //draw Bitmaps...


  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if FMenuContent[FRectsInfo.Connected[i]].Splitter then
        begin
          if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
            begin
              if FMenuContent[FRectsInfo.Connected[i]].transparent then
                begin
                  TeBit:=TBitmap.Create;
                  TeBit.PixelFormat:=pf24Bit;
                  TeBit.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                  TeBit.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                  TeBit1:=TBitmap.Create;
                  TeBit1.PixelFormat:=pf24Bit;
                  TeBit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                  TeBit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                  TeBit1.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                  TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                 rect(
                     FRectsInfo.Rects[i].left+
                    (FRectsInfo.Rects[i].Right-FRectsInfo.Rects[i].left-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2,
                     FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                    FRectsInfo.Rects[i].left+
                    (FRectsInfo.Rects[i].Right-FRectsInfo.Rects[i].left-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2
                                      +TeBit.Width,
                    FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2
                                      +TeBit.Height));
                  TR:=0;TG:=0;TB:=0;                    
                  for j:=0 to TeBit.height-1 do
                    begin
                      P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                      if j=0 then
                        begin
                          TR:=P2[0];TG:=P2[1];TB:=P2[2];
                        end;
                      for k:=0 to TeBit.Width-1 do
                        begin

                          if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                            begin
                              P1[k*3]:=P2[k*3];
                              P1[k*3+1]:=P2[k*3+1];
                              P1[k*3+2]:=P2[k*3+2];
                            end;
                        end;
                    end;
                  FPaintBitmap.Canvas.Draw(
                  FRectsInfo.Rects[i].left+
                    (FRectsInfo.Rects[i].Right-FRectsInfo.Rects[i].left-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2,
                  FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                  TeBit);
                  TeBit.Free;
                  TeBit1.Free;
                end else
                begin
                  FPaintBitmap.Canvas.Draw(FRectsInfo.Rects[i].left+
                    (FRectsInfo.Rects[i].Right-FRectsInfo.Rects[i].left-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2,
                              FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                              FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                end;
            end;
        end else//Splitter
        begin
          if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
            begin
              if FMenuContent[FRectsInfo.Connected[i]].transparent then
                begin
                  TeBit:=TBitmap.Create;
                  TeBit.PixelFormat:=pf24Bit;
                  TeBit.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                  TeBit.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                  TeBit1:=TBitmap.Create;
                  TeBit1.PixelFormat:=pf24Bit;
                  TeBit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                  TeBit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                  TeBit1.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                  TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                 rect(
                     FRectsInfo.Rects[i].left+IGap,  //TtBMP,IGap,GapBar,BTtBMP
                     FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                    FRectsInfo.Rects[i].left+IGap
                                      +TeBit.Width,
                    FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2
                                      +TeBit.Height));
                  TR:=0;TG:=0;TB:=0;                    
                  for j:=0 to TeBit.height-1 do
                    begin
                      P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                      if j=0 then
                        begin
                          TR:=P2[0];TG:=P2[1];TB:=P2[2];
                        end;
                      for k:=0 to TeBit.Width-1 do
                        begin

                          if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                            begin
                              P1[k*3]:=P2[k*3];
                              P1[k*3+1]:=P2[k*3+1];
                              P1[k*3+2]:=P2[k*3+2];
                            end;
                        end;
                    end;
                  FPaintBitmap.Canvas.Draw(
                  FRectsInfo.Rects[i].left+IGap,
                  FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                  TeBit);
                  TeBit.Free;
                  TeBit1.Free;
                end else
                begin
                  FPaintBitmap.Canvas.Draw(FRectsInfo.Rects[i].left+IGap,
                              FRectsInfo.Rects[i].Top+
                    (FRectsInfo.Rects[i].Bottom-FRectsInfo.Rects[i].Top-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height) div 2,
                              FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                end;
            end;
        end;
    end;
  //Draw Text Entires...
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if not (FMenuContent[FRectsInfo.Connected[i]].Splitter) then
        begin
          if FMenuContent[FRectsInfo.Connected[i]].Grayed then
            begin
              FCol:=(Owner as TIAeverMenu2).GrayColor;
            end else
            begin
              FCol:=(Owner as TIAeverMenu2).menufont.Color;
            end;
          FPaintBitmap.Canvas.Brush.Style:=bsClear;

          if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.Font.Color:=GetDColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.Font.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
              case (Owner as TIAeverMenu2).MenuAlign of
                iaalTop,iaalBottom,iaalNoneHorizontal : //TtBMP,IGap,GapBar,BTtBMP
                  begin
                    dx:=IGap;dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
                    if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil
                      then dx:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width+TtBMP+IGap;
                    FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx-1,FRectsInfo.Rects[i].top+dy-1,FMenuContent[FRectsInfo.Connected[i]].ItemName);
                  end;
                iaalLeft,iaalRight,iaalNoneVertical :
                  begin
                    dx:=maxW+IGap+TtBMP;
                    dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
                    FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx-1,FRectsInfo.Rects[i].top+dy-1,FMenuContent[FRectsInfo.Connected[i]].ItemName);
                  end;
              end;
          end;

          if (Owner as TIAeverMenu2).Font3DStyle<>iafsPlain then
            begin
              if (Owner as TIAeverMenu2).Font3DStyle=iafsPressed
                then  FPaintBitmap.Canvas.Font.Color:=GetLColor((Owner as TIAeverMenu2).BackColor)
                else  FPaintBitmap.Canvas.Font.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
              case (Owner as TIAeverMenu2).MenuAlign of
                iaalTop,iaalBottom,iaalNoneHorizontal :
                  begin
                    dx:=IGap;dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
                    if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil
                    then dx:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width+TtBMP+IGap;
                    FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx+1,FRectsInfo.Rects[i].top+dy+1,FMenuContent[FRectsInfo.Connected[i]].ItemName);
                  end;
                iaalLeft,iaalRight,iaalNoneVertical :
                  begin
                    dx:=maxW+IGap+TtBMP;
                    dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
                    FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx+1,FRectsInfo.Rects[i].top+dy+1,FMenuContent[FRectsInfo.Connected[i]].ItemName);
                  end;
              end;
          end;
            if (FMenuContent[FRectsInfo.Connected[i]].selected)  and
               (not FMenuContent[FRectsInfo.Connected[i]].grayed) then
               FPaintBitmap.Canvas.Font.Color:=(Owner as TIAeverMenu2).selectfontcolor else
               FPaintBitmap.Canvas.Font.Color:=FCol;
          case (Owner as TIAeverMenu2).MenuAlign of
          iaalTop,iaalBottom,iaalNoneHorizontal :
            begin
              dx:=IGap;dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
              if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil
                then dx:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width+TtBMP+IGap;
              FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx,FRectsInfo.Rects[i].top+dy,FMenuContent[FRectsInfo.Connected[i]].ItemName);
            end;
          iaalLeft,iaalRight,iaalNoneVertical :
            begin
              dx:=maxW+TtBMP+IGap;
              dy:=(FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top-abs(FPaintBitmap.Canvas.Font.Size)) div 2-abs(FPaintBitmap.Canvas.Font.Size) div 4;
              FPaintBitmap.Canvas.TextOut(FRectsInfo.Rects[i].left+dx,FRectsInfo.Rects[i].top+dy,FMenuContent[FRectsInfo.Connected[i]].ItemName);
            end;
          end;
          FPaintBitmap.Canvas.Brush.Style:=bsSolid;
          FPaintBitmap.Canvas.Font.Color:=(Owner as TIAeverMenu2).menufont.Color
        end;
    end;
  //Draw Default Selctor if not defined custom
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (FMenuContent[FRectsInfo.Connected[i]].Splitter) and (FMenuContent[FRectsInfo.Connected[i]].MainBitmap=nil) then
        begin
          case (Owner as TIAeverMenu2).MenuAlign of
            iaalTop,iaalBottom,iaalNoneHorizontal :
              begin  //TtBMP,IGap,GapBar,BTtBMP
                FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left+IGap,FRectsInfo.Rects[i].top);
                if (Owner as TIAeverMenu2).Font3DStyle=iafsRelief then
                FPaintBitmap.Canvas.pen.color:=GetLColor((Owner as TIAeverMenu2).BackColor) else
                FPaintBitmap.Canvas.pen.color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left+IGap,FRectsInfo.Rects[i].bottom);
                FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left+IGap+1,FRectsInfo.Rects[i].top);
                if (Owner as TIAeverMenu2).Font3DStyle=iafsRelief then
                FPaintBitmap.Canvas.pen.color:=GetDColor((Owner as TIAeverMenu2).BackColor) else
                FPaintBitmap.Canvas.pen.color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left+IGap+1,FRectsInfo.Rects[i].bottom);
              end;
            iaalLeft,iaalRight,iaalNoneVertical :
              begin
                FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap);
                if (Owner as TIAeverMenu2).Font3DStyle=iafsRelief then
                FPaintBitmap.Canvas.pen.color:=GetLColor((Owner as TIAeverMenu2).BackColor) else
                FPaintBitmap.Canvas.pen.color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].right,FRectsInfo.Rects[i].top+IGap);
                FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap+1);
                if (Owner as TIAeverMenu2).Font3DStyle=iafsRelief then
                FPaintBitmap.Canvas.pen.color:=GetDColor((Owner as TIAeverMenu2).BackColor) else
                FPaintBitmap.Canvas.pen.color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].right,FRectsInfo.Rects[i].top+IGap+1);
              end;
          end;
        end;
    end;
  //Draw Frames...
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if not (FMenuContent[FRectsInfo.Connected[i]].Splitter) and not (FMenuContent[FRectsInfo.Connected[i]].Grayed) then
        begin
          if FMenuContent[FRectsInfo.Connected[i]].Selected then
            begin
              FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).SelectColor);
              FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].Right-1,FRectsInfo.Rects[i].top);
              FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).SelectColor);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].Bottom-1);
              FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
            end else //Selected...
            begin
              if FMenuContent[FRectsInfo.Connected[i]].Hidden then
                begin
                  FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
                  FPaintBitmap.Canvas.MoveTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
                  FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top);
                  FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].Right-1,FRectsInfo.Rects[i].top);
                  FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
                  FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].Bottom-1);
                  FPaintBitmap.Canvas.LineTo(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].bottom-1);
                end;
            end;
        end;
    end;
  //++++++++++++++++++++++++here we draw the bar...
  if (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0 then
     begin                             //TtBMP,IGap,GapBar,BTtBMP
       RGN:=CreateRectRGN(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.top+GapBar,
                          FRectsInfo.BarRect.right-GapBar,FRectsInfo.BarRect.bottom-GapBar);
       selectClipRGN(FPaintBitmap.canvas.handle,RGN);
       BarIndex:=0;
       case (Owner as TIAeverMenu2).MenuAlign of
         iaalTop,iaalBottom,iaalNoneHorizontal :
           begin
             case FMenuContent.BarPosition of
                 iabpMain,iabpAlternate1 : BarIndex:=0;
                 iabpAlternate2          : BarIndex:=1;
             end;
           end;
         iaalLeft :
           begin
             case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=3;
                 iabpAlternate1,iabpAlternate2 : BarIndex:=0;
             end;
           end;
         iaalRight :
           begin
             case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=2;
                 iabpAlternate1,iabpAlternate2 : BarIndex:=0;
             end;
           end;  
         iaalNoneVertical :
           begin
             case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=3;
                 iabpAlternate1                : BarIndex:=2;
                 iabpAlternate2                : BarIndex:=0;
             end;
           end;  
       end; 

            case BarIndex of
              0 :
                begin//=====
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                         rect(FRectsInfo.BarRect.left+GapBar,//TtBMP,IGap,GapBar,BTtBMP,
                                              ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                                              FRectsInfo.BarRect.left+GapBar+FMenuContent.BarMainBitmap.Width,
                                              (FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2+FMenuContent.BarMainBitmap.Height div 2));
                          TR:=0;TG:=0;TB:=0;                    
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FPaintBitmap.Canvas.Draw(
                            FRectsInfo.BarRect.left+GapBar,
                            ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                            TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FPaintBitmap.Canvas.Draw(FRectsInfo.BarRect.left+GapBar,

                            ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                                      FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FPaintBitmap.Canvas.font);
                      FPaintBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FPaintBitmap.Canvas.brush.Style:=bsClear;
                      if FMenuContent.BarMainBitmap<>nil then //TtBMP,IGap,GapBar,BTtBMP,
                        begin


                          FPaintBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar+BTtBMP+FMenuContent.BarMainBitmap.width,
                                                   
                                                   (FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2-
                                                   3*abs(FPaintBitmap.Canvas.font.size) div 4,
                                                   FMenuContent.BarText);



                        end else
                        begin
                          FPaintBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.top+GapBar,FMenuContent.BarText);
                        end;
                      FPaintBitmap.Canvas.brush.Style:=bsSolid;
                      FPaintBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;//=======
         1 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar));//TtBMP,IGap,GapBar,BTtBMP,
                          TR:=0;TG:=0;TB:=0;
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FPaintBitmap.Canvas.font);
                      FPaintBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FPaintBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FPaintBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=900;
                      MyLFont.lfOrientation:=900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FPaintBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then  //TtBMP,IGap,GapBar,BTtBMP,
                        begin


                          FPaintBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2-
                                                      3*abs(FPaintBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.bottom-GapBar-BTtBMP-FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else
                        begin
                          FPaintBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.bottom-GapBar,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FPaintBitmap.Canvas.brush.Style:=bsSolid;
                      FPaintBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
      2 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);    //TtBMP,IGap,GapBar,BTtBMP,
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar+FMenuContent.BarMainBitmap.height));
                          TR:=0;TG:=0;TB:=0;
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FPaintBitmap.Canvas.font);
                      FPaintBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FPaintBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FPaintBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=-900;
                      MyLFont.lfOrientation:=-900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FPaintBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then //TtBMP,IGap,GapBar,BTtBMP,
                        begin


                          FPaintBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2+
                                                      3*abs(FPaintBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.top+GapBar+BTtBMP+FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else
                        begin
                          FPaintBitmap.Canvas.TextOut(FRectsInfo.BarRect.right-GapBar,FRectsInfo.BarRect.top+GapBar,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FPaintBitmap.Canvas.brush.Style:=bsSolid;
                      FPaintBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
     3 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FPaintBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar+FMenuContent.BarMainBitmap.height));
                          TR:=0;TG:=0;TB:=0;  //TtBMP,IGap,GapBar,BTtBMP,
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FPaintBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FPaintBitmap.Canvas.font);
                      FPaintBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      Sz.cx:=0;Sz.cy:=0;
                      if  FMenuContent.BarText<>'' then
                      GetTextExtentPoint32(FPaintBitmap.Canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
                      FPaintBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FPaintBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=900;
                      MyLFont.lfOrientation:=900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FPaintBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then  //TtBMP,IGap,GapBar,BTtBMP,
                        begin


                          FPaintBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2-
                                                      3*abs(FPaintBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.top+GapBar+BTtBMP
                                                      +sz.cx+FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else
                        begin
                          FPaintBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.top+GapBar+sz.cx,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FPaintBitmap.Canvas.brush.Style:=bsSolid;
                      FPaintBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
            end;

       selectClipRGN(FPaintBitmap.canvas.handle,0);
       deleteobject(RGN);
     end;
end;
procedure TIAeverMenuMainWindow2.DrawBackmtSimple;
var B : TBitmap;
    i,j : integer;
    RGN : HRGN;
begin
  //Here we draw the back of menu...
  FPaintBitmap.Canvas.Brush.Color:=(Owner as TIAeverMenu2).BackColor;
  FPaintBitmap.Canvas.FillRect(ClientRect);

         if FMenuContent.BackBitmap<>nil then
           begin
             B:=TBitmap.Create;
             B.PixelFormat:=pf24bit;
             if FMenuContent.MainBackStretch then
               begin
                 B.Width:=FRectsInfo.MainRect.Right-FRectsInfo.MainRect.Left;
                 B.Height:=FRectsInfo.MainRect.Bottom-FRectsInfo.MainRect.Top;
                 B.Canvas.StretchDraw(Rect(0,0,B.Width,B.Height),FMenuContent.BackBitmap);
               end else
               begin
                 B.Width:=FMenuContent.BackBitmap.Width;
                 B.Height:=FMenuContent.BackBitmap.Height;
                 B.Canvas.Draw(0,0,FMenuContent.BackBitmap);
               end;
             for i:=0 to width div B.Width do
               for j:=0 to height div B.Height do
                 FPaintBitmap.Canvas.Draw(i*B.width,j*B.height,B);
             B.free;
           end;

         FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
         FPaintBitmap.Canvas.MoveTo(0,Height-1);
         FPaintBitmap.Canvas.LineTo(0,0);
         FPaintBitmap.Canvas.LineTo(Width-1,0);
         FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
         FPaintBitmap.Canvas.LineTo(Width-1,Height-1);
         FPaintBitmap.Canvas.LineTo(0,Height-1);

   if (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0 then
     begin
       RGN:=CreateRectRGN(FRectsInfo.BarRect.left,FRectsInfo.BarRect.top,FRectsInfo.BarRect.right,FRectsInfo.BarRect.bottom);
       selectClipRGN(FPaintBitmap.canvas.handle,RGN);
       if (FMenuContent.BarBackBitmap<>nil) then
         begin
           if FMenuContent.BarStretch then
             begin
               FPaintBitmap.canvas.StretchDraw(FRectsInfo.BarRect,FMenuContent.BarBackBitmap);
             end else
             begin
               for i:=0 to (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left) div FMenuContent.BarBackBitmap.width  do
                 for j:=0 to (FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top) div FMenuContent.BarBackBitmap.height do
                   FPaintBitmap.Canvas.Draw(FRectsInfo.BarRect.left+i*FMenuContent.BarBackBitmap.width,
                                            FRectsInfo.BarRect.top+j*FMenuContent.BarBackBitmap.height,
                                            FMenuContent.BarBackBitmap);
             end;
         end;
         FPaintBitmap.Canvas.pen.Color:=GetDColor((Owner as TIAeverMenu2).BackColor);
         FPaintBitmap.Canvas.MoveTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.bottom-1);
         FPaintBitmap.Canvas.LineTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.top);
         FPaintBitmap.Canvas.LineTo(FRectsInfo.BarRect.right-1,FRectsInfo.BarRect.top);
         FPaintBitmap.Canvas.pen.Color:=GetLColor((Owner as TIAeverMenu2).BackColor);
         FPaintBitmap.Canvas.LineTo(FRectsInfo.BarRect.right-1,FRectsInfo.BarRect.bottom-1);
         FPaintBitmap.Canvas.LineTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.bottom-1);
       selectClipRGN(FPaintBitmap.canvas.handle,0);
       deleteobject(RGN);
     end;
end;
procedure TIAeverMenuMainWindow2.SetRegion;
var
  R : HRGN;
begin
  R:=GetCurrentRegion;
  SetWindowRgn(Handle,R,TRUE);
end;
function TIAeverMenuMainWindow2.GetCurrentRegion: HRGN;
var CW,CH,i : integer;
    R1 : HRGN;
begin
  Result:=NULLREGION;
  CW:=parent.clientWidth;CH:=parent.clientHeight;//parent.client
  case (Owner as TIAeverMenu2).MenuKind of
    mkRects :
      begin
        Result:=CreateRectRGn(0,0,0,0);
        for i:=0 to length(FRectsinfo.Rects)-1 do
          begin
            R1:=CreateRectRGN(FRectsinfo.Rects[i].left,FRectsinfo.Rects[i].top,
                              FRectsinfo.Rects[i].right,FRectsinfo.Rects[i].bottom);
            CombineRGN(Result,Result,R1,RGN_OR);
            DeleteObject(R1);
          end;
        R1:=CreateRectRGN(FRectsinfo.BarRect.left,FRectsinfo.BarRect.top,
                          FRectsinfo.BarRect.right,FRectsinfo.BarRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FRectsinfo.ShowHiddenRect.left,FRectsinfo.ShowHiddenRect.top,
                          FRectsinfo.ShowHiddenRect.right,FRectsinfo.ShowHiddenRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FRectsinfo.HideHiddenRect.left,FRectsinfo.HideHiddenRect.top,
                          FRectsinfo.HideHiddenRect.right,FRectsinfo.HideHiddenRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        case (Owner as TIAeverMenu2).MenuAlign of
          iaalTop,iaalBottom :
            begin
              R1:=CreateRectRGN(0,0,CW,FRectsInfo.MainRect.Bottom);
            end;
          iaalLeft,iaalRight :
            begin
              R1:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,CH);
            end;
          iaalNoneHorizontal:
            begin
              R1:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,FRectsInfo.MainRect.Bottom);
            end;
          iaalNoneVertical :
            begin
              R1:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,FRectsInfo.MainRect.Bottom);
            end;
        end;//Menualign
        CombineRGN(Result,Result,R1,RGN_AND);
        DeleteObject(R1);
      end;
    mkSimple,mkWide,mkSimpleCorner,mkWideCorner :
      begin
        case (Owner as TIAeverMenu2).MenuAlign of
          iaalTop,iaalBottom :
            begin
              Result:=CreateRectRGN(0,0,CW,FRectsInfo.MainRect.Bottom);
            end;
          iaalLeft,iaalRight :
            begin
              Result:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,CH);
            end;
          iaalNoneHorizontal:
            begin
              Result:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,FRectsInfo.MainRect.Bottom);
            end;
          iaalNoneVertical :
            begin
              Result:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,FRectsInfo.MainRect.Bottom);
            end;
        end;//Menualign
      end;//simple
  end;
end;
procedure TIAeverMenuMainWindow2.GetRectsInfo;
var i,MaxH,MaxW,MaxWw,MaxHh,MaxWt,MaxHt,HiddenNumber,N,j : integer;
    IHaveHidden : Boolean;
    Sz : TSize;
    TempRects : array of TRect;
    TempFont : TFont;
    dx,dy,dxm,dym,dright,dbottom : integer;
    Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP : integer;
begin
  //====================
  case (Owner as TIAeverMenu2).menuKind of
    mkRects :
      begin
        Gap1:= mtRgap;
        GapUL := mtRUpLeftgap;
        GapRD := mtRBottomRightgap;
        GapBtR := mtRBartoRectgap;
        GapRtC := mtRRecttoControlgap;
        CSize := mtRControlSize;

        GapBar := mtRBargap;
        TtBMP := mtRTexttoBMP;
        IGap  := mtRItemGap;
        BTtBMP :=mtRBarTexttoBMP;
      end;
    mkWide,mkWideCorner :
      begin
        Gap1:= mtEgap;
        GapUL := mtEUpLeftgap;
        GapRD := mtEBottomRightgap;
        GapBtR := mtEBartoRectgap;
        GapRtC := mtERecttoControlgap;
        CSize := mtEControlSize;

        GapBar := mtEBargap;
        TtBMP := mtETexttoBMP;
        IGap  := mtEItemGap;
        BTtBMP :=mtEBarTexttoBMP;
      end;
    mkSimple,mkSimpleCorner :
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
    else
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
  end;


  //+++++++++++++++++++
  maxWw:=0;MaxHh:=0;MaxWt:=0;MaxHt:=0;
  for i:=0 to FMenuContent.ItemsNumber-1 do
    begin
      if (FMenuContent[i].MainBitmap<>nil) and
          (not FMenuContent[i].Splitter)then
         begin
           MaxWw:=Max(MaxWw,FMenuContent[i].MainBitmap.Width);
           MaxHh:=Max(MaxHh,FMenuContent[i].MainBitmap.Height);
         end;
      sz.cx:=0;sz.cy:=0;
      if (length(FMenuContent[i].ItemName)>0) and (not(FMenuContent[i].splitter))then
        begin
          GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
        end;
      MaxWt:=Max(MaxWt,Sz.cx);
      MaxHt:=Max(MaxHt,Sz.cy);
    end;
  IhaveHidden:=False;
  for i:=0 to FMenuContent.ItemsNumber-1 do if FMenuContent[i].hidden then IHaveHidden:=True;
  case (Owner as TIAeverMenu2).menuKind of
    mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
      begin
        MaxH:=0;MaxW:=0;SetLength(TempRects,FMenuContent.ItemsNumber);HiddenNumber:=0;
        for i:=0 to FMenuContent.ItemsNumber-1 do
          begin
            Sz.cx:=0;Sz.cy:=0;
            if (length(FMenuContent[i].ItemName)>0) and (not(FMenuContent[i].splitter))then
              begin
                GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
              end;
            //----
            if FMenuContent[i].MainBitmap<>nil then
              begin
                case (Owner as TIAeverMenu2).menuAlign of
                  iaalTop,iaalBottom,iaalNoneHorizontal :
                    begin
                      if Sz.cx=0 then Sz.cx:=-TtBMP;
                      Sz.cx:=Sz.cx+FMenuContent[i].MainBitmap.Width+TtBMP;
                      Sz.cy:=Max(MaxHh,MaxHt);
                    end;
                  else
                    begin
                      Sz.cx:=MaxWt+MaxWw+TtBMP;
                      if (MaxWt=0) or (MaxWw=0) then dec(Sz.cx,TtBmp);
                      Sz.cy:=Max(Sz.cy,FMenuContent[i].MainBitmap.Height);
                    end;
                end;      

              end else
              begin
                if FMenuContent[i].splitter then
                begin
                  SZ.cx:=2;
                  Sz.cy:=2;
                end else
                begin
                  case (Owner as TIAeverMenu2).menuAlign of
                    iaalTop,iaalBottom,iaalNoneHorizontal :
                      begin
                        Sz.cx:=Sz.cx;
                        Sz.cy:=Max(MaxHh,MaxHt);
                      end;
                    else
                      begin
                        Sz.cx:=MaxWt+MaxWw+TtBMP;
                        if (MaxWt=0) or (MaxWw=0) then dec(Sz.cx,TtBmp);
                      end;
                  end;    
                end;
              end;
            //-----
            inc(SZ.cx,2*IGap);inc(SZ.cy,2*IGap);
            TempRects[i]:=Rect(0,0,SZ.cx,Sz.cy);
            Maxw:=Max(MaxW,Sz.cx);
            Maxh:=Max(MaxH,Sz.cy);
            if FMenuContent[i].hidden then inc(HiddenNumber);
          end;
        case (Owner as TIAeverMenu2).menuAlign of
          iaalTop,iaalBottom,iaalNoneHorizontal :
            begin
              if FMenuContent.ShowHidden then
                begin
                  FRectsInfo.ShowHiddenRect:=Rect(0,0,0,0);//We not need in it...
                  if IhaveHidden then
                    begin  //We have hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                      FRectsInfo.HideHiddenRect:=Rect(GapUL,GapUL,CSize+GapUL,Maxh+GapUL);
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if j=0 then
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.HideHiddenRect.right+GapRtC,FRectsInfo.HideHiddenRect.top,
                                     FRectsInfo.HideHiddenRect.right+TempRects[j].right+GapRtC,FRectsInfo.HideHiddenRect.bottom)
                          else
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.Rects[j-1].right+Gap1,FRectsInfo.Rects[j-1].top,
                                     FRectsInfo.Rects[j-1].right+TempRects[j].right+Gap1,FRectsInfo.Rects[j-1].bottom);
                          FRectsInfo.Connected[j]:=j;
                        end;
                      if FMenuContent.ItemsNumber>0 then
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].right+GapRD,MaxH+GapUl+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.HideHiddenRect.right+GapRD,MaxH+GapUl+GapRD);
                    end else//IHaveHidden..
                    begin //We have not hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                      FRectsInfo.HideHiddenRect:=Rect(GapUL,GapUL,GapUL,Maxh+GapUL);
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if j=0 then
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.HideHiddenRect.right+GapRtC,FRectsInfo.HideHiddenRect.top,
                                     FRectsInfo.HideHiddenRect.right+TempRects[j].right+GapRtC,FRectsInfo.HideHiddenRect.bottom)
                          else
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.Rects[j-1].right+Gap1,FRectsInfo.Rects[j-1].top,
                                     FRectsInfo.Rects[j-1].right+TempRects[j].right+Gap1,FRectsInfo.Rects[j-1].bottom);
                          FRectsInfo.Connected[j]:=j;
                        end;
                      //Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                      if FMenuContent.ItemsNumber>0 then
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].right+GapRD,MaxH+GapUl+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.HideHiddenRect.right+GapRD,MaxH+GapUl+GapRD);
                    end;//IHave not Hidden;
                end else //ShowHidden yes;
                begin
                  FRectsInfo.HideHiddenRect:=Rect(0,0,0,0);//We not need in it...
                  if IhaveHidden then
                    begin  //We have hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                      FRectsInfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL+CSize,Maxh+GapUL);
                      N:=0;
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if not FMenuContent[j].hidden then
                          begin
                            if N=0 then
                            FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.right+GapRtC,FRectsInfo.ShowHiddenRect.top,
                                      FRectsInfo.ShowHiddenRect.right+TempRects[j].right+GapRtC,FRectsInfo.ShowHiddenRect.bottom)
                            else
                            FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].right+Gap1,FRectsInfo.Rects[N-1].top,
                                     FRectsInfo.Rects[N-1].right+TempRects[j].right+Gap1,FRectsInfo.Rects[N-1].bottom);
                            FRectsInfo.Connected[N]:=j;
                            inc(N);
                          end;  
                        end; //Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                      if N>0 then
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.Rects[N-1].right+GapRD,MaxH+GapUl+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.ShowHiddenRect.right+GapRD,MaxH+GapUl+GapRD);
                    end else//IHaveHidden..
                    begin //We have not hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                      FRectsInfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL,Maxh+GapUL);
                      N:=0;
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if not FMenuContent[j].hidden then
                          begin
                            if N=0 then
                            FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.right+GapRtC,FRectsInfo.ShowHiddenRect.top,
                                      FRectsInfo.ShowHiddenRect.right+TempRects[j].right+GapRtC,FRectsInfo.ShowHiddenRect.bottom)
                            else
                            FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].right+Gap1,FRectsInfo.Rects[N-1].top,
                                     FRectsInfo.Rects[N-1].right+TempRects[j].right+Gap1,FRectsInfo.Rects[N-1].bottom);
                            FRectsInfo.Connected[N]:=j;
                            inc(N);
                          end;  
                        end;
                       //Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                      if N>0 then
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.Rects[N-1].right+GapRD,MaxH+GapUl+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,FRectsInfo.ShowHiddenRect.right+GapRD,MaxH+GapUl+GapRD);
                    end;//IHave not Hidden;

                end;//ShowHidden no;
            end;//Horizontal;
          iaalLeft,iaalRight,iaalNoneVertical :
            begin
              if FMenuContent.ShowHidden then
                begin
                  FRectsInfo.ShowHiddenRect:=Rect(0,0,0,0);//We not need in it...
                  if IhaveHidden then
                    begin  //We have hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                      FRectsInfo.HideHiddenRect:=Rect(GapUL,GapUL,MaxW+GapUL,GapUL+CSize);
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if j=0 then
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom+GapRtC,
                                     FRectsInfo.HideHiddenRect.right,FRectsInfo.HideHiddenRect.bottom+TempRects[j].bottom+GapRtC)
                          else
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.Rects[j-1].left,FRectsInfo.Rects[j-1].bottom+Gap1,
                                     FRectsInfo.Rects[j-1].right,FRectsInfo.Rects[j-1].bottom+TempRects[j].bottom+Gap1);
                          FRectsInfo.Connected[j]:=j;
                        end;//Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                      if FMenuContent.ItemsNumber>0 then
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].Bottom+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                    end else//IHaveHidden..
                    begin //We have not hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                      FRectsInfo.HideHiddenRect:=Rect(GapUL,GapUL,MaxW+GapUL,GapUL);
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if j=0 then
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom+GapRtC,
                                     FRectsInfo.HideHiddenRect.right,FRectsInfo.HideHiddenRect.bottom+TempRects[j].bottom+GapRtC)
                          else
                          FRectsInfo.Rects[j]:=Rect(FRectsInfo.Rects[j-1].left,FRectsInfo.Rects[j-1].bottom+Gap1,
                                     FRectsInfo.Rects[j-1].right,FRectsInfo.Rects[j-1].bottom+TempRects[j].bottom+Gap1);
                          FRectsInfo.Connected[j]:=j;
                        end;
                      
                      if FMenuContent.ItemsNumber>0 then
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].Bottom+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                    end;//IHave not Hidden;
                end else //ShowHidden yes;
                begin
                  FRectsInfo.HideHiddenRect:=Rect(0,0,0,0);//We not need in it...
                  if IhaveHidden then
                    begin  //We have hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                      FRectsInfo.ShowHiddenRect:=Rect(GapUL,GapUL,MaxW+GapUL,GapUL+CSize);
                      N:=0;
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if not FMenuContent[j].hidden then
                          begin
                            if N=0 then
                          FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom+GapRtC,
                                     FRectsInfo.ShowHiddenRect.right,FRectsInfo.ShowHiddenRect.bottom+TempRects[j].bottom+GapRtC)
                          else
                          FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                     FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+TempRects[j].bottom+Gap1);
                          FRectsInfo.Connected[N]:=j;
                            inc(N);
                          end;  
                        end;//Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                      if N>0 then
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.Rects[N-1].Bottom+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
      
                    end else//IHaveHidden..
                    begin //We have not hidden to show it...
                      setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                      setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                      FRectsInfo.ShowHiddenRect:=Rect(GapUL,GapUL,MaxW+GapUL,GapUL);
                      N:=0;
                      for j:=0 to FMenuContent.ItemsNumber-1 do
                        begin
                          if not FMenuContent[j].hidden then
                          begin
                            if N=0 then
                          FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom+GapRtC,
                                     FRectsInfo.ShowHiddenRect.right,FRectsInfo.ShowHiddenRect.bottom+TempRects[j].bottom+GapRtC)
                          else
                          FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                     FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+TempRects[j].bottom+Gap1);
                          FRectsInfo.Connected[N]:=j;
                            inc(N);
                          end;  
                        end;
                      if N>0 then
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.Rects[N-1].Bottom+GapRD)
                      else
                      FRectsInfo.MainRect:=Rect(0,0,MaxW+GapUl+GapRD,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
                    end;//IHave not Hidden;

                end;//ShowHidden no;
            end;//vertical;
            
        end;//menualign...
        if ((Owner as TIAeverMenu2).menuAlign = iaalNoneVertical) or ((Owner as TIAeverMenu2).menuAlign = iaalNoneHorizontal) then
              begin
                offsetrect(FRectsInfo.MainRect,(Owner as TIAeverMenu2).MainMenuLeft,(Owner as TIAeverMenu2).MainMenuTop);
              end;
        //Menu Bar...
        FRectsInfo.BarRect:=rect(0,0,0,0);
        if (FMenuContent.BarMainBitmap<>nil) or (FMenuContent.BarText<>'') then
          begin
            TempFont:=TFont.Create;
            TempFont.Assign(self.canvas.font);
            self.canvas.font.Assign(FMenuContent.BarFont);
            Sz.cx:=0;Sz.cy:=0;
            if  FMenuContent.BarText<>'' then
            GetTextExtentPoint32(self.canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
            MaxW:=-BTtBMP;MaxH:=-BTtBMP;
            if FMenuContent.BarMainBitmap<>nil then
              begin
                MaxW:=FMenuContent.BarMainBitmap.Width;
                MaxH:=FMenuContent.BarMainBitmap.Height;
              end;
            self.canvas.font.Assign(TempFont);
            TempFont.Free;
            dx:=0;dy:=0;dxm:=0;dym:=0;dright:=0;dbottom:=0;//Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
             case (Owner as TIAeverMenu2).MenuAlign of
                iaalTop,iaalBottom,iaalNoneHorizontal :
                  begin
                    case FMenuContent.BarPosition of
                      iabpMain :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar); //TtBMP,IGap,GapBar,BTtBMP
                          dx:=0;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top,GapUL+GapRD+FRectsInfo.BarRect.bottom)
                          -(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top);
                          dy:=dbottom div 2;
                          if dbottom<>0 then offsetrect(FRectsInfo.BarRect,FRectsInfo.MainRect.right-FRectsInfo.MainRect.left+GapBtR-GapRD,GapUL)
                                        else offsetrect(FRectsInfo.BarRect,FRectsInfo.MainRect.right-FRectsInfo.MainRect.left+GapBtR-GapRD,
                                             ((FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top)-
                                             (FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)) div 2);
                        end;
                      iabpAlternate1 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dx:=FRectsInfo.BarRect.Right+GapBtR;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top,GapUL+GapRD+FRectsInfo.BarRect.bottom)
                          -(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top);
                          dy:=dbottom div 2;
                          if dbottom<>0 then offsetrect(FRectsInfo.BarRect,GapUL,GapUL)
                                        else offsetrect(FRectsInfo.BarRect,GapUL,
                                             ((FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top)-
                                             (FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)) div 2);
                        end;
                      iabpAlternate2 :
                        begin  //Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                          if (Maxh>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,sz.cy),Maxh+sz.cx+BTtBMP+2*GapBar);
                          dx:=FRectsInfo.BarRect.Right+GapBtR;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top,GapUL+GapRD+FRectsInfo.BarRect.bottom)
                          -(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top);
                          dy:=dbottom div 2;
                          if dbottom<>0 then offsetrect(FRectsInfo.BarRect,GapUL,GapUL)
                                        else offsetrect(FRectsInfo.BarRect,GapUL,
                                             ((FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top)-
                                             (FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)) div 2);
                        end;    
                    end;

                  end;
               iaalLeft :
                 begin  //Gap1,GapUL,GapRD,GapBar,GapBtR,GapRtC,CSize
                   case FMenuContent.BarPosition of
                      iabpMain :
                        begin
                          if (Maxh>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,sz.cy),
                          max(Maxh+sz.cx+BTtBMP+2*GapBar,FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top-GapUL-GapRD));
                          dx:=FRectsInfo.BarRect.right+GapBtR;dy:=0;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top));
                          offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                        end;
                      iabpAlternate1 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dxm:=0;dym:=0;dright:=max(0,FRectsInfo.BarRect.Right+GapUL+GapRD-FRectsInfo.MainRect.Right+FRectsInfo.MainRect.left);
                          dbottom:=FRectsInfo.BarRect.bottom+GapBtR;
                          dy:=FRectsInfo.BarRect.bottom+GapBtR;
                          dx:=dright div 2;
                          offsetrect(FRectsInfo.BarRect,GapUL+
                          max(0,-FRectsInfo.BarRect.Right-GapUL-GapRD+FRectsInfo.MainRect.Right-FRectsInfo.MainRect.left)div 2,GapUL);
                        end;
                      iabpAlternate2 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dxm:=0;dym:=0;dright:=max(0,FRectsInfo.BarRect.Right+GapUL+GapRD-FRectsInfo.MainRect.Right+FRectsInfo.MainRect.left);
                          dbottom:=FRectsInfo.BarRect.bottom+GapBtR;
                          dy:=0;
                          dx:=dright div 2;
                          offsetrect(FRectsInfo.BarRect,GapUL+
                          max(0,-FRectsInfo.BarRect.Right-GapUL-GapRD+FRectsInfo.MainRect.Right-FRectsInfo.MainRect.left)div 2,
                          FRectsInfo.MainRect.bottom+GapBtR);
                        end;    
                    end;
                 end;
               iaalNoneVertical :
                 begin
                   case FMenuContent.BarPosition of
                      iabpMain :
                        begin
                          if (Maxh>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,sz.cy),
                          max(Maxh+sz.cx+BTtBMP+2*GapBar,FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top-GapUL-GapRD));
                          dx:=FRectsInfo.BarRect.right+GapBtR;dy:=0;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top));
                          offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                        end;
                      iabpAlternate1 :
                        begin
                          if (Maxh>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,sz.cy),
                          max(Maxh+sz.cx+BTtBMP+2*GapBar,FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top-GapUL-GapRD));
                          dx:=0;dy:=0;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top));
                          offsetrect(FRectsInfo.BarRect,FRectsInfo.MainRect.right-FRectsInfo.MainRect.left+GapBtR-GapRD,GapUL);
                        end;
                      iabpAlternate2 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dxm:=0;dym:=0;dright:=max(0,FRectsInfo.BarRect.Right+GapUL+GapRD-FRectsInfo.MainRect.Right+FRectsInfo.MainRect.left);
                          dbottom:=FRectsInfo.BarRect.bottom+GapBtR;
                          dy:=FRectsInfo.BarRect.bottom+GapBtR;
                          dx:=dright div 2;
                          offsetrect(FRectsInfo.BarRect,GapUL+
                          max(0,-FRectsInfo.BarRect.Right-GapUL-GapRD+FRectsInfo.MainRect.Right-FRectsInfo.MainRect.left)div 2,GapUL);
                        end;
                    end;
                 end;
               iaalRight :
                 begin
                   case FMenuContent.BarPosition of
                      iabpMain :
                        begin
                          if (Maxh>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,sz.cy),
                          max(Maxh+sz.cx+BTtBMP+2*GapBar,FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top-GapUL-GapRD));
                          dx:=0;dy:=0;dxm:=0;dym:=0;dright:=FRectsInfo.BarRect.Right+GapBtR;
                          dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-(FRectsInfo.MainRect.bottom-FRectsInfo.MainRect.top));
                          offsetrect(FRectsInfo.BarRect,FRectsInfo.MainRect.right-FRectsInfo.MainRect.left+GapBtR-GapRD,GapUL);
                        end;
                      iabpAlternate1 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dxm:=0;dym:=0;dright:=max(0,FRectsInfo.BarRect.Right+GapUL+GapRD-FRectsInfo.MainRect.Right+FRectsInfo.MainRect.left);
                          dbottom:=FRectsInfo.BarRect.bottom+GapBtR;
                          dy:=FRectsInfo.BarRect.bottom+GapBtR;
                          dx:=dright div 2;
                          offsetrect(FRectsInfo.BarRect,GapUL+
                          max(0,-FRectsInfo.BarRect.Right-GapUL-GapRD+FRectsInfo.MainRect.Right-FRectsInfo.MainRect.left)div 2,GapUL);
                        end;
                      iabpAlternate2 :
                        begin
                          if (MaxW>0) and (Sz.cx=0) then Sz.Cx:=-BTtBMP;
                          FRectsInfo.BarRect:=rect(0,0,Sz.cx+MaxW+BTtBMP+2*GapBar,max(Maxh,sz.cy)+2*GapBar);
                          dxm:=0;dym:=0;dright:=max(0,FRectsInfo.BarRect.Right+GapUL+GapRD-FRectsInfo.MainRect.Right+FRectsInfo.MainRect.left);
                          dbottom:=FRectsInfo.BarRect.bottom+GapBtR;
                          dy:=0;
                          dx:=dright div 2;
                          offsetrect(FRectsInfo.BarRect,GapUL+
                          max(0,-FRectsInfo.BarRect.Right-GapUL-GapRD+FRectsInfo.MainRect.Right-FRectsInfo.MainRect.left)div 2,
                          FRectsInfo.MainRect.bottom+GapBtR);
                        end;
                    end;
                 end;  
             end; //MenuAlign...
           for i:=0 to length(FRectsInfo.Rects)-1 do
             begin
               offsetrect(FRectsInfo.rects[i],dx,dy);
             end;
           offsetrect(FRectsInfo.ShowHiddenRect,dx,dy);
           offsetrect(FRectsInfo.HideHiddenRect,dx,dy);
           offsetrect(FRectsInfo.MainRect,dxm,dym);
           FRectsInfo.MainRect.Right:=FRectsInfo.MainRect.Right+dright;
           FRectsInfo.MainRect.bottom:=FRectsInfo.MainRect.bottom+dbottom;
          end;
      end;//Simple;
  end;
end;
//--------------------------
procedure TIAeverMenuForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  params.Caption:='My window';
  params.style:=WS_POPUP;
  params.ExStyle:=WS_EX_PALETTEWINDOW;
  params.X:=0;
  params.Y:=0;
  params.Width:=0;
  params.Height:=0;
end;
procedure TIAeverMenuForm.WMMOUSEACTIVATE(var Message : TMessage);
 begin
  message.Result:=MA_NOACTIVATE;
 end;
procedure TIAeverMenuForm.WMACTIVATE(var Message : TMessage);
begin
  inherited;
{  Message.WParamLo:=WA_INACTIVE;
  Message.Result:=0;}
end;
constructor TIAeverMenuForm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

end;

constructor TIAeverMenuForm.CreateNewOne(AOwner: TComponent;AMenuContent : TIAmenuList;
    ARect : TRect;AHorizontal : Boolean;var AOrientation : TIAPreferredOrientation;AmyOwner :TComponent);
begin
  CreateNew(AOwner);
  FIWindowState:=iawsbefore;
  FUpRectSelected :=false;
  FDownRectSelected :=false;
  FOpenHiddenSelected :=false;
  FCloseHiddenSelected :=false;
  FGap:=0;
  FCurrentPosition:=0;
  FCurrentBackBitmap:=nil;
  FCurrentListBackBitmap:=nil;
  FMainBitmap:=TBitmap.Create;
  FMainBitmap.PixelFormat:=pf24Bit;
  FMainBitmap.Width:=0;
  FMainBitmap.Height:=0;
  FFirst:=True;
  FMenuContent:=AMenuContent;
  FOrientation:=AOrientation;
  FmyOwner:=AmyOwner;
  self.Color:=(FmyOwner as TIAeverMenu2).BackColor;
  FSemiBitmap:=nil;
  if (FmyOwner as TIAeverMenu2).semipercent>0 then
    begin
      FSemiBitmap:=TBitmap.Create;
      FSemiBitmap.PixelFormat:=pf24Bit;
      FSemiBitmap.Width:=0;
      FSemiBitmap.Height:=0;
    end;
  FRect:=ARect;
  FHorizontal:=AHorizontal;
  GetRectsInfo(true);
  // we define Real Orientation and left/top point;
  DefineRealOrientation;
  GetRectsInfo;

  self.width:=FRectsinfo.MainRect.right;
  self.height:=FRectsinfo.MainRect.bottom;

  AOrientation:=FOrientation;
end;
procedure TIAeverMenuForm.DefineRealOrientation;
var Atleft,atRight,atTop,atBottom : integer;
begin
  if FHorizontal then
    begin
      AtLeft:=FRect.Right;AtRight:=Screen.Width-FRect.Left;
      AtTop:=FRect.Top;AtBottom:=Screen.Height-FRect.Bottom;
    end else//FHorizontal;
    begin
      AtLeft:=FRect.Left;AtRight:=Screen.Width-FRect.Right;
      AtTop:=FRect.Bottom;AtBottom:=Screen.Height-FRect.Top;
    end;
  case FOrientation of
    poLeftRightTopBottom :
      begin
        if (AtRight<AtLeft) and (AtRight<FRectsinfo.MainRect.right) then
          begin
            if (AtBottom<AtTop) and (AtBottom<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poRightLeftBottomTop;
              end else
              begin
                FOrientation:=poRightLeftTopBottom;
              end;
          end else
          begin
            if (AtBottom<AtTop) and (AtBottom<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poLeftRightBottomTop;
              end else
              begin

              end;
          end;
      end;
    poRightLeftTopBottom :
      begin
        if (AtLeft<AtRight) and (AtLeft<FRectsinfo.MainRect.right) then
          begin
            if (AtBottom<AtTop) and (AtBottom<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poLeftRightBottomTop;
              end else
              begin
                FOrientation:=poLeftRightTopBottom;
              end;
          end else
          begin
            if (AtBottom<AtTop) and (AtBottom<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poRightLeftBottomTop;
              end else
              begin

              end;
          end;
      end;
    poLeftRightBottomTop :
      begin
        if (AtRight<AtLeft) and (AtRight<FRectsinfo.MainRect.right) then
          begin
            if (AtTop<AtBottom) and (AtTop<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poRightLeftTopBottom;
              end else
              begin
                FOrientation:=poRightLeftBottomTop;
              end;
          end else
          begin
            if (AtTop<AtBottom) and (AtTop<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poLeftRightTopBottom;
              end else
              begin

              end;
          end;
      end;
    poRightLeftBottomTop :
      begin
        if (AtLeft<AtRight) and (AtLeft<FRectsinfo.MainRect.right) then
          begin
            if (AtTop<AtBottom) and (AtTop<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poLeftRightTopBottom;
              end else
              begin
                FOrientation:=poLeftRightBottomTop;
              end;
          end else
          begin
            if (AtTop<AtBottom) and (AtTop<FRectsinfo.MainRect.bottom) then
              begin
                FOrientation:=poRightLeftTopBottom;
              end else
              begin

              end;
          end;
      end;
  end;
  //----------------
  case FOrientation of
    poLeftRightTopBottom :
      begin
        if FHorizontal then
          begin
            self.top:=Frect.Bottom;self.Left:=FRect.Left;
          end else
          begin
            self.top:=Frect.Top;self.Left:=FRect.Right;
          end;
      end;
    poRightLeftTopBottom :
      begin
        if FHorizontal then
          begin
            self.top:=Frect.Bottom;self.Left:=FRect.right-FRectsinfo.MainRect.right;
          end else
          begin
            self.top:=Frect.Top;self.Left:=FRect.left-FRectsinfo.MainRect.right;
          end;
      end;
    poLeftRightBottomTop :
      begin
        if FHorizontal then
          begin
            self.top:=Frect.top-FRectsinfo.MainRect.bottom;self.Left:=FRect.Left;
          end else
          begin
            self.top:=Frect.bottom-FRectsinfo.MainRect.bottom;self.Left:=FRect.Right;
          end;
      end;
    poRightLeftBottomTop :
      begin
        if FHorizontal then
          begin
            self.top:=Frect.top-FRectsinfo.MainRect.bottom;self.Left:=FRect.right-FRectsinfo.MainRect.right;
          end else
          begin
            self.top:=Frect.bottom-FRectsinfo.MainRect.bottom;self.Left:=FRect.left-FRectsinfo.MainRect.right;
          end;
      end;
  end;
end;
procedure TIAeverMenuForm.CreateHandle;
var RGN : HRGN;
begin
  inherited CreateHandle;
  parent:=nil;
  RGN:=CreateRectRGN(0,0,0,0);
  setwindowrgn(self.handle,RGN,true);
  if FMenuContent<>nil then FMenuContent.OnChange:=IChanged;
  self.ControlStyle:=self.ControlStyle+[csOpaque];
end;
destructor TIAeverMenuForm.Destroy;
begin
  if FTimed then
    begin
      if FTimer<>nil then
        begin
          FTimer.free;
          FTimer:=nil;
        end;
      FTimed:=false;
    end;
  Unselect;  
  if FMenuContent<>nil then FMenuContent.OnChange:=Nil;
  FMenuContent:=nil;
  FMainBitmap.free;
  FSemiBitmap.free;
  inherited Destroy;
end;
procedure TIAeverMenuForm.Paint;
begin
  inherited Paint;
  FMainBitmap.Canvas.Font.Assign((FMyOwner as TIAeverMenu2).FMenuFont);
  if (FIWindowState=iawsOpening) or (FIWindowState=iawsClosing) then
    begin
      if FFirst then FFirst:=false else canvas.Draw(0,0,FMainBitmap);
      PaintAnimate;
      canvas.Draw(0,0,FMainBitmap);
    end;
  if FIWindowState=iawsWorking then
    begin
      if FFirst then FFirst:=false else canvas.Draw(0,0,FMainBitmap);
      DrawMainBitmap;
      canvas.Draw(0,0,FMainBitmap);
    end;
end;
procedure TIAeverMenuForm.DrawMainBitmap;
begin
  FMainBitmap.Width:=Width;
  FMainBitmap.Height:=Height;
  case (FmyOwner as TIAeverMenu2).menuKind of
    mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
      begin
        DrawMainBitmapmkSimple;
      end;
  end;    

end;
procedure TIAeverMenuForm.SetCurrentBackBitmap(ANumberItem: integer;AConTinued: Boolean;AList : TIAmenuList);
  var i : integer;
begin
  FCurrentBackBitmap.free;
  FCurrentBackBitmap:=nil;
  if AContinued then
    begin
      i:=ANumberItem;
      while (i>=0) and
            (AList.Items[i].Continued) and
            (AList.Items[i].BackBitmap=nil) do dec(i);
      if (i>=0) and (AList.Items[i].BackBitmap<>nil) then
        begin
          FCurrentBackBitmap:=TBitmap.Create;
          FCurrentBackBitmap.PixelFormat:=pf24bit;
          FCurrentBackBitmap.Width:=AList.Items[i].BackBitmap.Width;
          FCurrentBackBitmap.height:=AList.Items[i].BackBitmap.height;
          FCurrentBackBitmap.Canvas.Draw(0,0,AList.Items[i].BackBitmap);
        end else
        begin
          if (i<0) and (AList.Owner is TIAMenuItem) and ((AList.Owner as TIAMenuItem).owner is TIAmenuList) then
            begin
              i:=0;
              while (AList.Owner as TIAMenuItem)<>(((AList.Owner as TIAMenuItem).owner as TIAmenuList)[i]) do inc(i);
              SetCurrentBackBitmap(i,(AList.Owner as TIAMenuItem).Continued,((AList.Owner as TIAMenuItem).owner as TIAmenuList));
            end;
        end;
    end else
    begin
      if AList.Items[ANumberItem].BackBitmap<>nil then
        begin
          FCurrentBackBitmap:=TBitmap.Create;
          FCurrentBackBitmap.PixelFormat:=pf24bit;
          FCurrentBackBitmap.Width:=AList.Items[ANumberItem].BackBitmap.Width;
          FCurrentBackBitmap.height:=AList.Items[ANumberItem].BackBitmap.height;
          FCurrentBackBitmap.Canvas.Draw(0,0,AList.Items[ANumberItem].BackBitmap);
        end;
    end;
end;

procedure TIAeverMenuForm.SetCurrentListBackBitmap(AConTinued: Boolean);
  var AMenuContent : TIAmenuList;
begin
  FCurrentListBackBitmap.free;
  FCurrentListBackBitmap:=nil;
  if AContinued then
    begin
      AMenuContent:=FMenuContent;
      while (AMenuContent.Owner is TIAmenuItem) and
            ((AMenuContent.Owner as TIAmenuItem).owner is  TIAmenuList) and (AMenuContent.BackBitmap=nil) and
            (AMenuContent.ListContinued) do
        begin
          AMenuContent:=((AMenuContent.Owner as TIAmenuItem).owner as  TIAmenuList);
        end;    

          if AMenuContent.BackBitmap<>nil then
            begin
              FCurrentListBackBitmap:=TBitmap.Create;
              FCurrentListBackBitmap.PixelFormat:=pf24bit;
              FCurrentListBackBitmap.Width:=AMenuContent.BackBitmap.Width;
              FCurrentListBackBitmap.height:=AMenuContent.BackBitmap.height;
              FCurrentListBackBitmap.Canvas.Draw(0,0,AMenuContent.BackBitmap);
            end;
    end else
    begin
      if FMenuContent.BackBitmap<>nil then
        begin
          FCurrentListBackBitmap:=TBitmap.Create;
          FCurrentListBackBitmap.PixelFormat:=pf24bit;
          FCurrentListBackBitmap.Width:=FMenuContent.BackBitmap.Width;
          FCurrentListBackBitmap.height:=FMenuContent.BackBitmap.height;
          FCurrentListBackBitmap.Canvas.Draw(0,0,FMenuContent.BackBitmap);
        end;
    end;
end;
procedure TIAeverMenuForm.DrawMainBitmapmkSimple;
var i,j,k,iaTOPLINE,iaBottomLine,Maxw,Rr,Gg,Bb,leftfont,dh,dx,dy,BarIndex : integer;
    RAll,RGN,RGN1,RGN2 : HRGN;
    R1 : Trect;
    Bit1,Bit2 : TBitmap;
    p1,p2 : pByteArray;
    Sz : TSize;
    TempFont : tfont;
    MyFont,oldfont : HFONT;
    MyLFont : LOGFONT;
    DC : HDC;
    TeBit,TeBit1 : TBitmap;
    TR,TG,TB : BYTE;
    Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,Tts,IGap,GapBar,BTtBMP : integer;
begin
 //====================
  case (FMyOwner as TIAeverMenu2).menuKind of
    mkRects :
      begin
        Gap1:=    mtRgap;
        GapUL :=  mtRUpLeftgap;
        GapRD :=  mtRBottomRightgap;
        GapBtR := mtRBartoRectgap;
        GapRtC := mtRRecttoControlgap;
        CSize :=  mtRControlSize;

        GapBar := mtRBargap;
        TtBMP :=  mtRTexttoBMP;
        Tts:=     mtRTexttoSub;
        IGap  :=  mtRItemGap;
        BTtBMP := mtRBarTexttoBMP;
      end;
    mkWide,mkWideCorner :
      begin
        Gap1:= mtEgap;
        GapUL := mtEUpLeftgap;
        GapRD := mtEBottomRightgap;
        GapBtR := mtEBartoRectgap;
        GapRtC := mtERecttoControlgap;
        CSize := mtEControlSize;

        GapBar := mtEBargap;
        TtBMP := mtETexttoBMP;
        Tts:=mtETexttoSub;
        IGap  := mtEItemGap;
        BTtBMP :=mtEBarTexttoBMP;
      end;
    mkSimple,mkSimpleCorner :
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        Tts:=mtSTexttoSub;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
    else
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        Tts:=mtSTexttoSub;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
  end;


  //+++++++++++++++++++
  //BackBitmap.... and frame...
  SetCurrentListBackBitmap(FMenuContent.ListContinued);
  FMainBitmap.canvas.brush.Color:= (FmyOwner as TIAeverMenu2).BackColor;
  FMainBitmap.canvas.FillRect(ClientRect);
  if FMenuContent<>nil then
    begin
      if FCurrentListBackBitmap<>nil then
        begin
          if FMenuContent.MainBackStretch then
            begin
              FMainBitmap.canvas.StretchDraw(ClientRect,FCurrentListBackBitmap);
            end else
            begin
              for i:=0 to width div FCurrentListBackBitmap.Width do
                for j:=0 to height div FCurrentListBackBitmap.Height do
                  FMainBitmap.canvas.Draw(i*FCurrentListBackBitmap.Width,j*FCurrentListBackBitmap.Height,FCurrentListBackBitmap);
            end;
        end;
    end;
  FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
  FMainBitmap.canvas.MoveTo(ClientRect.left,ClientRect.bottom-1);
  FMainBitmap.canvas.LineTo(ClientRect.left,ClientRect.top);
  FMainBitmap.canvas.LineTo(ClientRect.right-1,ClientRect.top);
  FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
  FMainBitmap.canvas.LineTo(ClientRect.right-1,ClientRect.bottom-1);
  FMainBitmap.canvas.LineTo(ClientRect.left,ClientRect.bottom-1);
  //Draw the BackBitmaps...
  iaTopLine:=0;iaBottomLine:=0;
  if FMenuContent<>nil then
    begin
      if length(FRectsInfo.Rects)>0 then
        begin

          case FOrientation of
            poLeftRightTopBottom,poRightLeftTopBottom :
              begin
                iaTopLine:=GapUL;
                if (FRectsInfo.ShowHiddenRect.top-FRectsInfo.ShowHiddenRect.bottom)<>0 then
                iatopline:=max(iaTopLine,FRectsInfo.ShowHiddenRect.bottom+GapRtC);
                if (FRectsInfo.HideHiddenRect.top-FRectsInfo.HideHiddenRect.bottom)<>0 then
                iatopline:=max(iaTopLine,FRectsInfo.HideHiddenRect.bottom+GapRtC);
                iaBottomLine:=height-GapRD;
              end;
            poLeftRightBottomTop,poRightLeftBottomTop ://Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
              begin
                iaTopLine:=GapUL;
                iaBottomLine:=height-GapRD;
                if (FRectsInfo.ShowHiddenRect.top-FRectsInfo.ShowHiddenRect.bottom)<>0 then
                iaBottomLine:=min(iaBottomLine,FRectsInfo.ShowHiddenRect.top-GapRtC);
                if (FRectsInfo.HideHiddenRect.top-FRectsInfo.HideHiddenRect.bottom)<>0 then
                iaBottomLine:=min(iaBottomLine,FRectsInfo.HideHiddenRect.top-GapRtC);
              end;
          end;
          

          RAll:=CreateRectRGN(GapUL,iaTopLine,width-GapRD,iaBottomLine);
            for i:=0 to length(FRectsInfo.Rects)-1 do
              begin
                RGN:=CreateREctRGN(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top-FCurrentPosition,
                                   FRectsInfo.Rects[i].right,FRectsInfo.Rects[i].bottom-FCurrentPosition);
                CombineRGN(RGN,RGN,RAll,RGN_And);
                SelectClipRGN(FMainBitmap.canvas.handle,RGN);
                Deleteobject(RGN);
                SetCurrentBackBitmap(FRectsInfo.Connected[i],FMenuContent[FRectsInfo.Connected[i]].continued,FMenuContent);
                if FCurrentBackBitmap<>nil then
                  begin
                    if FMenuContent[FRectsInfo.Connected[i]].stretch then
                      begin
                        R1:=FRectsInfo.Rects[i];
                        R1.top:=R1.top-FCurrentPosition;
                        R1.bottom:=R1.bottom-FCurrentPosition;
                        FMainBitmap.canvas.StretchDraw(R1,FCurrentBackBitmap);
                      end else
                      begin
                        for j:=0 to (FRectsInfo.Rects[i].right-FRectsInfo.Rects[i].left)
                          div FCurrentBackBitmap.width do
                            for k:=0 to (FRectsInfo.Rects[i].bottom-FRectsInfo.Rects[i].top)
                              div FCurrentBackBitmap.height do
                                FMainBitmap.canvas.Draw(j*FCurrentBackBitmap.width+FRectsInfo.Rects[i].left,
                                                        k*FCurrentBackBitmap.height+FRectsInfo.Rects[i].top-FCurrentPosition,
                                                        FCurrentBackBitmap);
                      end;
                  end
              end;
          SelectClipRGN(FMainBitmap.canvas.handle,0);
          deleteobject(RAll);
        end;
    end;
  //--
  if (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0 then
     begin
       RGN:=CreateRectRGN(FRectsInfo.BarRect.left,FRectsInfo.BarRect.top,FRectsInfo.BarRect.right,FRectsInfo.BarRect.bottom);
       selectClipRGN(FMainBitmap.canvas.handle,RGN);
       if (FMenuContent.BarBackBitmap<>nil) then
         begin
           if FMenuContent.BarStretch then
             begin
               FMainBitmap.canvas.StretchDraw(FRectsInfo.BarRect,FMenuContent.BarBackBitmap);
             end else
             begin
               for i:=0 to (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left) div FMenuContent.BarBackBitmap.width  do
                 for j:=0 to (FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top) div FMenuContent.BarBackBitmap.height do
                   FMainBitmap.Canvas.Draw(FRectsInfo.BarRect.left+i*FMenuContent.BarBackBitmap.width,
                                            FRectsInfo.BarRect.top+j*FMenuContent.BarBackBitmap.height,
                                            FMenuContent.BarBackBitmap);
             end;
         end;
         FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
         FMainBitmap.Canvas.MoveTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.bottom-1);
         FMainBitmap.Canvas.LineTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.top);
         FMainBitmap.Canvas.LineTo(FRectsInfo.BarRect.right-1,FRectsInfo.BarRect.top);
         FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
         FMainBitmap.Canvas.LineTo(FRectsInfo.BarRect.right-1,FRectsInfo.BarRect.bottom-1);
         FMainBitmap.Canvas.LineTo(FRectsInfo.BarRect.left,FRectsInfo.BarRect.bottom-1);
       selectClipRGN(FMainBitmap.canvas.handle,0);
       deleteobject(RGN);
     end;

  if (FMyOwner as TIAeverMenu2).menuKind =  mkRects then
    begin
      for i:=0 to length(FRectsInfo.rects)-1 do
        begin
          FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].Bottom-1-FCurrentPosition);
          FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].top-FCurrentPosition);
          FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].top-FCurrentPosition);
          FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
          FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
        end;
    end;
  if (FMyOwner as TIAeverMenu2).menuKind =  mkRects then
    begin
      FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
      FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
      FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.top);
      FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-1,FRectsInfo.HideHiddenRect.top);
      FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
      FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.right-1,FRectsInfo.HideHiddenRect.Bottom-1);
      FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
    end;
  if (FMyOwner as TIAeverMenu2).menuKind =  mkRects then
    begin
      FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
      FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
      FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.top);
      FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-1,FRectsInfo.ShowHiddenRect.top);
      FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
      FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.right-1,FRectsInfo.ShowHiddenRect.Bottom-1);
      FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
    end;
  //
  //=======================================================
  //Point of SemiTransparence...
  if (FmyOwner as TIAeverMenu2).semipercent>0 then
    begin
      GetSemiBitmaps;
    end;
  //Point of SemiTransparence...
  //=======================================================
  MaxW:=0;
  if FMenuContent<>nil then
    begin
      for i:=0 to FMenuContent.ItemsNumber-1 do
        if FMenuContent[i].MainBitmap<>nil then MaxW:=max(Maxw,FMenuContent[i].MainBitmap.Width);
    end;
  if FMenuContent<>nil then
    begin
      //-
      Case FOrientation of
        poLeftRightTopBottom,poLeftRightBottomTop :
          begin
            RAll:=CreateRectRGN(GapUL,iaTopLine,width-GapRD,iaBottomLine);//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP


            RGN1:=CreateRectRGN(FUpRect.left,FUpRect.top,FUpRect.right,FUpRect.bottom);
            RGN2:=CreateRectRGN(FDownRect.left,FDownRect.top,FDownRect.right,FDownRect.bottom);
            combinergn(RALL,RALL,RGN1,RGN_DIFF);
            combinergn(RALL,RALL,RGN2,RGN_DIFF);
            deleteobject(RGN1);
            deleteobject(RGN2);
            for i:=0 to length(FRectsInfo.rects)-1 do
              begin
                RGN:=CreateREctRGN(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top-FCurrentPosition,
                                   FRectsInfo.Rects[i].right,FRectsInfo.Rects[i].bottom-FCurrentPosition);
                CombineRGN(RGN,RGN,RAll,RGN_And);
                SelectClipRGN(FMainBitmap.canvas.handle,RGN);
                Deleteobject(RGN);
                if FMenuContent[FRectsInfo.Connected[i]].splitter then
                  begin
                    if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
                      begin
                        if FMenuContent[FRectsInfo.Connected[i]].transparent then
                          begin
                            Bit1:=TBitmap.Create;
                            Bit1.PixelFormat:=pf24bit;
                            Bit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                            Bit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                            Bit2:=TBitmap.Create;
                            Bit2.PixelFormat:=pf24bit;
                            Bit2.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                            Bit2.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                            Bit1.Canvas.Draw(-(FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].Right
                                            -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2,
                                            -(IGap+FRectsInfo.Rects[i].top-FCurrentPosition),FMainBitmap);
                            Bit2.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                            Rr:=0;Gg:=0;Bb:=0;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                            for j:=0 to Bit1.Height-1 do
                              begin
                                p1:=Bit1.ScanLine[j];p2:=Bit2.ScanLine[j];
                                if j=0 then
                                  begin
                                    Rr:=p2[0];Gg:=p2[1];Bb:=p2[2];
                                  end;  
                                for k:=0 to Bit1.Width-1 do
                                  begin
                                    if (Rr<>p2[k*3]) or (Gg<>p2[k*3+1]) or (Bb<>p2[k*3+2]) then
                                      begin
                                        p1[k*3]:=p2[k*3];
                                        p1[k*3+1]:=p2[k*3+1];
                                        p1[k*3+2]:=p2[k*3+2];
                                      end;
                                  end;
                              end;
                            FMainBitmap.canvas.Draw((FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].Right
                                            -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2,
                                                     IGap+FRectsInfo.Rects[i].top-FCurrentPosition,Bit1);
                            Bit1.free;
                            Bit2.free;
                      end else
                      begin
                        FMainBitmap.canvas.Draw((FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].Right
                                            -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width) div 2
                                            ,IGap+FRectsInfo.Rects[i].top-FCurrentPosition,
                                                FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                      end;
                      end else
                      begin
                        if (FmyOwner as TIAeverMenu2).Font3DStyle = iafsRelief then
                        FMainBitmap.canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor)
                        else
                        FMainBitmap.canvas.pen.color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].top+IGap-FCurrentPosition);
                        if (FmyOwner as TIAeverMenu2).Font3DStyle = iafsRelief then
                        FMainBitmap.canvas.pen.color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor)
                        else
                        FMainBitmap.canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap+1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].top+IGap+1-FCurrentPosition);
                      end;

                  end else//splitter...
                  begin    //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
                  begin
                    if FMenuContent[FRectsInfo.Connected[i]].transparent then
                      begin
                        Bit1:=TBitmap.Create;
                        Bit1.PixelFormat:=pf24bit;
                        Bit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                        Bit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                        Bit2:=TBitmap.Create;
                        Bit2.PixelFormat:=pf24bit;
                        Bit2.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                        Bit2.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                        Bit1.Canvas.Draw(-(IGap+FRectsInfo.Rects[i].left),-(IGap+FRectsInfo.Rects[i].top-FCurrentPosition),FMainBitmap);
                        Bit2.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                        Rr:=0;Gg:=0;Bb:=0;
                        for j:=0 to Bit1.Height-1 do //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          begin
                            p1:=Bit1.ScanLine[j];p2:=Bit2.ScanLine[j];
                            if j=0 then
                              begin
                                Rr:=p2[0];Gg:=p2[1];Bb:=p2[2];
                              end;
                            for k:=0 to Bit1.Width-1 do
                              begin
                                if (Rr<>p2[k*3]) or (Gg<>p2[k*3+1]) or (Bb<>p2[k*3+2]) then
                                  begin
                                    p1[k*3]:=p2[k*3];
                                    p1[k*3+1]:=p2[k*3+1];
                                    p1[k*3+2]:=p2[k*3+2];
                                  end;
                              end;
                          end;
                        FMainBitmap.canvas.Draw(IGap+FRectsInfo.Rects[i].left,IGap+FRectsInfo.Rects[i].top-FCurrentPosition,Bit1);
                        Bit1.free;
                        Bit2.free;
                      end else
                      begin
                        FMainBitmap.canvas.Draw(IGap+FRectsInfo.Rects[i].left,IGap+FRectsInfo.Rects[i].top-FCurrentPosition,
                                                FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                      end;
                  end;//Draw BackBitmap;
                  if Maxw=0 then leftfont:=IGap+FRectsInfo.Rects[i].left else leftfont:=IGap+TtBMP+Maxw+FRectsInfo.Rects[i].left;
                  FMainBitmap.canvas.brush.style:=bsClear;
                  if FMenuContent[FRectsInfo.Connected[i]].ItemName<>'' then
                    begin
                      case  (FmyOwner as TIAeverMenu2).Font3DStyle of
                        iafsRelief :
                          begin
                            FMainBitmap.canvas.font.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(leftfont-1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition-1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                            FMainBitmap.canvas.font.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(leftfont+1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition+1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                          end;
                        iafsPressed : //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          begin
                            FMainBitmap.canvas.font.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(leftfont-1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition-1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                            FMainBitmap.canvas.font.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(leftfont+1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition+1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                          end;
                      end;
                      if not FMenuContent[FRectsInfo.Connected[i]].Grayed then
                      begin
                        if FMenuContent[FRectsInfo.Connected[i]].selected then
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).FSelectFontColor else
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).menufont.Color;
                      end else
                      begin
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).GrayColor;
                      end;

                      FMainBitmap.canvas.TextOut(leftfont,
                        -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                        (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition,
                        FMenuContent[FRectsInfo.Connected[i]].ItemName);

                    end;
                  FMainBitmap.canvas.brush.style:=bsSolid;  
                  if FMenuContent[FRectsInfo.Connected[i]].SubMenuList<>nil then
                    begin
                      case  (FmyOwner as TIAeverMenu2).Font3DStyle of
                        iafsRelief :
                          begin
                            FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].right-IGap-1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition-1);
                            FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].right-IGap+1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap+1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition+1);
                          end;
                        iafsPressed :
                          begin
                            FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].right-IGap-1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition-1);
                            FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].right-IGap+1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size) div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap+1-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition+1);
                          end;
                      end;
                      if FMenuContent[FRectsInfo.Connected[i]].selected then
                      FMainBitmap.canvas.pen.Color:=(FmyOwner as TIAeverMenu2).FSelectFontColor else
                      FMainBitmap.canvas.pen.Color:=(FmyOwner as TIAeverMenu2).menufont.Color;
                      FMainBitmap.canvas.moveto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size),
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size),
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-IGap-abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition);
                    end;


                if FMenuContent[FRectsInfo.Connected[i]].selected and (not FMenuContent[FRectsInfo.Connected[i]].Grayed ) then
                  begin
                    FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor);
                    FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].Bottom-1-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].top-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].top-FCurrentPosition);
                    FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                  end else
                  begin
                    if  FMenuContent[FRectsInfo.Connected[i]].hidden and (not FMenuContent[FRectsInfo.Connected[i]].Grayed ) then
                      begin
                        FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].Bottom-1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].top-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].top-FCurrentPosition);
                        FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                      end;
                  end;
               end;
             end;//splitter...  
            SelectClipRGN(FMainBitmap.canvas.handle,0);
            deleteobject(RAll);
          end;
        poRightLeftTopBottom,poRightLeftBottomTop :
          begin
            RAll:=CreateRectRGN(GapUL,iaTopLine,width-GapRD,iaBottomLine);
            RGN1:=CreateRectRGN(FUpRect.left,FUpRect.top,FUpRect.right,FUpRect.bottom);
            RGN2:=CreateRectRGN(FDownRect.left,FDownRect.top,FDownRect.right,FDownRect.bottom);
            combinergn(RALL,RALL,RGN1,RGN_DIFF);
            combinergn(RALL,RALL,RGN2,RGN_DIFF);
            deleteobject(RGN1);
            deleteobject(RGN2);
            for i:=0 to length(FRectsInfo.rects)-1 do//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
              begin
                RGN:=CreateREctRGN(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top-FCurrentPosition,
                                   FRectsInfo.Rects[i].right,FRectsInfo.Rects[i].bottom-FCurrentPosition);
                CombineRGN(RGN,RGN,RAll,RGN_And);
                SelectClipRGN(FMainBitmap.canvas.handle,RGN);
                Deleteobject(RGN);
                if FMenuContent[FRectsInfo.Connected[i]].splitter then
                  begin
                    if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
                      begin
                        if FMenuContent[FRectsInfo.Connected[i]].transparent then
                          begin
                            Bit1:=TBitmap.Create;
                            Bit1.PixelFormat:=pf24bit;
                            Bit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                            Bit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                            Bit2:=TBitmap.Create;
                            Bit2.PixelFormat:=pf24bit;
                            Bit2.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                            Bit2.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                            Bit1.Canvas.Draw(-((FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].right
                                          -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.width) div 2),
                                            -(IGap+FRectsInfo.Rects[i].top-FCurrentPosition),FMainBitmap);
                            Bit2.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                            Rr:=0;Gg:=0;Bb:=0;
                            for j:=0 to Bit1.Height-1 do
                              begin
                                p1:=Bit1.ScanLine[j];p2:=Bit2.ScanLine[j];
                                if j=0 then
                                  begin
                                    Rr:=p2[0];Gg:=p2[1];Bb:=p2[2];
                                  end;  
                                for k:=0 to Bit1.Width-1 do
                                  begin
                                    if (Rr<>p2[k*3]) or (Gg<>p2[k*3+1]) or (Bb<>p2[k*3+2]) then
                                      begin
                                        p1[k*3]:=p2[k*3];
                                        p1[k*3+1]:=p2[k*3+1];
                                        p1[k*3+2]:=p2[k*3+2];
                                      end;
                                  end;
                              end;
                            FMainBitmap.canvas.Draw(((FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].right
                                          -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.width) div 2),
                            IGap+FRectsInfo.Rects[i].top-FCurrentPosition,Bit1);
                            Bit1.free;
                            Bit2.free;
                      end else
                      begin
                        FMainBitmap.canvas.Draw(((FRectsInfo.Rects[i].left+FRectsInfo.Rects[i].right
                                          -FMenuContent[FRectsInfo.Connected[i]].MainBitmap.width) div 2)
                                           ,IGap+FRectsInfo.Rects[i].top-FCurrentPosition,
                                                FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                      end;
                      end else
                      begin
                        if (FmyOwner as TIAeverMenu2).Font3DStyle = iafsRelief then
                        FMainBitmap.canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor)
                        else
                        FMainBitmap.canvas.pen.color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].top+IGap-FCurrentPosition);
                        if (FmyOwner as TIAeverMenu2).Font3DStyle = iafsRelief then
                        FMainBitmap.canvas.pen.color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor)
                        else
                        FMainBitmap.canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.Rects[i].left,FRectsInfo.Rects[i].top+IGap+1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.Rects[i].right-1,FRectsInfo.Rects[i].top+IGap+1-FCurrentPosition);
                      end;

                  end else//splitter...
                  begin
                if FMenuContent[FRectsInfo.Connected[i]].MainBitmap<>nil then
                  begin
                    if FMenuContent[FRectsInfo.Connected[i]].transparent then
                      begin     //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        Bit1:=TBitmap.Create;
                        Bit1.PixelFormat:=pf24bit;
                        Bit1.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                        Bit1.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                        Bit2:=TBitmap.Create;
                        Bit2.PixelFormat:=pf24bit;
                        Bit2.Width:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width;
                        Bit2.Height:=FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Height;
                        Bit1.Canvas.Draw(-(FRectsInfo.Rects[i].right-IGap-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width),
                        -(IGap+FRectsInfo.Rects[i].top-FCurrentPosition),FMainBitmap);
                        Bit2.Canvas.Draw(0,0,FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                        Rr:=0;Gg:=0;Bb:=0;
                        for j:=0 to Bit1.Height-1 do
                          begin
                            p1:=Bit1.ScanLine[j];p2:=Bit2.ScanLine[j];
                            if j=0 then
                              begin
                                Rr:=p2[0];Gg:=p2[1];Bb:=p2[2];
                              end;
                            for k:=0 to Bit1.Width-1 do
                              begin
                                if (Rr<>p2[k*3]) or (Gg<>p2[k*3+1]) or (Bb<>p2[k*3+2]) then
                                  begin
                                    p1[k*3]:=p2[k*3];
                                    p1[k*3+1]:=p2[k*3+1];
                                    p1[k*3+2]:=p2[k*3+2];
                                  end;
                              end;
                          end;
                        FMainBitmap.canvas.Draw(FRectsInfo.Rects[i].right-IGap-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width,
                        IGap+FRectsInfo.Rects[i].top-FCurrentPosition,Bit1);
                        Bit1.free;
                        Bit2.free;
                      end else
                      begin
                        FMainBitmap.canvas.Draw(FRectsInfo.Rects[i].right-IGap-FMenuContent[FRectsInfo.Connected[i]].MainBitmap.Width,
                                                IGap+FRectsInfo.Rects[i].top-FCurrentPosition,
                                                FMenuContent[FRectsInfo.Connected[i]].MainBitmap);
                      end;
                  end;//Draw BackBitmap; //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                  if Maxw=0 then leftfont:=IGap else leftfont:=IGap+TtBMP+Maxw;
                  FMainBitmap.canvas.brush.style:=bsClear;
                  if FMenuContent[FRectsInfo.Connected[i]].ItemName<>'' then
                    begin
                      GetTextExtentPoint32(self.canvas.handle,
                        @(FMenuContent[FRectsInfo.Connected[i]].ItemName[1]),
                        length(FMenuContent[FRectsInfo.Connected[i]].ItemName),Sz);
                      case  (FmyOwner as TIAeverMenu2).Font3DStyle of
                        iafsRelief :
                          begin
                            FMainBitmap.canvas.font.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(FRectsInfo.Rects[i].right-sz.cx-leftfont-1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition-1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                            FMainBitmap.canvas.font.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(FRectsInfo.Rects[i].right-sz.cx-leftfont+1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition+1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                          end;
                        iafsPressed :
                          begin
                            FMainBitmap.canvas.font.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(FRectsInfo.Rects[i].right-sz.cx-leftfont-1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition-1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                            FMainBitmap.canvas.font.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.TextOut(FRectsInfo.Rects[i].right-sz.cx-leftfont+1,
                            -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                            (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition+1,
                            FMenuContent[FRectsInfo.Connected[i]].ItemName);
                          end;
                      end;
                      if not FMenuContent[FRectsInfo.Connected[i]].Grayed then
                      begin
                        if FMenuContent[FRectsInfo.Connected[i]].selected then
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).FSelectFontColor else
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).menufont.Color;
                      end else
                      begin
                        FMainBitmap.canvas.font.Color:=(FmyOwner as TIAeverMenu2).GrayColor;
                      end;

                      FMainBitmap.canvas.TextOut(FRectsInfo.Rects[i].right-sz.cx-leftfont,
                        -abs((FmyOwner as TIAeverMenu2).menufont.size)*3 div 4+
                        (FRectsInfo.Rects[i].bottom+FRectsInfo.Rects[i].top) div 2-FCurrentPosition,
                        FMenuContent[FRectsInfo.Connected[i]].ItemName);

                    end;
                  FMainBitmap.canvas.brush.style:=bsSolid;
                  if FMenuContent[FRectsInfo.Connected[i]].SubMenuList<>nil then
                    begin
                      case  (FmyOwner as TIAeverMenu2).Font3DStyle of
                        iafsRelief :
                          begin //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                            FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left+IGap-1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap-1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition-1);
                            FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left+IGap+1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition+1);
                          end;
                        iafsPressed :
                          begin
                            FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left+IGap-1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)-1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition-1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap-1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition-1);
                            FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                            FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left+IGap+1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)+1,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition+1);
                            FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+1+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition+1);
                          end;
                      end;
                      if FMenuContent[FRectsInfo.Connected[i]].selected then
                      FMainBitmap.canvas.pen.Color:=(FmyOwner as TIAeverMenu2).FSelectFontColor else
                      FMainBitmap.canvas.pen.Color:=(FmyOwner as TIAeverMenu2).menufont.Color;
                      FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                         (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size),
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   -abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size),
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2
                                                   +abs((FmyOwner as TIAeverMenu2).menufont.size)div 2-FCurrentPosition);
                      FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left+IGap+abs((FmyOwner as TIAeverMenu2).menufont.size)div 2,
                                                   (FRectsInfo.rects[i].bottom+FRectsInfo.rects[i].top) div 2 -FCurrentPosition);
                    end;

                 if FMenuContent[FRectsInfo.Connected[i]].selected and (not FMenuContent[FRectsInfo.Connected[i]].Grayed ) then
                  begin
                    FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor);
                    FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].Bottom-1-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].top-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].top-FCurrentPosition);
                    FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                    FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                  end else
                  begin
                    if  FMenuContent[FRectsInfo.Connected[i]].hidden and (not FMenuContent[FRectsInfo.Connected[i]].Grayed ) then
                      begin
                        FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.moveto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].Bottom-1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].top-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].top-FCurrentPosition);
                        FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].right-1,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                        FMainBitmap.canvas.lineto(FRectsInfo.rects[i].left,FRectsInfo.rects[i].bottom-1-FCurrentPosition);
                      end;
                  end;
               end;
              end;//splitter...  
            SelectClipRGN(FMainBitmap.canvas.handle,0);
            deleteobject(RAll);
          end;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
      end;//Case... orientation
      //Draw Bar
      if (FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0 then
         begin
           RGN:=CreateRectRGN(FRectsInfo.BarRect.left,FRectsInfo.BarRect.top,FRectsInfo.BarRect.right,FRectsInfo.BarRect.bottom);
           selectClipRGN(FMainBitmap.canvas.handle,RGN);
           //==========
           BarIndex:=0;
           case FOrientation of
             poLeftRightTopBottom :
               case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=1;
                 iabpAlternate1                : BarIndex:=0;
                 iabpAlternate2                : BarIndex:=2;
               end;
             poRightLeftTopBottom :
               case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=0;
                 iabpAlternate1                : BarIndex:=1;
                 iabpAlternate2                : BarIndex:=2;
               end;
             poLeftRightBottomTop :
               case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=3;
                 iabpAlternate1                : BarIndex:=4;
                 iabpAlternate2                : BarIndex:=2;
               end;
             poRightLeftBottomTop :
               case FMenuContent.BarPosition of
                 iabpMain                      : BarIndex:=4;
                 iabpAlternate1                : BarIndex:=3;
                 iabpAlternate2                : BarIndex:=2;
               end;
           end;  
          

            case BarIndex of
              2 :
                begin//=====
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FMainBitmap.Canvas,
                                         rect(FRectsInfo.BarRect.left+GapBar,
                                              ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                                              FRectsInfo.BarRect.left+GapBar+FMenuContent.BarMainBitmap.Width,
                                              (FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2+FMenuContent.BarMainBitmap.Height div 2));
                          TR:=0;TG:=0;TB:=0;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FMainBitmap.Canvas.Draw(
                            FRectsInfo.BarRect.left+GapBar,
                            ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                            TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FMainBitmap.Canvas.Draw(FRectsInfo.BarRect.left+GapBar,

                            ((FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2 -FMenuContent.BarMainBitmap.Height div 2),
                                      FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FMainBitmap.Canvas.font);
                      FMainBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FMainBitmap.Canvas.brush.Style:=bsClear;
                      if FMenuContent.BarMainBitmap<>nil then
                        begin


                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar+BTtBMP+FMenuContent.BarMainBitmap.width,
                                                   
                                                   (FRectsInfo.BarRect.bottom+FRectsInfo.BarRect.top) div 2-
                                                   3*abs(FMainBitmap.Canvas.font.size) div 4,
                                                   FMenuContent.BarText);



                        end else
                        begin
                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.top+GapBar,FMenuContent.BarText);
                        end;
                      FMainBitmap.Canvas.brush.Style:=bsSolid;
                      FMainBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;//=======
         3 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FMainBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar));
                          TR:=0;TG:=0;TB:=0;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FMainBitmap.Canvas.font);
                      FMainBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FMainBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FMainBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=900;
                      MyLFont.lfOrientation:=900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FMainBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then
                        begin


                          FMainBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2-
                                                      3*abs(FMainBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.bottom-GapBar-BTtBMP-FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        begin
                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.bottom-GapBar,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FMainBitmap.Canvas.brush.Style:=bsSolid;
                      FMainBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
      4 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FMainBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar));
                          TR:=0;TG:=0;TB:=0;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.bottom-GapBar-FMenuContent.BarMainBitmap.Height,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FMainBitmap.Canvas.font);
                      FMainBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      Sz.cx:=0;Sz.cy:=0;
                      if  FMenuContent.BarText<>'' then
                      GetTextExtentPoint32(FMainBitmap.Canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
                      FMainBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FMainBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=-900;
                      MyLFont.lfOrientation:=-900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FMainBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then
                        begin


                          FMainBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2+
                                                      3*abs(FMainBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.bottom-GapBar-BTtBMP-FMenuContent.BarMainBitmap.height-sz.cx,
                                                      FMenuContent.BarText);



                        end else//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        begin
                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.right-GapBar,FRectsInfo.BarRect.bottom-GapBar-sz.cx,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FMainBitmap.Canvas.brush.Style:=bsSolid;
                      FMainBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========          
      0 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FMainBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar+FMenuContent.BarMainBitmap.height));
                          TR:=0;TG:=0;TB:=0;//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FMainBitmap.Canvas.font);
                      FMainBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      FMainBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FMainBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=-900;
                      MyLFont.lfOrientation:=-900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FMainBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then
                        begin


                          FMainBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2+
                                                      3*abs(FMainBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.top+GapBar+BTtBMP+FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        begin
                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.right-GapBar,FRectsInfo.BarRect.top+GapBar,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FMainBitmap.Canvas.brush.Style:=bsSolid;
                      FMainBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
     1 :
                begin //=========
                  if FMenuContent.BarMainBitmap<>nil then
                    begin
                      if FMenuContent.BarTransparent then
                        begin
                          TeBit:=TBitmap.Create;
                          TeBit.PixelFormat:=pf24Bit;
                          TeBit.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1:=TBitmap.Create;
                          TeBit1.PixelFormat:=pf24Bit;
                          TeBit1.Width:=FMenuContent.BarMainBitmap.Width;
                          TeBit1.Height:=FMenuContent.BarMainBitmap.Height;
                          TeBit1.Canvas.Draw(0,0,FMenuContent.BarMainBitmap);
                          TeBit.Canvas.CopyRect(rect(0,0,TeBit.Width,TeBit.Height),FMainBitmap.Canvas,
                                         rect((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              (FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 +
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar+FMenuContent.BarMainBitmap.height));
                          TR:=0;TG:=0;TB:=0; //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          for j:=0 to TeBit.height-1 do
                            begin
                              P1:=TeBit.ScanLine[j];P2:=TeBit1.ScanLine[j];
                              if j=0 then
                                begin
                                  TR:=P2[0];TG:=P2[1];TB:=P2[2];
                                end;
                              for k:=0 to TeBit.Width-1 do
                                begin

                                  if (TR<>P2[k*3]) or (TG<>P2[3*k+1]) or (TB<>P2[3*k+2]) then
                                    begin
                                      P1[k*3]:=P2[k*3];
                                      P1[k*3+1]:=P2[k*3+1];
                                      P1[k*3+2]:=P2[k*3+2];
                                    end;
                                end;
                            end;
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              TeBit);
                          TeBit.Free;
                          TeBit1.Free;
                        end else
                        begin
                          FMainBitmap.Canvas.Draw((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2 -
                                              FMenuContent.BarMainBitmap.Width div 2,
                                              FRectsInfo.BarRect.top+GapBar,
                                              FMenuContent.BarMainBitmap);
                        end;
                  end;//mainbitmap for bar...
                  // Draw the Text...
                  if FMenuContent.BarText<>'' then
                    begin
                      TempFont:=Tfont.Create;
                      TempFont.Assign(FMainBitmap.Canvas.font);
                      FMainBitmap.Canvas.font.Assign(FMenuContent.BarFont);
                      Sz.cx:=0;Sz.cy:=0;
                      if  FMenuContent.BarText<>'' then
                      GetTextExtentPoint32(FMainBitmap.Canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
                      FMainBitmap.Canvas.brush.Style:=bsClear;
                      GETOBJECT(FMainBitmap.Canvas.Font.Handle,sizeof(MyLFont),@MyLFont);
                      MyLfont.lfEscapement:=900;
                      MyLFont.lfOrientation:=900;
                      MyFont:=CREATEFONTINDIRECT(MyLFont);
                      Dc:=FMainBitmap.canvas.handle;
                      oldfont:=selectObject(dc,MyFont);



                      if FMenuContent.BarMainBitmap<>nil then
                        begin


                          FMainBitmap.Canvas.TextOut((FRectsInfo.BarRect.right+FRectsInfo.BarRect.left) div 2-
                                                      3*abs(FMainBitmap.Canvas.font.size) div 4,
                                                      FRectsInfo.BarRect.top+GapBar+BTtBMP+sz.cx+FMenuContent.BarMainBitmap.height,FMenuContent.BarText);



                        end else //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        begin
                          FMainBitmap.Canvas.TextOut(FRectsInfo.BarRect.left+GapBar,FRectsInfo.BarRect.top+GapBar+sz.cx,FMenuContent.BarText);
                        end;
                      deleteobject(selectobject(dc,oldfont));  
                      FMainBitmap.Canvas.brush.Style:=bsSolid;
                      FMainBitmap.Canvas.font.Assign(TempFont);
                      TempFont.free;
                    end;//end of text draw...
                end;  //==========
            end;

           //===========
           selectClipRGN(FMainBitmap.canvas.handle,0);
           deleteobject(RGN);
         end;


    end;
  //-----
  ///-----
  //Draw Close REct
  if (FRectsInfo.HideHiddenRect.Right-FRectsInfo.HideHiddenRect.Left)*(FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top)<>0 then
    begin
      dh:=(FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top) div 2-2;
      dx:=(FRectsInfo.HideHiddenRect.Right-FRectsInfo.HideHiddenRect.Left-dh) div 2;
      dy:=(FRectsInfo.HideHiddenRect.Bottom-FRectsInfo.HideHiddenRect.Top-dh) div 2;


            if (FmyOwner as TIAeverMenu2).Font3DStyle<>iafsPlain then
              begin
                if (FmyOwner as TIAeverMenu2).Font3DStyle=iafsPressed
                  then  FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor)
                  else  FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                FMainBitmap.Canvas.pen.Width:=2;
                FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                          FRectsInfo.HideHiddenRect.top+dy-1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx-1,
                          FRectsInfo.HideHiddenRect.Bottom-dy-1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2-1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx-1,
                          FRectsInfo.HideHiddenRect.Bottom-dy-1);
              end;
            if (FmyOwner as TIAeverMenu2).Font3DStyle<>iafsPlain then
              begin
                if (FmyOwner as TIAeverMenu2).Font3DStyle=iafsPressed
                  then  FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor)
                  else  FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                FMainBitmap.Canvas.pen.Width:=2;
                FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx+1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                          FRectsInfo.HideHiddenRect.top+dy+1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx+1,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx+1,
                          FRectsInfo.HideHiddenRect.Bottom-dy+1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2+1,
                           (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx+1,
                          FRectsInfo.HideHiddenRect.Bottom-dy+1);
              end;
            if FCloseHiddenSelected then
              FMainBitmap.Canvas.pen.color:=(FmyOwner as TIAeverMenu2).selectfontcolor else
              FMainBitmap.Canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).menufont.color);
              FMainBitmap.Canvas.pen.Width:=2;
              FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                          FRectsInfo.HideHiddenRect.top+dy);
              FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.Right-dx,
                          FRectsInfo.HideHiddenRect.Bottom-dy);
              FMainBitmap.Canvas.LineTo((FRectsInfo.HideHiddenRect.Right+FRectsInfo.HideHiddenRect.left) div 2,
                          (FRectsInfo.HideHiddenRect.top+FRectsInfo.HideHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Left+dx,
                          FRectsInfo.HideHiddenRect.Bottom-dy);
 
      FMainBitmap.Canvas.pen.Width:=1;

      if FCloseHiddenSelected then
        begin
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor);
          FMainBitmap.Canvas.MoveTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
          FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.top);
          FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.Right-1,FRectsInfo.HideHiddenRect.top);
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor);
          FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.right-1,FRectsInfo.HideHiddenRect.Bottom-1);
          FMainBitmap.Canvas.LineTo(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom-1);
        end;

    end;
   //Draw Open REct
   if (FRectsInfo.ShowHiddenRect.Right-FRectsInfo.ShowHiddenRect.Left)*(FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top)<>0 then
    begin
      dh:=(FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top) div 2-2;
      dx:=(FRectsInfo.ShowHiddenRect.Right-FRectsInfo.ShowHiddenRect.Left-dh) div 2;
      dy:=(FRectsInfo.ShowHiddenRect.Bottom-FRectsInfo.ShowHiddenRect.Top-dh) div 2;


            if (FmyOwner as TIAeverMenu2).Font3DStyle<>iafsPlain then
              begin
                if (FmyOwner as TIAeverMenu2).Font3DStyle=iafsPressed
                  then  FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor)
                  else  FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
                FMainBitmap.Canvas.pen.Width:=2;
                FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.top-dy-1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy-1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2-1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx-1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy-1);
              end;
            if (FmyOwner as TIAeverMenu2).Font3DStyle<>iafsPlain then
              begin
                if (FmyOwner as TIAeverMenu2).Font3DStyle=iafsPressed
                  then  FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor)
                  else  FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
                FMainBitmap.Canvas.pen.Width:=2;
                FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.top-dy+1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy+1);
                FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2+1,
                           (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2+1);
                FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx+1,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy+1);
              end;
            if FOpenHiddenSelected then
              FMainBitmap.Canvas.pen.color:=(FmyOwner as TIAeverMenu2).selectfontcolor else
              FMainBitmap.Canvas.pen.color:=GetLColor((FmyOwner as TIAeverMenu2).menufont.color);
              FMainBitmap.Canvas.pen.Width:=2;
              FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.top-dy);
              FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.Right-dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy);
              FMainBitmap.Canvas.LineTo((FRectsInfo.ShowHiddenRect.Right+FRectsInfo.ShowHiddenRect.left) div 2,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom) div 2);
              FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Left+dx,
                          (FRectsInfo.ShowHiddenRect.top+FRectsInfo.ShowHiddenRect.Bottom)-FRectsInfo.ShowHiddenRect.Bottom+dy);
 
      FMainBitmap.Canvas.pen.Width:=1;

      if FOpenHiddenSelected then
        begin
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor);
          FMainBitmap.Canvas.MoveTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
          FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.top);
          FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.Right-1,FRectsInfo.ShowHiddenRect.top);
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor);
          FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.right-1,FRectsInfo.ShowHiddenRect.Bottom-1);
          FMainBitmap.Canvas.LineTo(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom-1);
        end;
    end;
  //Draw Up-Down Rects if avaible...
  {
  FUpRect : TRect;
    FDownRect : TRect;
    FUpRectSelected : Boolean;
    FDownRectSelected : Boolean;
  }
  if (FDownRect.Right-FDownRect.Left)*(FDownRect.Bottom-FDownRect.Top)<>0 then
    begin
      FMainBitmap.Canvas.brush.Color:=(FmyOwner as TIAeverMenu2).BackColor;
     // FMainBitmap.Canvas.FillRect(FDownRect);
          if FDownRectSelected then
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor)
          else
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.Canvas.MoveTo(FDownRect.left,FDownRect.bottom-1);
          FMainBitmap.Canvas.LineTo(FDownRect.left,FDownRect.top);
          FMainBitmap.Canvas.LineTo(FDownRect.Right-1,FDownRect.top);
          if FDownRectSelected then
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor)
          else
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.Canvas.LineTo(FDownRect.right-1,FDownRect.Bottom-1);
          FMainBitmap.Canvas.LineTo(FDownRect.left,FDownRect.bottom-1);
    end;
  if (FUpRect.Right-FUpRect.Left)*(FUpRect.Bottom-FUpRect.Top)<>0 then
    begin
      FMainBitmap.Canvas.brush.Color:=(FmyOwner as TIAeverMenu2).BackColor;
   //   FMainBitmap.Canvas.FillRect(FUpRect);
          if FUpRectSelected then
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).SelectColor)
          else
          FMainBitmap.Canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.Canvas.MoveTo(FUpRect.left,FUpRect.bottom-1);
          FMainBitmap.Canvas.LineTo(FUpRect.left,FUpRect.top);
          FMainBitmap.Canvas.LineTo(FUpRect.Right-1,FUpRect.top);
          if FUpRectSelected then
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).SelectColor)
          else
          FMainBitmap.Canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
          FMainBitmap.Canvas.LineTo(FUpRect.right-1,FUpRect.Bottom-1);
          FMainBitmap.Canvas.LineTo(FUpRect.left,FUpRect.bottom-1);
    end;

end;
procedure TIAeverMenuForm.PaintAnimate;
var i,j,Ry : integer;
    R1,R2 : TRect;
    Rgn : HRGN;
begin
  FMainBitmap.Width:=Width;
  FMainBitmap.Height:=Height;
  SetCurrentListBackBitmap(FMenuContent.ListContinued);
  case (FmyOwner as TIAeverMenu2).menuKind of
    mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
      begin
        FMainBitmap.canvas.brush.Color:= (FmyOwner as TIAeverMenu2).BackColor;
        FMainBitmap.canvas.FillRect(ClientRect);
        RGN:=CreateRectRGN(0,0,0,0);
        GetWindowRGN(self.handle,RGN);
        if FMenuContent<>nil then
          begin
            GetRgnBox(RGN,R1);
             Ry:=0;
            case FOrientation of
              poLeftRightTopBottom,poRightLeftTopBottom : Ry:=R1.bottom-R1.top-height;
              poLeftRightBottomTop,poRightLeftBottomTop : Ry:=R1.top;
            end;
            R2:=ClientRect;
            OffsetRect(R2,0,Ry);
            if FCurrentListBackBitmap<>nil then
              begin
                if FMenuContent.MainBackStretch then
                  begin
                    FMainBitmap.canvas.StretchDraw(R2,FCurrentListBackBitmap);
                  end else
                  begin
                    for i:=0 to width div FCurrentListBackBitmap.Width do
                      for j:=0 to height div FCurrentListBackBitmap.Height do
                        FMainBitmap.canvas.Draw(i*FCurrentListBackBitmap.Width,Ry+j*FCurrentListBackBitmap.Height,FCurrentListBackBitmap);
                  end;
              end;
          end;
        FMainBitmap.canvas.pen.Color:=GetLColor((FmyOwner as TIAeverMenu2).BackColor);
        FMainBitmap.canvas.MoveTo(R1.left,R1.bottom-1);
        FMainBitmap.canvas.LineTo(R1.left,R1.top);
        FMainBitmap.canvas.LineTo(R1.right-1,R1.top);
        FMainBitmap.canvas.pen.Color:=GetDColor((FmyOwner as TIAeverMenu2).BackColor);
        FMainBitmap.canvas.LineTo(R1.right-1,R1.bottom-1);
        FMainBitmap.canvas.LineTo(R1.left,R1.bottom-1);
        if (FMyOwner as TIAeverMenu2).menuKind =  mkRects then
          begin
            FMainBitmap.canvas.brush.Color:=getDColor((FmyOwner as TIAeverMenu2).BackColor);
            framergn(FMainBitmap.canvas.handle,Rgn,FMainBitmap.canvas.brush.handle,1,1);
          end;
        deleteobject(RGN);
      end;
  end;
  if (FmyOwner as TIAeverMenu2).semipercent>0 then
    begin
      GetSemiBitmaps;
    end;
end;
procedure TIAeverMenuForm.SetIWindowState(Value : TIAWindowState);
var RGN : HRGN;
begin
  if Value<>FIWindowState then
    begin
      FIWindowstate:=value;
      if value=iawsWorking then
        begin
          RGN:=GetCurrentRegion;
          if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
          setwindowrgn(self.handle,RGN,true) else
          setwindowrgn(self.handle,RGN,false);
          repaint;
        end;
    end;
end;
procedure TIAeverMenuForm.SetOpenHiddenSelected(Value : Boolean);
var
  RGN : HRGN;
begin
  if Value<>FOpenHiddenSelected then
    begin
      FOpenHiddenSelected:=Value;
      IChanged;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
    end;
end;
procedure TIAeverMenuForm.SetCloseHiddenSelected(Value : Boolean);
var
  RGN : HRGN;
begin
  if Value<>FCloseHiddenSelected then
    begin
      FCloseHiddenSelected:=Value;
      IChanged;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
    end;
end;
procedure TIAeverMenuForm.SetUpRectSelected(Value : Boolean);
var
  RGN : HRGN;
begin
  if Value<>FUpRectSelected then
    begin
      FUpRectSelected:=Value;
      IChanged;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
      if Value then postmessage(self.handle,CM_UP,0,0);
    end;
end;

procedure TIAeverMenuForm.SetDownRectSelected(Value : Boolean);
var
  RGN : HRGN;
begin
  if Value<>FDownRectSelected then
    begin
      FDownRectSelected:=Value;
      IChanged;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
      if Value then postmessage(self.handle,CM_Down,0,0);
    end;
end;
procedure TIAeverMenuForm.CMDOWN(var Message : TMessage);
var
  Rgn : HRGN;
begin
  sleep(10);
  Application.ProcessMessages;
  if  FDownRectSelected then
    begin
      inc(FCurrentPosition,(FmyOwner as TIAeverMenu2).FScrollVelocity);
      if FCurrentPosition>FGap then FCurrentPosition:=FGap;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
      postmessage(self.handle,CM_Down,0,0);
    end;
end;
procedure TIAeverMenuForm.CMUP(var Message : TMessage);
var
  Rgn : HRGN;
begin
  sleep(10);
  Application.ProcessMessages;
  if  FUpRectSelected then
    begin
      dec(FCurrentPosition,(FmyOwner as TIAeverMenu2).FScrollVelocity);
      if FCurrentPosition<0 then FCurrentPosition:=0;
      if (FmyOwner as TIAeverMenu2).MenuKind = mkRects then
        begin
          RGN:= GetCurrentRegion;
          SetWindowRGN(self.handle,RGN,TRUE);
        end;
      invalidate;
      postmessage(self.handle,CM_UP,0,0);
    end;
end;
procedure TIAeverMenuForm.IChanged;
begin
  if not IsChanged then
    begin
      self.width:=FRectsinfo.MainRect.right;
      self.height:=FRectsinfo.MainRect.bottom;
      SetRegion;
    end;
  Invalidate;
end;
procedure TIAeverMenuForm.CorrectBarPosition;
begin
  if (FMenuContent.BarMainBitmap<>nil) or (FMenuContent.BarText<>'') then
    begin
       if FMenuContent.BarPosition<>iabpAlternate2 then
         begin
           FRectsInfo.BarRect.Bottom:=FRectsInfo.BarRect.Bottom-FGap;
         end else
         begin
           case Forientation of
             poLeftRightBottomTop,poRightLeftBottomTop : offsetRect(FRectsInfo.BarRect,0,-FGap);
           end;
         end;
    end;
end;
procedure TIAeverMenuForm.DefineBarPosition;
var
  dx,dy,dxm,dym,dright,dbottom,i : integer;
  TempFont : TFont;
  Maxw,Maxh : integer;
  Sz : TSize;
  GapUL,GapRD,GapBtR,GapBar,BTtBMP : integer;
begin
   //====================
  case (FmyOwner as TIAeverMenu2).menuKind of
    mkRects :
      begin

        GapUL := mtRUpLeftgap;
        GapRD := mtRBottomRightgap;
        GapBtR := mtRBartoRectgap;


        GapBar := mtRBargap;

        BTtBMP :=mtRBarTexttoBMP;
      end;
    mkWide,mkWideCorner :
      begin

        GapUL := mtEUpLeftgap;
        GapRD := mtEBottomRightgap;
        GapBtR := mtEBartoRectgap;


        GapBar := mtEBargap;

        BTtBMP :=mtEBarTexttoBMP;
      end;
    mkSimple,mkSimpleCorner :
      begin

        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;


        GapBar := mtSBargap;

        BTtBMP :=mtSBarTexttoBMP;
      end;
    else
      begin

        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
       

        GapBar := mtSBargap;


        BTtBMP :=mtSBarTexttoBMP;
      end;
  end;


  //+++++++++++++++++++
  //Menu Bar...
        FRectsInfo.BarRect:=rect(0,0,0,0);
        if (FMenuContent.BarMainBitmap<>nil) or (FMenuContent.BarText<>'') then
          begin
            TempFont:=TFont.Create;
            TempFont.Assign(self.canvas.font);
            self.canvas.font.Assign(FMenuContent.BarFont);
            Sz.cx:=0;Sz.cy:=0;
            if  FMenuContent.BarText<>'' then
            GetTextExtentPoint32(self.canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
            MaxW:=-BTtBMP;MaxH:=-BTtBMP; //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
            if FMenuContent.BarMainBitmap<>nil then
              begin
                MaxW:=FMenuContent.BarMainBitmap.Width;
                MaxH:=FMenuContent.BarMainBitmap.Height;
              end;
            self.canvas.font.Assign(TempFont);
            TempFont.Free;
            dx:=0;dy:=0;dxm:=0;dym:=0;dright:=0;dbottom:=0;
            case FMenuContent.BarPosition of
              iabpMain,iabpAlternate1 :
                begin
                  FRectsInfo.BarRect:=rect(0,0,2*GapBar+max(Maxw,SZ.cy),max(FRectsinfo.MainRect.Bottom-FRectsinfo.MainRect.Top
                  -GapRD-GapUL,BTtBMP+2*GapBar+Maxh+Sz.cx));
                end;
              iabpAlternate2 :
                begin
                  FRectsInfo.BarRect:=rect(0,0,max(FRectsinfo.MainRect.Right-FRectsinfo.MainRect.Left
                  -GapUL-GapRD,BTtBMP+2*GapBar+Sz.cx+Maxw),2*GapBar+max(Maxh,sz.cy));
                end;
            end;
            case FOrientation of
              poLeftRightTopBottom :
                begin
                  case FMenuContent.BarPosition of
                    iabpMain :   //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                      begin
                        dx:=GapBtR+FRectsInfo.BarRect.right;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                    iabpAlternate1 :
                      begin
                        dx:=0;dy:=0;dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,FRectsinfo.MainRect.right+GapBtR-GapRD,GapUL);
                      end;
                    iabpAlternate2 :
                      begin
                        dx:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right+FRectsinfo.MainRect.left) div 2;
                        dy:=GapBtR+FRectsInfo.BarRect.bottom;
                        dxm:=0;dym:=0;
                        dright:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right+FRectsinfo.MainRect.left);
                        dbottom:=GapBtR+FRectsInfo.BarRect.bottom;
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                  end;
                end;
              poRightLeftTopBottom :
                begin
                  case FMenuContent.BarPosition of
                    iabpMain :
                      begin
                        dx:=0;dy:=0;dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,FRectsinfo.MainRect.right+GapBtR-GapRD,GapUL);
                      end;
                    iabpAlternate1 :
                      begin
                        dx:=GapBtR+FRectsInfo.BarRect.right;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                    iabpAlternate2 :            //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                      begin
                        dx:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right+FRectsinfo.MainRect.left) div 2;
                        dy:=GapBtR+FRectsInfo.BarRect.bottom;
                        dxm:=0;dym:=0;
                        dright:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right+FRectsinfo.MainRect.left);
                        dbottom:=GapBtR+FRectsInfo.BarRect.bottom;
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                  end;
                end;
              poLeftRightBottomTop :
                begin
                  case FMenuContent.BarPosition of
                    iabpMain :
                      begin
                        dx:=GapBtR+FRectsInfo.BarRect.right;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                    iabpAlternate1 :
                      begin
                        dx:=0;dy:=0;dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,FRectsinfo.MainRect.right+GapBtR-GapRD,GapUL);
                      end;
                    iabpAlternate2 :
                      begin
                        dx:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right) div 2;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right);
                        dbottom:=GapBtR+FRectsInfo.BarRect.bottom;
                        offsetrect(FRectsInfo.BarRect,GapUL,FRectsinfo.MainRect.bottom-FRectsinfo.MainRect.top+GapBtR-GapRD);
                      end;
                  end; //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                end;
              poRightLeftBottomTop :
                begin
                  case FMenuContent.BarPosition of
                    iabpMain :
                      begin
                        dx:=0;dy:=0;dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,FRectsinfo.MainRect.right+GapBtR-GapRD,GapUL);
                      end;
                    iabpAlternate1 :
                      begin
                        dx:=GapBtR+FRectsInfo.BarRect.right;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=GapBtR+FRectsInfo.BarRect.right;
                        dbottom:=max(0,FRectsInfo.BarRect.bottom+GapUL+GapRD-FRectsinfo.MainRect.Bottom+FRectsinfo.MainRect.top);
                        offsetrect(FRectsInfo.BarRect,GapUL,GapUL);
                      end;
                    iabpAlternate2 :
                      begin
                        dx:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right) div 2;dy:=0;
                        dxm:=0;dym:=0;
                        dright:=max(0,FRectsInfo.BarRect.right+GapUL+GapRD-FRectsinfo.MainRect.right);
                        dbottom:=GapBtR+FRectsInfo.BarRect.bottom;
                        offsetrect(FRectsInfo.BarRect,GapUL,FRectsinfo.MainRect.bottom-FRectsinfo.MainRect.top+GapBtR-GapRD);
                      end;
                  end;
                end;
            end;




            for i:=0 to length(FRectsInfo.Rects)-1 do
              begin
                offsetrect(FRectsInfo.rects[i],dx,dy);
              end;
            offsetrect(FRectsInfo.ShowHiddenRect,dx,dy);
            offsetrect(FRectsInfo.HideHiddenRect,dx,dy);
            offsetrect(FRectsInfo.MainRect,dxm,dym);
            FRectsInfo.MainRect.Right:=FRectsInfo.MainRect.Right+dright;
            FRectsInfo.MainRect.bottom:=FRectsInfo.MainRect.bottom+dbottom;
          end;
end;
procedure TIAeverMenuForm.GetRectsInfo(ABefore : Boolean =false);
var i,MaxWw,HiddenNumber,N,MaxWS,RealHeight,dy1,dy2 : integer;
    IHaveHidden,IHaveSub : Boolean;
    Sz : TSize;
    TempRects : array of TRect;
    {Atleft,atRight,}atTop,atBottom : integer;
    TempFont : TFont;
    Maxw,Maxh : integer;
    Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,TtS,IGap,GapBar,BTtBMP : integer;
begin
 //====================
  case (FMyOwner as TIAeverMenu2).menuKind of
    mkRects :
      begin
        Gap1:=    mtRgap;
        GapUL :=  mtRUpLeftgap;
        GapRD :=  mtRBottomRightgap;
        GapBtR := mtRBartoRectgap;
        GapRtC := mtRRecttoControlgap;
        CSize :=  mtRControlSize;

        GapBar := mtRBargap;
        TtBMP :=  mtRTexttoBMP;
        Tts:=     mtRTexttoSub;
        IGap  :=  mtRItemGap;
        BTtBMP := mtRBarTexttoBMP;
      end;
    mkWide,mkWideCorner :
      begin
        Gap1:= mtEgap;
        GapUL := mtEUpLeftgap;
        GapRD := mtEBottomRightgap;
        GapBtR := mtEBartoRectgap;
        GapRtC := mtERecttoControlgap;
        CSize := mtEControlSize;

        GapBar := mtEBargap;
        TtBMP := mtETexttoBMP;
        Tts:=mtETexttoSub;
        IGap  := mtEItemGap;
        BTtBMP :=mtEBarTexttoBMP;
      end;
    mkSimple,mkSimpleCorner :
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        Tts:=mtSTexttoSub;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
    else
      begin
        Gap1:= mtSgap;
        GapUL := mtSUpLeftgap;
        GapRD := mtSBottomRightgap;
        GapBtR := mtSBartoRectgap;
        GapRtC := mtSRecttoControlgap;
        CSize := mtSControlSize;

        GapBar := mtSBargap;
        TtBMP := mtSTexttoBMP;
        Tts:=mtSTexttoSub;
        IGap  := mtSItemGap;
        BTtBMP :=mtSBarTexttoBMP;
      end;
  end;


  //+++++++++++++++++++
 Self.Canvas.Font.Assign((FMyOwner as TIAeverMenu2).FMenuFont);
  if ABefore then
    begin
      maxWw:=0;maxWs:=0;
      for i:=0 to FMenuContent.ItemsNumber-1 do
        begin
           if (FMenuContent[i].MainBitmap<>nil) and (not FMenuContent[i].Splitter) then
             begin
               MaxWw:=Max(MaxWw,FMenuContent[i].MainBitmap.Width);
             end;
           if (not FMenuContent[i].Splitter) and (FMenuContent[i].ItemName<>'') then
             begin
               GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
               MaxWs:=Max(MaxWs,Sz.cx);
             end;  
        end;
      IhaveHidden:=False;{HiddenNumber:=0;}IHaveSub:=false;   //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
      for i:=0 to FMenuContent.ItemsNumber-1 do
        begin
          if FMenuContent[i].hidden then
            begin
              IHaveHidden:=True;
    //          inc(HiddenNumber);
            end;
          if FMenuContent[i].SubMenuList<>nil then IHaveSub:=true;
        end;
      case (FmyOwner as TIAeverMenu2).menuKind of
        mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
          begin
            SetLength(TempRects,FMenuContent.ItemsNumber);
            if maxWw=0 then maxWw:=-TtBMP;
            if maxWs=0 then maxWs:=-TtBMP;
            for i:=0 to FMenuContent.ItemsNumber-1 do
              begin
                if FMenuContent[i].Splitter then
                  begin
                    if (FMenuContent[i].MainBitmap<>nil) then
                      begin
                        if IHaveSub then//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                        TempRects[i]:=Rect(0,0,maxWw+IGap*2+TtBMP+MaxWs+2*abs(self.font.size),FMenuContent[i].MainBitmap.Height+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+2*IGap+MaxWs+TtBMP,FMenuContent[i].MainBitmap.Height+2*IGap);
                      end else
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*abs(self.font.size)+2*IGap,2+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,2+2*IGap);
                      end;
                  end else
                  begin
                    Sz.cx:=0;Sz.cy:=0;
                    if FMenuContent[i].ItemName<>'' then
                    GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
                    if (FMenuContent[i].MainBitmap<>nil) then
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+Tts+2*abs(self.font.size)+2*IGap,max(Sz.cy,FMenuContent[i].MainBitmap.height)+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,max(Sz.cy,FMenuContent[i].MainBitmap.height)+2*IGap);
                      end else
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+Tts+2*abs(self.font.size)+2*IGap,Sz.cy+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,Sz.cy+2*IGap);
                      end;

                  end;
              end;
          end;
      end;
      //We define the real dimension of Rect...
      case (FmyOwner as TIAeverMenu2).menuKind of
        mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
          begin
            if FMenuContent.ShowHidden then
              begin
                if IHaveHidden then
                  begin
                    RealHeight:=GapUL+GapRD+CSize+GapRtC; //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                    for i:=0 to FMenuContent.ItemsNumber-1 do
                      begin
                        inc(RealHeight,TempRects[i].Bottom+Gap1);
                      end;
                    if FMenuContent.ItemsNumber>0 then
                    FRectsinfo.MainRect:=rect(0,0,GapUL+GapRD+TempRects[0].right,RealHeight-Gap1)
                    else
                    FRectsinfo.MainRect:=rect(0,0,maxWw+TtBMP+MaxWs+GapUL+GapRD,RealHeight-GapRtC);
                  end else //IhaveHidden
                  begin
                    RealHeight:=GapUL+GapRD;
                    for i:=0 to FMenuContent.ItemsNumber-1 do
                      begin
                        inc(RealHeight,TempRects[i].Bottom+Gap1);
                      end;
                    if FMenuContent.ItemsNumber>0 then
                    FRectsinfo.MainRect:=rect(0,0,GapUL+GapRD+TempRects[0].right,RealHeight-Gap1)
                    else
                    FRectsinfo.MainRect:=rect(0,0,maxWw+TtBMP+MaxWs+GapUL+GapRD,RealHeight);
                  end;
              end else //ShowHidden
              begin
                if IHaveHidden then
                  begin
                    RealHeight:=GapUL+GapRD+CSize+GapRtC;
                    for i:=0 to FMenuContent.ItemsNumber-1 do
                      begin
                        if not FMenuContent[i].hidden then
                          begin
                            inc(RealHeight,TempRects[i].Bottom+Gap1);
                          end;
                      end;
                    if FMenuContent.ItemsNumber>0 then
                    FRectsinfo.MainRect:=rect(0,0,GapUL+GapRD+TempRects[0].right,RealHeight-Gap1)
                    else
                    FRectsinfo.MainRect:=rect(0,0,maxWw+TtBMP+MaxWs+GapUL+GapRD,RealHeight-GapRtC);
                  end else //IhaveHidden
                  begin
                    RealHeight:=GapUL+GapRD;
                    for i:=0 to FMenuContent.ItemsNumber-1 do
                      begin
                        inc(RealHeight,TempRects[i].Bottom+Gap1);
                      end;
                    if FMenuContent.ItemsNumber>0 then
                    FRectsinfo.MainRect:=rect(0,0,GapUL+GapRD+TempRects[0].right,RealHeight-Gap1)
                    else
                    FRectsinfo.MainRect:=rect(0,0,maxWw+TtBMP+MaxWs+GapUL+GapRD,RealHeight);
                  end;
              end;
          end; //mkSimple
      end;
          if (FMenuContent.BarMainBitmap<>nil) or (FMenuContent.BarText<>'') then
          begin     //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
            TempFont:=TFont.Create;
            TempFont.Assign(self.canvas.font);
            self.canvas.font.Assign(FMenuContent.BarFont);
            Sz.cx:=0;Sz.cy:=0;
            if  FMenuContent.BarText<>'' then
            GetTextExtentPoint32(self.canvas.handle,@(FMenuContent.BarText[1]),length(FMenuContent.BarText),Sz);
            MaxW:=-BTtBMP;MaxH:=-BTtBMP;
            if FMenuContent.BarMainBitmap<>nil then
              begin
                MaxW:=FMenuContent.BarMainBitmap.Width;
                MaxH:=FMenuContent.BarMainBitmap.Height;
              end;
            self.canvas.font.Assign(TempFont);
            TempFont.Free;
            case FMenuContent.BarPosition of
              iabpMain,iabpAlternate1 :
                begin
                  FRectsinfo.MainRect.Right:=FRectsinfo.MainRect.Right+GapBtR+max(Maxw,SZ.cy)+2*GapBar;
                  FRectsinfo.MainRect.Bottom:=max(FRectsinfo.MainRect.Bottom,2*GapBar+BTtBMP+Maxh+Sz.cx);
                end;
              iabpAlternate2 :
                begin
                  FRectsinfo.MainRect.Right:=max(FRectsinfo.MainRect.Right,2*GapBar+BTtBMP+Sz.cx+Maxw);
                  FRectsinfo.MainRect.Bottom:=FRectsinfo.MainRect.Bottom+GapBtR+2*GapBar+max(Maxh,sz.cy);
                end;
            end;
         end;     
    end else //ABefore...
    begin //Normal evaluation Begin....



      maxWw:=0;maxWs:=0;
      for i:=0 to FMenuContent.ItemsNumber-1 do
        begin
           if (FMenuContent[i].MainBitmap<>nil) and (not FMenuContent[i].Splitter) then
             begin
               MaxWw:=Max(MaxWw,FMenuContent[i].MainBitmap.Width);
             end;
           if (not FMenuContent[i].Splitter) and (FMenuContent[i].ItemName<>'') then
             begin
               GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
               MaxWs:=Max(MaxWs,Sz.cx);
             end;  
        end;
      IhaveHidden:=False;HiddenNumber:=0;IHaveSub:=false;
      for i:=0 to FMenuContent.ItemsNumber-1 do
        begin
          if FMenuContent[i].hidden then
            begin
              IHaveHidden:=True;
              inc(HiddenNumber);
            end;
          if FMenuContent[i].SubMenuList<>nil then IHaveSub:=true;
        end;
      case (FmyOwner as TIAeverMenu2).menuKind of
        mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
          begin
            SetLength(TempRects,FMenuContent.ItemsNumber);  //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
            if maxWw=0 then maxWw:=-TtBMP;
            if maxWs=0 then maxWs:=-TtBMP;
            for i:=0 to FMenuContent.ItemsNumber-1 do
              begin
                if FMenuContent[i].Splitter then
                  begin
                    if (FMenuContent[i].MainBitmap<>nil) then
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*abs(self.font.size)+2*IGap,FMenuContent[i].MainBitmap.Height+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,FMenuContent[i].MainBitmap.Height+2*IGap);
                      end else
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+2*IGap+MaxWs+2*abs(self.font.size)+TtBMP,2+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+2*IGap+MaxWs+TtBMP,2+2*IGap);
                      end;
                  end else
                  begin
                    Sz.cx:=0;Sz.cy:=0;
                    if FMenuContent[i].ItemName<>'' then
                    GetTextExtentPoint32(self.canvas.handle,@(FMenuContent[i].ItemName[1]),length(FMenuContent[i].ItemName),Sz);
                    if (FMenuContent[i].MainBitmap<>nil) then
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+Tts+2*abs(self.font.size)+2*IGap,max(Sz.cy,FMenuContent[i].MainBitmap.height)+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,max(Sz.cy,FMenuContent[i].MainBitmap.height)+2*IGap);
                      end else
                      begin
                        if IHaveSub then
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+Tts+2*abs(self.font.size)+2*IGap,Sz.cy+2*IGap)
                        else
                        TempRects[i]:=Rect(0,0,maxWw+TtBMP+MaxWs+2*IGap,Sz.cy+2*IGap);
                      end;
                  end;
              end;
          end;
      end;
      //We defined the dimentions of rects..
      if FHorizontal then
        begin
        //  AtLeft:=FRect.Right;AtRight:=Screen.Width-FRect.Left;
          AtTop:=FRect.Top;AtBottom:=Screen.Height-FRect.Bottom;
        end else//FHorizontal;
        begin
      //    AtLeft:=FRect.Left;AtRight:=Screen.Width-FRect.Right;
          AtTop:=FRect.Bottom;AtBottom:=Screen.Height-FRect.Top;
        end;
      case (FmyOwner as TIAeverMenu2).menuKind of
        mkSimple,mkWide,mkRects,mkSimpleCorner,mkWideCorner :
          begin
            Case FOrientation of
              poLeftRightTopBottom,poRightLeftTopBottom :
                begin
                  if FMenuContent.ShowHidden then
                    begin
                      FRectsinfo.ShowHiddenRect:=Rect(0,0,0,0);
                      if IHaveHidden then
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                          if FMenuContent.ItemsNumber>0 then   //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,TempRects[0].right+GapUL,GapUL+CSize) else
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL+CSize);
                          for i:=0 to FMenuContent.ItemsNumber-1 do
                            begin
                              if i=0 then
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom+GapRtC,
                                         FRectsInfo.HideHiddenRect.right,FRectsInfo.HideHiddenRect.bottom+GapRtC+TempRects[i].bottom)
                              else
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.Rects[i-1].left,FRectsInfo.Rects[i-1].bottom+Gap1,
                                         FRectsInfo.Rects[i-1].right,FRectsInfo.Rects[i-1].bottom+Gap1+TempRects[i].bottom);
                              FRectsInfo.Connected[i]:=i;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapUL+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapUL+GapRD,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtBottom);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap; 
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtBottom);
                          CorrectBarPosition;
                        end else //IHaveHidden
                        begin//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,TempRects[0].right+GapUL,GapUL) else
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL);
                          for i:=0 to FMenuContent.ItemsNumber-1 do
                            begin
                              if i=0 then
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.HideHiddenRect.left,FRectsInfo.HideHiddenRect.bottom,
                                         FRectsInfo.HideHiddenRect.right,FRectsInfo.HideHiddenRect.bottom+TempRects[i].bottom)
                              else
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.Rects[i-1].left,FRectsInfo.Rects[i-1].bottom+Gap1,
                                         FRectsInfo.Rects[i-1].right,FRectsInfo.Rects[i-1].bottom+Gap1+TempRects[i].bottom);
                              FRectsInfo.Connected[i]:=i;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapUL+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-1].Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapUL+GapRD,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtBottom);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap; 
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtBottom);
                          CorrectBarPosition;
                        end;
                    end else //ShowHidden...
                    begin
                      FRectsinfo.HideHiddenRect:=Rect(0,0,0,0);
                      if IHaveHidden then
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,TempRects[0].right+GapUL,GapUL+CSize) else
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL+CSize);
                          N:=0;
                          for i:=0 to FMenuContent.ItemsNumber-1 do  //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                            begin
                              if not FMenuContent[i].hidden then
                              begin
                                if N=0 then
                                  FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom+GapRtC,
                                         FRectsInfo.ShowHiddenRect.right,FRectsInfo.ShowHiddenRect.bottom+GapRtC+TempRects[i].bottom)
                                else
                                  FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                          FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+Gap1+TempRects[i].bottom);
                                  FRectsInfo.Connected[N]:=i;
                                inc(N);
                              end;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapUL+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapUL+GapRD,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtBottom);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap; 
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtBottom);
                          CorrectBarPosition;
                        end else //IHaveHidden
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,TempRects[0].right+GapUL,GapUL) else
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL);
                          N:=0;
                          for i:=0 to FMenuContent.ItemsNumber-1 do  //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                            begin
                              if not FMenuContent[i].hidden then
                                begin
                                  if N=0 then
                                  FRectsInfo.Rects[N]:=Rect(FRectsInfo.ShowHiddenRect.left,FRectsInfo.ShowHiddenRect.bottom,
                                             FRectsInfo.ShowHiddenRect.right,FRectsInfo.ShowHiddenRect.bottom+TempRects[i].bottom)
                                  else
                                  FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                             FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+Gap1+TempRects[i].bottom);
                                  FRectsInfo.Connected[N]:=i;
                                  inc(N);
                                end;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapUL+GapRD,FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapUL+GapRD,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtBottom);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap; 
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtBottom);
                          CorrectBarPosition;
                        end;
                    end;
                    dy1:=0;dy2:=0;
                  if (FMenuContent.BarPosition = iabpAlternate2) and
                     ((FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0) then
                    begin
                      case FOrientation of
                        poLeftRightTopBottom,poRightLeftTopBottom : dy1:=FRectsInfo.BarRect.Bottom-FRectsInfo.BarRect.top;
                        poLeftRightBottomTop,poRightLeftBottomTop : dy2:=FRectsInfo.BarRect.top-FRectsInfo.BarRect.Bottom;
                      end;
                    end;
                    if FGap=0 then
                      begin
                        FUpRect:=rect(0,0,0,0);
                        FDownRect:=rect(0,0,0,0);
                      end else
                      begin
                        if length(FRectsInfo.Rects)>0 then
                          begin
                            if FCurrentPosition=0 then FUpRect:=rect(0,0,0,0) else
                              begin
                                if IHaveHidden and ((FOrientation=poLeftRightTopBottom) or(FOrientation=poRightLeftTopBottom)) then
                                  FUpRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                GapUL+CSize+dy1,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                GapUL+6+CSize+dy1)
                                                else  //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                                  FUpRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                GapUL+dy1,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                GapUL+6+dy1);
                              end;
                            if FCurrentPosition=FGap then FDownRect:=Rect(0,0,0,0)
                             else
                               begin
                                if IHaveHidden and ((FOrientation=poLeftRightBottomTop) or(FOrientation=poRightLeftBottomTop)) then
                                 FDownRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                FRectsInfo.MainRect.Bottom-GapRD-6-CSize+dy2,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                FRectsInfo.MainRect.Bottom-GapRD-CSize+dy2)
                                                  else

                                 FDownRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                FRectsInfo.MainRect.Bottom-FRectsInfo.MainRect.top-GapRD-6+dy2,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                FRectsInfo.MainRect.Bottom-FRectsInfo.MainRect.top-GapRD+dy2);
                               end;
                          end else
                          begin
                            FUpRect:=rect(0,0,0,0);
                            FDownRect:=rect(0,0,0,0);
                          end;
                      end;
                end;
              poLeftRightBottomTop,poRightLeftBottomTop :
                begin
                  if FMenuContent.ShowHidden then
                    begin
                      FRectsinfo.ShowHiddenRect:=Rect(0,0,0,0);
                      if IHaveHidden then
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);

                          for i:=0 to FMenuContent.ItemsNumber-1 do  //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                            begin
                              if i=0 then
                              FRectsInfo.Rects[i]:=Rect(GapUL,GapUL,
                                         TempRects[0].right+GapUL,GapUL+TempRects[i].bottom)
                              else
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.Rects[i-1].left,FRectsInfo.Rects[i-1].bottom+Gap1,
                                         FRectsInfo.Rects[i-1].right,FRectsInfo.Rects[i-1].bottom+TempRects[i].bottom+Gap1);
                              FRectsInfo.Connected[i]:=i;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.HideHiddenRect:=Rect(FRectsInfo.Rects[FMenuContent.ItemsNumber-1].left,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].bottom+GapRtC,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].right,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].bottom+GapRtC+CSize) else
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,GapRD+GapUL,GapRD+GapUL+CSize);

                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapRD+GapUL,FRectsinfo.HideHiddenRect.Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapRD+GapUL,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtTop);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap;

                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtTop);
                          offsetrect(FRectsinfo.HideHiddenRect,0,-FGap);
                          CorrectBarPosition;
                        end else //IHaveHidden
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber);
                          for i:=0 to FMenuContent.ItemsNumber-1 do
                            begin
                              if i=0 then //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                              FRectsInfo.Rects[i]:=Rect(GapUL,GapUL,
                                         TempRects[0].right+GapUL,GapUL+TempRects[i].bottom)
                              else
                              FRectsInfo.Rects[i]:=Rect(FRectsInfo.Rects[i-1].left,FRectsInfo.Rects[i-1].bottom+Gap1,
                                         FRectsInfo.Rects[i-1].right,FRectsInfo.Rects[i-1].bottom+TempRects[i].bottom+Gap1);
                              FRectsInfo.Connected[i]:=i;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.HideHiddenRect:=Rect(FRectsInfo.Rects[FMenuContent.ItemsNumber-1].left,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].bottom,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].right,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-1].bottom) else
                          FRectsinfo.HideHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL+CSize);

                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapRD+GapUL,FRectsinfo.HideHiddenRect.Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapRD+GapUL,FRectsInfo.HideHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtTop);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap;
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtTop);
                          offsetrect(FRectsinfo.HideHiddenRect,0,-FGap);
                          CorrectBarPosition;
                        end;
                    end else //ShowHidden...
                    begin
                      FRectsinfo.HideHiddenRect:=Rect(0,0,0,0);
                      if IHaveHidden then
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                           N:=0;
                          for i:=0 to FMenuContent.ItemsNumber-1 do
                            begin
                              if not FMenuContent[i].hidden then
                                begin
                                  if N=0 then //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                                    FRectsInfo.Rects[N]:=Rect(GapUL,GapUL,TempRects[i].right+GapUL,GapUL+TempRects[i].bottom)
                                  else
                                    FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                           FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+Gap1+TempRects[i].bottom);
                                  FRectsInfo.Connected[N]:=i;
                                  inc(N);
                               end;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.ShowHiddenRect:=Rect(FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].left,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].bottom+GapRtC,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].right,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].bottom+GapRtC+CSize) else
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL+CSize);

                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapRD+GapUL,FRectsinfo.ShowHiddenRect.Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapRD+GapUL,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtTop);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap; 
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtTop);
                          offsetrect(FRectsinfo.ShowHiddenRect,0,-FGap);
                          CorrectBarPosition;
                        end else //IHaveHidden
                        begin
                          setlength(FRectsInfo.rects,FMenuContent.ItemsNumber-HiddenNumber);
                          setlength(FRectsInfo.Connected,FMenuContent.ItemsNumber-HiddenNumber);
                          N:=0;
                          for i:=0 to FMenuContent.ItemsNumber-1 do
                            begin
                              if not FMenuContent[i].hidden then
                                begin
                                  if N=0 then//Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                                    FRectsInfo.Rects[N]:=Rect(GapUL,GapUL,TempRects[i].right+GapUL,GapUL+TempRects[i].bottom)
                                  else
                                    FRectsInfo.Rects[N]:=Rect(FRectsInfo.Rects[N-1].left,FRectsInfo.Rects[N-1].bottom+Gap1,
                                           FRectsInfo.Rects[N-1].right,FRectsInfo.Rects[N-1].bottom+Gap1+TempRects[i].bottom);
                                  FRectsInfo.Connected[N]:=i;
                                  inc(N);
                               end;
                            end;
                          if FMenuContent.ItemsNumber>0 then
                          FRectsinfo.ShowHiddenRect:=Rect(FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].left,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].bottom,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].right,
                                                          FRectsInfo.Rects[FMenuContent.ItemsNumber-HiddenNumber-1].bottom) else
                          FRectsinfo.ShowHiddenRect:=Rect(GapUL,GapUL,GapUL,GapUL+CSize);

                          if FMenuContent.ItemsNumber>0 then
                          FRectsInfo.MainRect:=Rect(0,0,TempRects[0].right+GapUL+GapRD,FRectsinfo.ShowHiddenRect.Bottom+GapRD)
                          else
                          FRectsInfo.MainRect:=Rect(0,0,GapUL+GapRD,FRectsInfo.ShowHiddenRect.Bottom+GapRD);
                          DefineBarPosition;
                          FGap:=max(0,FRectsInfo.MainRect.Bottom-AtTop);
                          if FCurrentPosition>=FGap then FCurrentPosition:=FGap;
                          FRectsInfo.MainRect.Bottom:=min(FRectsInfo.MainRect.Bottom,AtTop);
                          offsetrect(FRectsinfo.ShowHiddenRect,0,-FGap);
                          CorrectBarPosition;
                        end;
                    end;
                  dy1:=0;dy2:=0;
                  if (FMenuContent.BarPosition = iabpAlternate2) and
                     ((FRectsInfo.BarRect.Right-FRectsInfo.BarRect.left)*(FRectsInfo.BarRect.bottom-FRectsInfo.BarRect.top)>0) then
                    begin
                      case FOrientation of
                        poLeftRightTopBottom,poRightLeftTopBottom : dy1:=FRectsInfo.BarRect.Bottom-FRectsInfo.BarRect.top;
                        poLeftRightBottomTop,poRightLeftBottomTop : dy2:=FRectsInfo.BarRect.top-FRectsInfo.BarRect.Bottom;
                      end;
                    end;
                  if FGap=0 then
                      begin
                        FUpRect:=rect(0,0,0,0);
                        FDownRect:=rect(0,0,0,0);
                      end else
                      begin
                        if length(FRectsInfo.Rects)>0 then
                          begin
                            if FCurrentPosition=0 then FUpRect:=rect(0,0,0,0) else
                              begin
                                if IHaveHidden and ((FOrientation=poLeftRightTopBottom) or(FOrientation=poRightLeftTopBottom)) then
                                  FUpRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                GapUL+CSize+dy1,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                GapUL+6+CSize+dy1)
                                                else //Gap1,GapUL,GapRD,GapBtR,GapRtC,CSize,TtBMP,IGap,GapBar,BTtBMP
                                  FUpRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                GapUL+dy1,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                GapUL+6+dy1);
                              end;
                            if FCurrentPosition=FGap then FDownRect:=Rect(0,0,0,0)
                             else
                               begin
                                if IHaveHidden and ((FOrientation=poLeftRightBottomTop) or(FOrientation=poRightLeftBottomTop)) then
                                 FDownRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                FRectsInfo.MainRect.Bottom-GapRD-6-CSize+dy2,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                FRectsInfo.MainRect.Bottom-GapRD-CSize+dy2)
                                                  else
                                              
                                 FDownRect:=rect(FRectsInfo.Rects[length(FRectsInfo.Rects)-1].left,
                                                FRectsInfo.MainRect.Bottom-FRectsInfo.MainRect.top-GapRD-6+dy2,
                                                FRectsInfo.Rects[length(FRectsInfo.Rects)-1].right,
                                                FRectsInfo.MainRect.Bottom-FRectsInfo.MainRect.top-GapRD+dy2);
                               end;
                          end else
                          begin
                            FUpRect:=rect(0,0,0,0);
                            FDownRect:=rect(0,0,0,0);
                          end;
                      end;
                end;

            end;
          end;//mkSimple...
      end;
      //Defining of Top..Left...
      if (FmyOwner as TIAeverMenu2).semipercent>0 then GetSemi(FRectsinfo.MainRect.right,FRectsinfo.MainRect.bottom);
      case FOrientation of
        poLeftRightTopBottom :
          begin
            if FHorizontal then
              begin
                self.top:=Frect.Bottom;self.Left:=FRect.Left;
              end else
              begin
                self.top:=Frect.Top;self.Left:=FRect.Right;
              end;
          end;
        poRightLeftTopBottom :
          begin
            if FHorizontal then
              begin
                self.top:=Frect.Bottom;self.Left:=FRect.right-FRectsinfo.MainRect.right;
              end else
              begin
                self.top:=Frect.Top;self.Left:=FRect.left-FRectsinfo.MainRect.right;
              end;
          end;
        poLeftRightBottomTop :
          begin
            if FHorizontal then
              begin
                self.top:=Frect.top-FRectsinfo.MainRect.bottom;self.Left:=FRect.Left;
              end else
              begin
                self.top:=Frect.bottom-FRectsinfo.MainRect.bottom;self.Left:=FRect.Right;
              end;
          end;
        poRightLeftBottomTop :
          begin
            if FHorizontal then
              begin
                self.top:=Frect.top-FRectsinfo.MainRect.bottom;self.Left:=FRect.right-FRectsinfo.MainRect.right;
              end else
              begin
                self.top:=Frect.bottom-FRectsinfo.MainRect.bottom;self.Left:=FRect.left-FRectsinfo.MainRect.right;
              end;
          end;
      end;    
    end;
end;
procedure TIAeverMenuForm.SetRegion;
var
  R : HRGN;
begin
  R:=GetCurrentRegion;
  SetWindowRgn(Handle,R,TRUE);
end;
function TIAeverMenuForm.GetCurrentRegion: HRGN;
var i : integer;
    R1 : HRGN;
begin
  Result:=NULLREGION;
  case (FmyOwner as TIAeverMenu2).MenuKind of
    mkRects :
      begin
        Result:=CreateRectRGn(0,0,0,0);
        for i:=0 to length(FRectsinfo.Rects)-1 do
          begin
            R1:=CreateRectRGN(FRectsinfo.Rects[i].left,FRectsinfo.Rects[i].top-FCurrentPosition,
                              FRectsinfo.Rects[i].right,FRectsinfo.Rects[i].bottom-FCurrentPosition);
            CombineRGN(Result,Result,R1,RGN_OR);
            DeleteObject(R1);
          end;
        R1:=CreateRectRGN(FRectsinfo.BarRect.left,FRectsinfo.BarRect.top,
                          FRectsinfo.BarRect.right,FRectsinfo.BarRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FRectsinfo.ShowHiddenRect.left,FRectsinfo.ShowHiddenRect.top,
                          FRectsinfo.ShowHiddenRect.right,FRectsinfo.ShowHiddenRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FRectsinfo.HideHiddenRect.left,FRectsinfo.HideHiddenRect.top,
                          FRectsinfo.HideHiddenRect.right,FRectsinfo.HideHiddenRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FUpRect.left,FUpRect.top,
                          FUpRect.right,FUpRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
        R1:=CreateRectRGN(FDownRect.left,FDownRect.top,
                          FDownRect.right,FDownRect.bottom);
        CombineRGN(Result,Result,R1,RGN_OR);
        DeleteObject(R1);
      end;
    mkSimple,mkWide,mkSimpleCorner,mkWideCorner :
      begin
        Result:=CreateRectRGN(0,0,FRectsInfo.MainRect.Right,FRectsInfo.MainRect.Bottom);
      end;//simple
  end;
end;
procedure TIAeverMenuForm.CMOpening(var Message : TMessage);
begin
  sleep((FmyOwner as TIAeverMenu2).FramesDelay);
  (TIAeverMenuWindow2(Message.WParam)).OpeningWindow;
end;
procedure TIAeverMenuForm.CMClosing(var Message : TMessage);
begin
  sleep((FmyOwner as TIAeverMenu2).FramesDelay);
  (TIAeverMenuWindow2(Message.WParam)).ClosingWindow;
end;
procedure TIAeverMenuForm.WMSize(var Message : TMessage);
begin
  inherited;
    if (FmyOwner as TIAeverMenu2).semipercent>0 then
      begin
      //  GetSemi(width,height);
      end;
end;
procedure TIAeverMenuForm.GetSemi(Nw : integer =0;Nh : integer =0);
var TempBitmap : TBitmap;
    DC : HDC;
    WND : HWND;
    Nt,Nl : integer;
begin
  Nt:=top;Nl:=left;
  case FOrientation of
        poLeftRightTopBottom :
          begin
            if FHorizontal then
              begin
                Nt:=Frect.Bottom;Nl:=FRect.Left;
              end else
              begin
                Nt:=Frect.Top;Nl:=FRect.Right;
              end;
          end;
        poRightLeftTopBottom :
          begin
            if FHorizontal then
              begin
                Nt:=Frect.Bottom;Nl:=FRect.right-FRectsinfo.MainRect.right;
              end else
              begin
                Nt:=Frect.Top;Nl:=FRect.left-FRectsinfo.MainRect.right;
              end;
          end;
        poLeftRightBottomTop :
          begin
            if FHorizontal then
              begin
                Nt:=Frect.top-FRectsinfo.MainRect.bottom;Nl:=FRect.Left;
              end else
              begin
                Nt:=Frect.bottom-FRectsinfo.MainRect.bottom;Nl:=FRect.Right;
              end;
          end;
        poRightLeftBottomTop :
          begin
            if FHorizontal then
              begin
                Nt:=Frect.top-FRectsinfo.MainRect.bottom;Nl:=FRect.right-FRectsinfo.MainRect.right;
              end else
              begin
                Nt:=Frect.bottom-FRectsinfo.MainRect.bottom;Nl:=FRect.left-FRectsinfo.MainRect.right;
              end;
          end;
      end;
  TempBitmap:=TBitmap.Create;
  TempBitmap.Assign(FSemiBitmap);
  FSemiBitmap.Width:=Nw;
  FSemiBitmap.Height:=Nh;
  WND:=GetDesktopWindow;
  DC:=GetDC(WND);
  BitBLT(FSemiBitmap.canvas.handle,0,0,Nw,Nh,DC,Nl,Nt,SRCCOPY);
  FSemiBitmap.canvas.Draw(left-Nl,top-Nt,TempBitmap);
  ReleaseDC(WND,DC);
  TempBitmap.free;
end;
procedure TIAeverMenuForm.GetSemiBitmaps;
var i,j : integer;
    P1,P2 : PByteArray;
begin
  for i:=0 to height-1 do
    begin
      P1:=FMainBitmap.ScanLine[i];P2:=FSemiBitmap.ScanLine[i];
      for j:=0 to width*3-1 do
        begin
          P1[j]:=P1[j]+(P2[j]-P1[j])*(FmyOwner as TIAeverMenu2).semipercent div 100;
        end;
    end;
end;
//---------------------------
procedure TIAeverMenuForm.WMLBUTTONDOWN(var Message : TMessage);
var TrySelectNumber : integer;
    Point1 : TPoint;
    i : integer;
    ARect : TRect;
begin
  inherited;
  Point1:=Point(Message.LParamLo,Message.LParamHi);
 TrySelectNumber:=-10;

  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      ARect:=FRectsInfo.Rects[i];
      offsetRect(ARect,0,-FCurrentPosition);
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         ptinrect(ARect,Point1) then TrySelectNumber:=i;
    end;
  if ptinrect(FRectsInfo.ShowHiddenRect,Point1) then  TrySelectNumber:=-2;
  if ptinrect(FRectsInfo.HideHiddenRect,Point1) then  TrySelectNumber:=-1;

  if ptinrect(FUpRect,Point1) then  TrySelectNumber:=-3;
  if ptinrect(FDownRect,Point1) then  TrySelectNumber:=-4;
    
      FSelectedRectNumber:=TrySelectNumber;
      case TrySelectNumber of
        -10 : begin Unselect; end;
        -4 : begin
               TryUnselect;
               DownRectSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,TRUE,Rect(0,0,0,0),false);
             end;
        -3 : begin
               TryUnselect;
               UpRectSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,TRUE,Rect(0,0,0,0),false);
             end;     
        -2 : begin
               TryUnselect;
               OpenHiddenSelected:=true;
               FMenuContent.ShowHidden:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,TRUE,Rect(0,0,0,0),false);
             end;
        -1 : begin
               TryUnselect;
               CloseHiddenSelected:=true;
               FMenuContent.ShowHidden:=false;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,TRUE,Rect(0,0,0,0),false);
             end;
        else begin
               if not FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected then
               begin
                 TryUnselect;
                 if FSelectedRectNumber<=(length(FRectsInfo.Rects)-1) then
                   Begin
                     FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected:=True;
                     ARect:=FrectsInfo.Rects[FSelectedRectNumber];
                     offsetRect(ARect,Left,Top-FCurrentPosition);
                     (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                                    TRUE,ARect,false);
                   end;
               end else
               begin
                     ARect:=FrectsInfo.Rects[FSelectedRectNumber];
                     offsetRect(ARect,Left,Top-FCurrentPosition);
                    (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                              TRUE,ARect,TRUE);
                   end;
               end;

      end;
end;
procedure TIAeverMenuForm.WMLBUTTONDBLCLK(var Message : TMessage);
begin
  inherited;
  sendmessage(self.handle,WM_LBUTTONDOWN,Message.WParam,Message.LParam);
end;
procedure TIAeverMenuForm.WMMOUSEMOVE(var Message : TMessage);
begin
  inherited;
  if (not FTimed)  then
    begin
      FTimed:=TRUE;
      FTimer:=TTimer.Create(self);
      FTimer.OnTimer:=onFTimer;
      FTimer.Interval:=(FmyOwner as TIAeverMenu2).FDelayTime;
      FTimer.Enabled:=True;
    end;
end;
procedure TIAeverMenuForm.onFTimer(Sender: TObject);
var TrySelectNumber,i : integer;
    Point1 : TPoint;
    ARect : TRect;
begin
  FTimer.free;
  FTimer:=nil;
  FTimed:=false;

  Point1:=Point(Mouse.CursorPos.x-Left,Mouse.CursorPos.y-TOP);
  TrySelectNumber:=-10;

  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      ARect:=FRectsInfo.Rects[i];
      offsetRect(ARect,0,-FCurrentPosition);
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         ptinrect(ARect,Point1) then TrySelectNumber:=i;
    end;
  if ptinrect(FRectsInfo.ShowHiddenRect,Point1) then  TrySelectNumber:=-2;
  if ptinrect(FRectsInfo.HideHiddenRect,Point1) then  TrySelectNumber:=-1;

  if ptinrect(FUpRect,Point1) then  TrySelectNumber:=-3;
  if ptinrect(FDownRect,Point1) then  TrySelectNumber:=-4;
    
      FSelectedRectNumber:=TrySelectNumber;
      case TrySelectNumber of
        -10 : begin Unselect; end;
        -4 : begin
               TryUnselect;
               DownRectSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,false,Rect(0,0,0,0),false);
             end;
        -3 : begin
               TryUnselect;
               UpRectSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,false,Rect(0,0,0,0),false);
             end;     
        -2 : begin
               TryUnselect;
               OpenHiddenSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,false,Rect(0,0,0,0),false);
             end;
        -1 : begin
               TryUnselect;
               CloseHiddenSelected:=true;
               (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(nil,false,Rect(0,0,0,0),false);
             end;
        else begin
               if not FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected then
               begin
                 TryUnselect;
                 if FSelectedRectNumber<=(length(FRectsInfo.Rects)-1) then
                   Begin
                     FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]].selected:=True;
                     ARect:=FrectsInfo.Rects[FSelectedRectNumber];
                     offsetRect(ARect,Left,Top-FCurrentPosition);
                     (FmyOwner as TIAeverMenu2).ONSelectCurrentItem(FMenuContent.Items[FrectsInfo.Connected[FSelectedRectNumber]],
                                                                    false,ARect,false);
                   end;
               end;
             end;
      end;
end;
procedure TIAeverMenuForm.TryUnselect;
var i : integer;
begin
  if FSelectedRectNumber<>-4 then DownRectSelected:=false;
  if FSelectedRectNumber<>-3 then UpRectSelected:=false;
  if FSelectedRectNumber<>-2 then OpenHiddenSelected:=false;
  if FSelectedRectNumber<>-1 then CloseHiddenSelected:=false;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
         (FSelectedRectNumber<>i) and (FMenuContent.Items[FrectsInfo.Connected[i]].SubMenuList=nil) then
         FMenuContent.Items[FrectsInfo.Connected[i]].selected:=false;
    end;
end;
procedure TIAeverMenuForm.Unselect;
var i : integer;
begin
  DownRectSelected:=false;
  UpRectSelected:=false;
  OpenHiddenSelected:=false;
  CloseHiddenSelected:=false;
  for i:=0 to length(FRectsInfo.Rects)-1 do
    begin
      if (not(FMenuContent.Items[FrectsInfo.Connected[i]].grayed)) and
         (not(FMenuContent.Items[FrectsInfo.Connected[i]].splitter)) and
          (FMenuContent.Items[FrectsInfo.Connected[i]].SubMenuList=nil) then
         FMenuContent.Items[FrectsInfo.Connected[i]].selected:=false;
    end;
end;
function  TIAeverMenuForm.IsChanged: Boolean;
var i : integer;
    TempInfo : TIARectsInfo;
begin
  Tempinfo.MainRect:=FRectsInfo.MainRect;
  Tempinfo.ShowHiddenRect:=FRectsInfo.ShowHiddenRect;
  Tempinfo.HideHiddenRect:=FRectsInfo.HideHiddenRect;
  setlength(Tempinfo.Rects,length(FRectsInfo.rects));
  for i:=0 to length(FRectsInfo.rects)-1 do
    Tempinfo.Rects[i]:=FRectsInfo.rects[i];
  setlength(Tempinfo.Connected,length(FRectsInfo.Connected));
  for i:=0 to length(FRectsInfo.Connected)-1 do
    Tempinfo.Connected[i]:=FRectsInfo.Connected[i];
  GetRectsInfo;
  Result:=True;
  if Tempinfo.MainRect.Left<>FRectsInfo.MainRect.Left then Result:=false;
  if Tempinfo.MainRect.Top<>FRectsInfo.MainRect.Top then Result:=false;
  if Tempinfo.MainRect.Right<>FRectsInfo.MainRect.Right then Result:=false;
  if Tempinfo.MainRect.Bottom<>FRectsInfo.MainRect.Bottom then Result:=false;
  
  if Tempinfo.ShowHiddenRect.Left<>FRectsInfo.ShowHiddenRect.Left then Result:=false;
  if Tempinfo.ShowHiddenRect.Top<>FRectsInfo.ShowHiddenRect.Top then Result:=false;
  if Tempinfo.ShowHiddenRect.Right<>FRectsInfo.ShowHiddenRect.Right then Result:=false;
  if Tempinfo.ShowHiddenRect.Bottom<>FRectsInfo.ShowHiddenRect.Bottom then Result:=false;

  if Tempinfo.HideHiddenRect.Left<>FRectsInfo.HideHiddenRect.Left then Result:=false;
  if Tempinfo.HideHiddenRect.Top<>FRectsInfo.HideHiddenRect.Top then Result:=false;
  if Tempinfo.HideHiddenRect.Right<>FRectsInfo.HideHiddenRect.Right then Result:=false;
  if Tempinfo.HideHiddenRect.Bottom<>FRectsInfo.HideHiddenRect.Bottom then Result:=false;
  
  if length(FRectsInfo.rects)<>length(Tempinfo.rects) then Result:=false;
  for i:=0 to min(length(FRectsInfo.rects),length(Tempinfo.rects))-1 do
    begin
      if Tempinfo.Rects[i].Left<>FRectsInfo.rects[i].Left then Result:=false;
      if Tempinfo.Rects[i].Top<>FRectsInfo.rects[i].Top then Result:=false;
      if Tempinfo.Rects[i].Right<>FRectsInfo.rects[i].Right then Result:=false;
      if Tempinfo.Rects[i].Bottom<>FRectsInfo.rects[i].Bottom then Result:=false;
    end;  
  if length(FRectsInfo.Connected)<>length(Tempinfo.Connected) then Result:=false;
  for i:=0 to min(length(FRectsInfo.Connected),length(Tempinfo.Connected))-1 do
    begin
      if Tempinfo.Connected[i]<>FRectsInfo.Connected[i] then Result:=false;
    end;

end;
//--------------------------
//==========================
constructor TIAeverMainMenuSe.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.MenuType:=mtMain;
  self.MainMenuList.AddItem;
  self.MainMenuList[0].ItemName:='Menu Item';
  RecreateMenu;
end;
constructor TIAeverPopMenuSe.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  self.MainMenuList.AddItem;
  self.MainMenuList[0].ItemName:='Menu Item';
end;

//==========================
procedure Register;
begin
  RegisterComponents('TIA', [TIAeverMainMenuSe]);
  RegisterComponents('TIA', [TIAeverPopMenuSe]);
end;
end.
